
 /*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
*/

function _ZimbraFix(context) {
  function ZimbraFix() {}

  ZimbraFix._backuppedFcns = {};
  ZimbraFix.backupFcn = function(name, fcn) {
    ZimbraFix._backuppedFcns[name] = fcn;
  };
  context.ZimbraFix = ZimbraFix;

  /*
   * === Fix all the things \o/ ===
   */

  if ((typeof ZaItemList !== 'undefined' && typeof ZaItemList.prototype.loadEffectiveRights !== 'undefined') &&
      (ZxUtils.CompareZimbraVersion('8.0.7') < 0)) {
    /* Only up to Z 8.0.6 /o\
     see ZX-2576 for more informations.
     */
    ZimbraFix.backupFcn(
      'ZaItemList.prototype.loadEffectiveRights',
      ZaItemList.prototype.loadEffectiveRights
    );

    ZaItemList.prototype.loadEffectiveRights = function () {
      var arr = this.getArray();
      var cnt = arr.length;
      var soapDoc, params, resp;
      //batch the rest of the requests
      soapDoc = AjxSoapDoc.create('BatchRequest', 'urn:zimbra');
      soapDoc.setMethodAttribute('onerror', 'continue');

      for (var i = 0; i < cnt; i++) {
        if (arr[i].id && arr[i].loadEffectiveRights && arr[i].type && !arr[i].loadedRights &&
            (arr[i].type == ZaItem.ACCOUNT || arr[i].type == ZaItem.DL || arr[i].type == ZaItem.RESOURCE ||
              arr[i].type == ZaItem.DOMAIN || arr[i].type == ZaItem.COS || arr[i].type == ZaItem.ZIMLET ||
              arr[i].type == ZaItem.SERVER
            )
        ) {
          var getEffRightsDoc = soapDoc.set('GetEffectiveRightsRequest', null, null, ZaZimbraAdmin.URN);
          var elTarget = soapDoc.set('target', arr[i].id, getEffRightsDoc);
          elTarget.setAttribute('by', 'id');
          elTarget.setAttribute('type', arr[i].type);
          var elGrantee = soapDoc.set('grantee', ZaZimbraAdmin.currentUserId, getEffRightsDoc);
          elGrantee.setAttribute('by', 'id');
        } else if (arr[i].type == ZaItem.ALIAS && arr[i].attrs[ZaAlias.A_AliasTargetId]) {
          var getEffRightsDoc = soapDoc.set('GetEffectiveRightsRequest', null, null, ZaZimbraAdmin.URN);
          var elTarget = soapDoc.set('target', arr[i].attrs[ZaAlias.A_AliasTargetId], getEffRightsDoc);
          elTarget.setAttribute('by', 'id');
          elTarget.setAttribute('type', arr[i].attrs[ZaAlias.A_targetType]);
          var elGrantee = soapDoc.set('grantee', ZaZimbraAdmin.currentUserId, getEffRightsDoc);
          elGrantee.setAttribute('by', 'id');
        }
      }
      params = new Object();
      params.soapDoc = soapDoc;
      var reqMgrParams = {
        controller: ZaApp.getInstance().getCurrentController(),
        busyMsg: ZaMsg.BUSY_REQUESTING_ACCESS_RIGHTS
      };

      var respObj = ZaRequestMgr.invoke(params, reqMgrParams);
      if (respObj.isException && respObj.isException()) {
        ZaApp.getInstance().getCurrentController()._handleException(respObj.getException(), 'ZaItemList.prototype.loadEffectiveRights', null, false);
      } else if (respObj.Body.BatchResponse.Fault) {
        var fault = respObj.Body.BatchResponse.Fault;
        if (fault instanceof Array)
          fault = fault[0];

        if (fault) {
          // JS response with fault
          var ex = ZmCsfeCommand.faultToEx(fault);
          ZaApp.getInstance().getCurrentController()._handleException(ex, 'ZaItemList.prototype.loadEffectiveRights', null, false);
        }
      } else {
        var batchResp = respObj.Body.BatchResponse;
        if (batchResp.GetEffectiveRightsResponse && batchResp.GetEffectiveRightsResponse instanceof Array) {
          var cnt2 = batchResp.GetEffectiveRightsResponse.length;
          for (var i = 0; i < cnt2; i++) {
            resp = batchResp.GetEffectiveRightsResponse[i];
            var item = null;
            if (this instanceof ZaItemList) {
              item = this.getItemById(resp.target[0].id);
            }
            else if (this instanceof AjxVector) {
              var index = this.indexOfLike({id: resp.target[0].id}, function () {
                return this.id;
              });
              item = this.get(index);
            }
            if (!!item) {
              item.initEffectiveRightsFromJS(resp);
              item.loadedRights = true;
            }
          }
        }
      }
      this.loadedRights = true;
    };
  }

  if (typeof ZaDomainListController !== 'undefined' && typeof ZaDomainListController.prototype.searchCallback !== 'undefined' &&
      (ZxUtils.CompareZimbraVersion('8.7.0') <= 0)) {

    ZimbraFix.backupFcn(
      'ZaDomainListController.prototype.searchCallback',
      ZaDomainListController.prototype.searchCallback
    );

    ZaDomainListController.prototype.searchCallback = function (params, resp) {
      ZaListViewController.prototype.searchCallback.call(this, params, resp);
      var app = ZaApp.getInstance();
      app._domainList = this.getList();
      //app._domainNameList = undefined;
    };
  }

  //Firefox fix tab travel (each onkeypress attribute is converted to onkeydown)
  XFormItem.prototype.getKeyPressHandlerHTML = function () {
    var keydownEv = "onkeydown";
    return AjxBuffer.concat(" ", keydownEv, "=\"", this.getGlobalRef(), ".handleKeyDown(event, this)\"",
      " onkeyup=\"", this.getGlobalRef(), ".handleKeyUp(event, this)\"");
  };

  Textarea_XFormItem.prototype.getKeyPressHandlerHTML = function () {
    var keydownEv = "onkeydown";
    return AjxBuffer.concat(" ", keydownEv, "=\"", this.getGlobalRef(), ".handleKeyDown(event, this)\"",
      " onkeyup=\"", this.getGlobalRef(), ".handleKeyUp(event, this)\"");
  };

  if (AjxEnv.isFirefox) {
    var _originalFunction = DynSelect_XFormItem.prototype.outputHTML;

    DynSelect_XFormItem.prototype.outputHTML = function (HTMLoutput) {
      AjxEnv.isFirefox = false;
      _originalFunction.call(this, HTMLoutput);
      AjxEnv.isFirefox = true;
    }
  }
}
_ZimbraFix(this);
