/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxStatsButton() {}

ZxStatsButton._initPopupMenu = function() {
  var op = new ZaOperation(ZaOperation.ZE_SHOW_USER_STATS,
    zxMsg('LBL_COR_statistics'),
    zxMsg('LBL_COR_show_user_statistics'),
    'ZxStats', 'ZxStats',
    new AjxListener(this, ZxStatsButton._showAccountStats));

  this._popupOperations[ZaOperation.ZE_SHOW_USER_STATS] = op;
};

ZxStatsButton._initExtraToolbar = function() {
  ZaOperation.ZE_SHOW_USER_STATS = ++ZA_OP_INDEX;
  var op = new ZaOperation(ZaOperation.ZE_SHOW_USER_STATS,
    zxMsg('LBL_COR_statistics'),
    zxMsg('LBL_COR_show_user_statistics'),
    'ZxStats', 'ZxStats',
    new AjxListener(this, ZxStatsButton._showAccountStats));

  this._toolbarOperations[ZaOperation.ZE_SHOW_USER_STATS] = op;
  this._toolbarOrder.push(ZaOperation.ZE_SHOW_USER_STATS);
};

ZxStatsButton._showAccountStats = function(ev) {
  var controller = ZaApp.getInstance().getCurrentController(),
    item = controller._currentObject,
    userId = item.attrs[ZaItem.A_zimbraId],
    server_addrs = item.attrs[ZaAccount.A_mailHost];

  ZxAdminRequest.sendRequest(
    server_addrs,
    'ZxCore',
    'getAccountStats',
    {account: userId}
  ).then(
    AjxCallback.simpleClosure(
      function(controller, resp) {
        var dialog,
          stats = resp.response;
        stats.total = (
          stats.chatCount + stats.contactCount + stats.conversationCount + stats.documentCount +
            stats.folderCount + stats.messageStats.total + stats.mountPointCount + stats.noteCount +
            stats.searchFolderCount + stats.systemFolders + stats.tagCount + stats.taskCount +
            stats.virtualConversationCount + stats.wikiCount
        );
        if (!ZxUtils.isZ8Up()) { stats.total += stats.appointmentCount; }  // Not present in zimbra 8

        dialog = new ZxStatsDialog(
          controller._shell,
          320,
          160,
          zxMsg('LBL_COR_account_statistics'),
          stats
        );

        dialog.registerCallback(
          DwtDialog.OK_BUTTON,
          function() {
            dialog.popdown();
          }
        );
        dialog.popup();
      },
      this,
      controller
    ),
    ZxUtils.catchError
  );

};

ZxStatsButton.view = function() {
  ZaOperation.ZE_SHOW_USER_STATS = ++ZA_OP_INDEX;

  if (ZxUtils.isZ8Up()) {
    ZaController.initPopupMenuMethods.ZaAccountViewController.push(
      ZxStatsButton._initPopupMenu
    );

  } else {

    ZaController.initToolbarMethods.ZaAccountViewController.push(
      ZxStatsButton._initExtraToolbar
    );
  }
};

ZxStatsButton.view();
