/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxStatsDialog(parent, w, h, title, params) {
  if (arguments.length === 0) { return; }
  this._standardButtons = [DwtDialog.OK_BUTTON];
  ZaXDialog.call(this, parent, null, title, w, h, null, null);
  this.initForm(ZxStatsDialog.MODEL, this.getMyXForm());
  this.setObject(params);
  this._helpURL = ZxLinks.HELP_COR_Stats_dialog;
}

ZxStatsDialog.prototype = new ZaXDialog();
ZxStatsDialog.prototype.constructor = ZxStatsDialog;

ZxStatsDialog.MODEL = [
  {type: _NUMBER_, ref: 'total'},
  {type: _NUMBER_, ref: 'messageStats/total'},
  {type: _NUMBER_, ref: 'messageStats/trash'},
  {type: _NUMBER_, ref: 'messageStats/spam'},
  {type: _NUMBER_, ref: 'chatCount'},
  {type: _NUMBER_, ref: 'conversationCount'},
  {type: _NUMBER_, ref: 'contactCount'},
  {type: _NUMBER_, ref: 'appointmentCount'},
  {type: _NUMBER_, ref: 'folderCount'},
  {type: _NUMBER_, ref: 'documentCount'},
  {type: _NUMBER_, ref: 'noteCount'},
  {type: _NUMBER_, ref: 'taskCount'},
  {type: _NUMBER_, ref: 'tagCount'},
  {type: _NUMBER_, ref: 'mountPointCount'},
  {type: _NUMBER_, ref: 'searchFolderCount'},
  {type: _NUMBER_, ref: 'virtualConversationCount'},
  {type: _NUMBER_, ref: 'wikiCount'}
];

ZxStatsDialog.prototype.getMyXForm = function() {
  var xFormObject = {
    numCols: 2,
    colSizes: ['50%', '50%'],
    items: [
      {
        type: _GROUP_,
        numCols: 2,
        valign: _TOP_,
        colSizes: [120, 40],
        items: [
          {type: _OUTPUT_, ref: 'total',
            label: zxMsg('LBL_COR_stat_total_object')},
          {type: _OUTPUT_, label: '', value: ''},
          {type: _OUTPUT_, ref: 'messageStats/total',
            label: zxMsg('LBL_COR_stat_total_messages')},
          {type: _OUTPUT_, ref: 'messageStats/trash',
            label: zxMsg('LBL_COR_stat_trash_messages')},
          {type: _OUTPUT_, ref: 'messageStats/spam',
            label: zxMsg('LBL_COR_stat_spam_messages')},
          {type: _OUTPUT_, ref: 'chatCount',
            label: zxMsg('LBL_COR_stat_chats')},
          {type: _OUTPUT_, ref: 'conversationCount',
            label: zxMsg('LBL_COR_stat_conversations')},
          {type: _OUTPUT_, ref: 'contactCount',
            label: zxMsg('LBL_COR_stat_contacts')},
          {type: _OUTPUT_, ref: 'appointmentCount',
            label: zxMsg('LBL_COR_stat_appointments')}
        ]
      },
      {
        type: _GROUP_,
        numCols: 2,
        valign: _TOP_,
        colSizes: [120, 40],
        items: [
          {type: _OUTPUT_, ref: 'folderCount',
            label: zxMsg('LBL_COR_stat_folders')},
          {type: _OUTPUT_, ref: 'documentCount',
            label: zxMsg('LBL_COR_stat_documents')},
          {type: _OUTPUT_, ref: 'noteCount',
            label: zxMsg('LBL_COR_stat_notes')},
          {type: _OUTPUT_, ref: 'taskCount',
            label: zxMsg('LBL_COR_stat_tasks')},
          {type: _OUTPUT_, ref: 'tagCount',
            label: zxMsg('LBL_COR_stat_tags')},
          {type: _OUTPUT_, ref: 'mountPointCount',
            label: zxMsg('LBL_COR_stat_mount_points')},
          {type: _OUTPUT_, ref: 'searchFolderCount',
            label: zxMsg('LBL_COR_stat_search_folders')},
          {type: _OUTPUT_, ref: 'virtualConversationCount',
            label: zxMsg('LBL_COR_stat_virtual_conversations')},
          {type: _OUTPUT_, ref: 'wikiCount',
            label: zxMsg('LBL_COR_stat_wikis')}
        ]
      }
    ]
  };
  return xFormObject;
};
