/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

/**
 * Container object for ALL links used into ZeXtras Interface.
 * @constructor
 */
function ZxLinks() {}

ZxLinks.MainSite = 'http://www.zextras.com/';

ZxLinks.Download = ZxLinks.MainSite + 'download';

/**
 * Main Link to ZeXtras Store
 * @type {string}
 */
ZxLinks.Store = 'https://store.zextras.com/';

/**
 * Main Link to ZeXtras Wiki
 * @type {string}
 */
ZxLinks.Wiki = 'http://wiki.zextras.com/wiki/';

ZxLinks.Forum = 'http://forums.zextras.com';

ZxLinks.Support = 'http://support.zextras.com/';

ZxLinks.MSG_Module_Disabled_on_NE = ZxLinks.Wiki + 'Running_ZeXtras_Suite_on_Zimbra_Network_Edition';

ZxLinks.MSG_Mobile_Device_Management = ZxLinks.Wiki + 'Zx_Mobile_Mobile_Device_Management_(a.k.a_Provisioning)';

/**
 * Used in the Admin module as main help link on the module page.
 * @type {string}
 */
ZxLinks.HELP_DLG_Admin = ZxLinks.Wiki + 'ZxAdmin';

/**
 * @type {string}
 */
ZxLinks.HELP_DLG_Dialog_ResetSettings = ZxLinks.Wiki + 'ZxAdmin_Configuration_Reset';

ZxLinks.HELP_DLG_Dialog_Reset_Domain_Settings = ZxLinks.Wiki + 'ZxAdmin_Domain_Limits#Reset_the_limits_of_a_Domain';

ZxLinks.HELP_DLG_Dialog_Edit_Domain_Settings = ZxLinks.Wiki + 'ZxAdmin_Domain_Limits#Edit_the_limits_of_a_Domain';

ZxLinks.HELP_DLG_Dialog_Browse_log = ZxLinks.Wiki + 'ZxAdminDomain_Admin_Log_Browsing';

ZxLinks.HELP_DLG_Dialog_Change_log_path = ZxLinks.Wiki + 'ZxAdmin_Reports_and_Informations#Changing_The_ZxAdmin_Log_Path';

ZxLinks.HELP_DLG_Change_log_path_changed = ZxLinks.Wiki + 'ZxAdmin_Reports_and_Informations#Changing_The_ZxAdmin_Log_Path';

ZxLinks.HELP_DLG_Admin_provisioning = ZxLinks.Wiki + 'ZxAdmin_Delegated_Admin_Provisioning';

ZxLinks.HELP_DLG_Admin_provisioning_remove_cos = ZxLinks.Wiki + 'ZxAdmin_Delegated_Admin_Provisioning';

ZxLinks.HELP_DLG_Delete_delegated_admin = ZxLinks.Wiki + 'ZxAdmin_Delegated_Admin_Provisioning#From_the_ZeXtras_Administration_Zimlet_3';

ZxLinks.HELP_DLG_Add_delegated_admin = ZxLinks.Wiki + 'ZxAdmin_Delegated_Admin_Provisioning#From_the_ZeXtras_Administration_Zimlet';

ZxLinks.HELP_DLG_Modify_delegated_admin = ZxLinks.Wiki + 'ZxAdmin_Delegated_Admin_Provisioning#From_the_ZeXtras_Administration_Zimlet_2';

ZxLinks.HELP_DLG_About_Reports = ZxLinks.Wiki + 'ZxAdmin_Reports_and_Informations';

ZxLinks.HELP_DLG_About_Browse_Logs = ZxLinks.Wiki + 'ZxAdminDomain_Admin_Log_Browsing';

/**
 * Used in the Backup module as main help link on the module page.
 * @type {string}
 */
ZxLinks.HELP_BCK_Backup = ZxLinks.Wiki + 'ZxBackup';

/**
 * Used in the help button of the import wizard of the backup module.
 * @type {string}
 */
ZxLinks.HELP_BCK_Export_wizard = ZxLinks.Wiki + 'Zx_Backup_ExternalBackup';

/**
 * Used in the help button of the export wizard of the backup module.
 * @type {string}
 */
ZxLinks.HELP_BCK_Import_wizard = ZxLinks.Wiki + 'Zx_Backup_ExternalRestore';

/**
 * Used in the help button of the restore wizard of the backup module.
 * @type {string}
 */
ZxLinks.HELP_BCK_Restore_wizard = ZxLinks.Wiki + 'ZxBackup_Admin_Guide#Restore';

ZxLinks.HELP_BCK_User_tab_info = ZxLinks.Wiki + 'ZxBackup_COS-level_Backup_Management';

/**
 * @type {string}
 */
ZxLinks.BCK_Case_insensitive_info = ZxLinks.Wiki + 'ZxBackup_Store/Case_Sensitive_filesystem_for_ZeXtras_Backup';
/**
 * @type {string}
 */

ZxLinks.BCK_BackupFirstInitialization = ZxLinks.Wiki + 'ZxBackup:_Initialization';
/**
 * @type {string}
 */
ZxLinks.BCK_BackupNotAvailable = ZxLinks.Wiki + 'ZxBackup:_Initialization#.22ZeXtras_Backup_is_not_initialized.22';

/**
 * Used in the Chat module as main help link on the module page.
 * @type {string}
 */
ZxLinks.HELP_CHT_Chat = ZxLinks.Wiki + 'ZxChat';

/**
 * @type {string}
 */
ZxLinks.HELP_CHT_Dialog_Deploy_Zimlet = ZxLinks.Wiki + 'ZxChat_Zimlet_Install_Guide';

/**
 * @type {string}
 */
ZxLinks.CHT_Installation_Zimlet_Guide = ZxLinks.Wiki + 'ZxChat_Zimlet_Install_Guide';

/**
 * Used in the Core module as main help link on the module page.
 * @type {string}
 */
ZxLinks.HELP_COR_Core = ZxLinks.Wiki + 'License_Management';

/**
 * @type {string}
 */
ZxLinks.HELP_COR_Dialog_CheckUpdate = ZxLinks.Wiki + 'Changelog';

/**
 * @type {string}
 */
ZxLinks.HELP_COR_Dialog_CheckUpdate_Troubleshooting = ZxLinks.Wiki + 'CheckUpdate_Troubleshooting';

/**
 * @type {string}
 */
ZxLinks.HELP_COR_Dialog_ContactForLicense = ZxLinks.Wiki + 'License_Management';

/**
 * @type {string}
 */
ZxLinks.COR_Download_ZeXtras_for_Zimbra = ZxLinks.Download;

/**
 * @type {string}
 */
ZxLinks.COR_License_how_work = ZxLinks.Wiki + 'License_Management#How_ZeXtras_Suite_Licensing_works';

/**
 * @type {string}
 */
ZxLinks.COR_License_Management_info = ZxLinks.Wiki + 'License_Management';

/**
 * Used in the help button of Stats dialog of the ZxFreeTools
 * @type {string}
 */
ZxLinks.HELP_COR_Stats_dialog = ZxLinks.Wiki + 'License_Management';

/**
 * Used in the Powerstore module as main help link on the module page.
 * @type {string}
 */
ZxLinks.HELP_HSM_Powerstore = ZxLinks.Wiki + 'ZxPowerStore_Admin_Guide';

/**
 * Used in the help button of the "Add/Modify HSM" dialog of the powerstore module.
 * @type {string}
 */
ZxLinks.HELP_HSM_Dialog_AddModify_HSM = ZxLinks.Wiki + 'ZxPowerstore:_Hierarchical_Storage_Management';

/**
 * Used in the help button of the "Add/Modify Volume" dialog of the powerstore module.
 * @type {string}
 */
ZxLinks.HELP_HSM_Dialog_AddModify_Volume = ZxLinks.Wiki + 'ZxPowerstore:_Volume_Management';
ZxLinks.HELP_HSM_Dialog_AddModify_S3_Volume = ZxLinks.Wiki + 'Zextras_Powerstore:_Secondary_volumes_on_Amazon_S3';

/**
 * Used in the help button of the "Stats" dialog of the powerstore module.
 * @type {string}
 */
ZxLinks.HELP_HSM_Dialog_Stats = ZxLinks.Wiki + 'ZxPowerstore:_doMoveBlobs#doMoveBlobs_Stats_and_Info';

/**
 * Used in the Migration Tool module as main help link on the module page.
 * @type {string}
 */
ZxLinks.HELP_MIG_MigrationTool = ZxLinks.Wiki + 'Migrate_Zimbra';

ZxLinks.INFO_MIG_Preparation = ZxLinks.Wiki + 'ZeXtras_Migration_Tool_Guide#Preparing_the_migration';

ZxLinks.INFO_MIG_Toolguide = ZxLinks.Wiki + 'ZeXtras_Migration_Tool_Guide';

ZxLinks.HELP_MIG_Export_wizard = ZxLinks.Wiki + 'Zx_Backup:_Migration_Tool_Export';

/**
 * Used in the Mobile module as main help link on the module page.
 * @type {string}
 */
ZxLinks.HELP_MOB_Mobile = ZxLinks.Wiki + 'ZxMobile';

ZxLinks.HELP_MOB_Settings = ZxLinks.Wiki + 'Zx_Mobile_Advanced_Settings';

ZxLinks.HELP_MOB_Remove_device = ZxLinks.Wiki + 'Zx_Mobile_SyncStates#Remove_Device';

ZxLinks.HELP_MOB_Reset_device = ZxLinks.Wiki + 'Zx_Mobile_SyncStates#Reset_Device';

ZxLinks.HELP_MOB_Device_Password = ZxLinks.Wiki + 'Zx_Mobile_The_Mobile_Password_feature';

/**
 * Used in the Notifications module as main help link on the module page.
 * @type {string}
 */
ZxLinks.HELP_NOT_Notifications = ZxLinks.Wiki + 'Main_Page';

/**
 * @type {string}
 */
ZxLinks.HELP_NOT_Dialog_OpInfo = ZxLinks.Wiki + 'ZxBackup:_Operation_queue_and_queue_management#Operation_Queue_Management';

/**
 * @type {string}
 */
ZxLinks.HELP_NOT_Dialog_OpQueue = ZxLinks.Wiki + 'ZxBackup:_Operation_queue_and_queue_management#ZeXtras_Backup.27s_Operation_Queue';

ZxLinks.MOB_INFO_SETUP = ZxLinks.Wiki + 'ZxMobile_Admin_Guide#Configuration';

ZxLinks.HELP_Installation_guide = ZxLinks.Wiki + 'ZeXtras_Suite_Installation_Guide';

ZxLinks.HELP_ACL = ZxLinks.Wiki + 'Delegated_Authority_Settings';
ZxLinks.HELP_ACL_Dialog_edit_new = ZxLinks.Wiki + 'Delegated_Authority_Settings';
ZxLinks.HELP_ACL_Alias = ZxLinks.Wiki + 'Delegated_Authority_Settings#Delegated_Authority_and_mail_aliases';

ZxLinks.CHANGELOG = ZxLinks.Wiki + 'Changelog';

ZxLinks.DOS_FILTER = ZxLinks.Wiki + 'ZeXtras_Suite_and_the_Zimbra_DoSFilter';

ZxLinks.HELP_Privacy_Policy = ZxLinks.Wiki + 'How_to_report_a_ZeXtras_Suite_issue#Help_us_improve_ZeXtras_Suite';

ZxLinks.HELP_CLN_about_client_zimlet = ZxLinks.Wiki + 'ZeXtras_Client_Zimlet';
