/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxServersListController(appCtxt, container, id, module) {
  ZaListViewController.call(this, appCtxt, container, id);

  this.module = module;
}

ZxServersListController.prototype = new ZaListViewController();
ZxServersListController.prototype.constructor = ZxServersListController;

//ZxServersListController.prototype.set = function(serverList) {
//  this.show(serverList);
//};

ZxServersListController.prototype.show = function(openInNewTab) {
//  if (!this._UICreated) {
//  Force to recreate the view every time
    this._createUI();
//  }

  this._list = ZaApp.getInstance().getMbsList();
  this._contentView.set(this._list.getVector());

  ZaApp.getInstance().pushView(this.getContentViewId());
};

ZxServersListController.prototype._createUI = function(openInNewTab, skipRefresh) {
  var elements = {};
  this._contentView = this._view = new ZxServersListView(this._container, this);
  elements[ZaAppViewMgr.C_APP_CONTENT] = this._contentView;
  ZaApp.getInstance().getAppViewMgr().createView(this.getContentViewId(), elements);
  this._contentView.addSelectionListener(new AjxListener(this, this._listSelectionListener));
  this._UICreated = true;
  ZaApp.getInstance()._controllers[this.getContentViewId()] = this;
};

/**
 * If are shown the server list view, handle a click on an item.
 * @param {DwtSelectionEvent} ev
 */
ZxServersListController.prototype._listSelectionListener = function(ev) {
  if (ev.detail === DwtListView.ITEM_DBL_CLICKED) {
    if (ev.item) {
      var item = ZeXtras.getModuleItem(this.module, ev.item.name);
      if (!item) {
        throw new Error('ZeXtras Module Item not found.');
      }
      if (ZeXtras.isServerOnline(item.getServerName()) && item.isServerSameZxVersion() && item.isZxInstalled()) {
        item.switchToNextView(ev.item);
      }
    }
  }
};

ZxServersListController.prototype.getModule = function() {
  return this.module;
};
