/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

/**
 * Waring dialog to warn the user to set the DoS Filter properly.
 * @constructor
 */
function ZxDoSFilterWarningDialog() {
  DwtMessageDialog.call(this, ZaApp.getInstance().getAppCtxt().getShell());

  this.setMessage(
    zxMsg(
      'MSG_DOSFILTER_info',
      ['<a href="' + ZxLinks.DOS_FILTER + '" target="_blank">', '</a>']
    ),
    DwtMessageDialog.WARNING_STYLE,
    ZxUtils.getTitleWithIcon('ZeXtras', zxMsg('LBL_DOSFILTER'))
  );

  if (!ZxDoSFilterWarningDialog.SHOWN) {
    ZxDoSFilterWarningDialog.SHOWN = true;
    this.popup();
  }
}

ZxDoSFilterWarningDialog.prototype = new DwtMessageDialog();
ZxDoSFilterWarningDialog.prototype.constructor = ZxDoSFilterWarningDialog;

/**
 * Show the dialog only once.
 * @type {boolean}
 */
ZxDoSFilterWarningDialog.SHOWN = false;
