/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

/**
 *
 * @param {ZxError} error
 * @param {String=} server
 * @constructor
 */
function ZxErrorDialog(error, server) {
  ZaErrorDialog.call(this, ZaApp.getInstance().getAppCtxt().getShell());

  var errorTitle;

  if (server) {
    errorTitle = ZxUtils.getTitleWithIcon('ZeXtras', zxMsg('LBL_Error_on_server', [server]));
  } else {
    errorTitle = ZxUtils.getTitleWithIcon('ZeXtras', zxMsg('LBL_Error'));
  }

  this.setMessage(
    error.message,
    error.toString(),
    DwtMessageDialog.CRITICAL_STYLE,
    errorTitle
  );

  this.popup();
}

ZxErrorDialog.prototype = new ZaErrorDialog();
ZxErrorDialog.prototype.constructor = ZxErrorDialog;

