// Generated by CoffeeScript 1.10.0
var ZxError, exports,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

ZxError = (function(superClass) {
  extend(ZxError, superClass);

  ZxError.CLIENT_ERRORS = [];

  ZxError.KEY_CODE = "code";

  ZxError.KEY_DETAILS = "details";

  ZxError.KEY_MESSAGE = "message";

  ZxError.KEY_STACKTRACE = "stackTrace";

  ZxError.KEY_CAUSE = "cause";

  ZxError.KEY_ERROR_TIME = "time";

  function ZxError(code, cause) {
    if ((code == null) && (cause == null)) {
      ZxError.__super__.constructor.call(this, ZxErrorCode.UNKNOWN_JS_EXCEPTION);
      return;
    }
    if (typeof code === "string") {
      if ((typeof ZxErrorCode !== "undefined" && ZxErrorCode !== null) && !ZxErrorCode.hasOwnProperty(code)) {
        code = ZxErrorCode.GENERIC_ERROR;
      }
    } else if (code instanceof Error || code instanceof AjxException) {
      cause = code;
      code = ZxErrorCode.UNKNOWN_JS_EXCEPTION;
    } else {
      throw new TypeError("Unknown Error type");
    }
    ZxError.__super__.constructor.call(this, code);
    this.name = "ZxError";
    this._code = code;
    this._createStackTrace(this.trace);
    this._time = new Date().getTime();
    this._isException = false;
    this._cause = null;
    this._exception = null;
    this._details = {};
    this._message = code;
    this._dumpedObjects = {};
    if (typeof ZxErrorCode !== "undefined" && ZxErrorCode !== null) {
      this._message = ZxErrorCode.getMessage(code);
    }
    if (cause instanceof AjxException) {
      this.setDetail("details", cause.msg);
    } else if (cause instanceof ZxError) {

    } else if (cause instanceof Error) {
      this.setDetail("details", cause.message);
    }
    if (cause != null) {
      this.initCause(cause);
    }
    ZxError.CLIENT_ERRORS.push(this);
    if (typeof ZxUtils !== "undefined" && ZxUtils !== null) {
      ZxUtils.log(this.toString('\n'), "ZxError code: " + this._code, ZxUtils.LOG_ERROR);
    }
  }

  ZxError.prototype.toJSON = function() {
    var i, len, obj, ref, trace, traceEl;
    obj = {};
    obj[ZxError.KEY_CODE] = this._code;
    obj[ZxError.KEY_MESSAGE] = this._message;
    obj[ZxError.KEY_ERROR_TIME] = this._time;
    obj[ZxError.KEY_DETAILS] = this._details;
    trace = [];
    ref = this._trace;
    for (i = 0, len = ref.length; i < len; i++) {
      traceEl = ref[i];
      trace.push({
        className: traceEl.className,
        fileName: traceEl.fileName,
        lineNumber: traceEl.lineNumber,
        methodName: traceEl.methodName,
        nativeMethod: traceEl.nativeMethod
      });
    }
    obj[ZxError.KEY_STACKTRACE] = trace;
    if (this._cause != null) {
      obj[ZxError.KEY_CAUSE] = this._cause.toJSON();
    } else {
      obj[ZxError.KEY_CAUSE] = null;
    }
    return obj;
  };

  ZxError.prototype.initCause = function(cause) {
    if (cause instanceof ZxError) {
      this._cause = cause;
    } else if (cause instanceof AjxException) {
      this._cause = ZxError.convertError(cause);
    } else if (cause instanceof Error) {
      this._cause = ZxError.convertError(cause);
    }
    return this;
  };

  ZxError.prototype._setMessage = function(message) {
    this._message = message;
    return this;
  };

  ZxError.prototype.getMessage = function(br) {
    var key, message, ref, value;
    if (br == null) {
      br = "<br>";
    }
    message = this._message;
    ref = this._details;
    for (key in ref) {
      if (!hasProp.call(ref, key)) continue;
      value = ref[key];
      message = message.replace("{" + key + "}", value);
    }
    return message.replace(/\n/mg, br);
  };

  ZxError.prototype.setCode = function(code) {
    if (typeof ZxErrorCode !== "undefined" && ZxErrorCode !== null) {
      if (!ZxErrorCode.hasOwnProperty(code)) {
        code = ZxErrorCode.UNKNOWN_ERROR;
      }
    }
    this._code = code;
    if ((typeof ZxErrorCode !== "undefined" && ZxErrorCode !== null) && (ZxErrorCode.getMessage(code) != null)) {
      this._message = ZxErrorCode.getMessage(code);
    }
    return this;
  };

  ZxError.prototype.getCode = function() {
    return this._code;
  };

  ZxError.prototype.setDetails = function(details) {
    this._details = details;
    return this;
  };

  ZxError.prototype.setDetail = function(key, value) {
    this._details[key] = value;
    return this;
  };

  ZxError.prototype.getDetail = function(key) {
    return this._details[key];
  };

  ZxError.prototype.setException = function(ex) {
    this._exception = ex;
    return this;
  };

  ZxError.prototype.getException = function() {
    return this._exception;
  };

  ZxError.prototype.isException = function() {
    return this._isException;
  };

  ZxError.prototype.isError = function() {
    return !this._isException;
  };

  ZxError.prototype.setIsException = function() {
    this._isException = true;
    return this;
  };

  ZxError.prototype.setIsError = function() {
    this._isException = false;
    return this;
  };

  ZxError.prototype.setStackTrace = function(trace) {
    this._trace = trace;
    return this;
  };

  ZxError.prototype.getStackTrace = function() {
    return this._trace;
  };

  ZxError.prototype.setTime = function(time) {
    this._time = time;
    return this;
  };

  ZxError.prototype.getTime = function() {
    return this._time;
  };

  ZxError.prototype.getCause = function() {
    return this._cause;
  };

  ZxError.prototype.attachDump = function(tag, object) {
    this._dumpedObjects[tag] = ZxUtils.cloneObj(object);
    return this;
  };

  ZxError.prototype.getAttachedDumps = function() {
    return this._dumpedObjects;
  };

  ZxError.fromResponse = function(resp) {
    var cause, error;
    error = new ZxError();
    if ((resp != null) && (resp.error != null)) {
      if (typeof resp.error === "string") {
        resp.error = JSON.parse(resp.error);
      }
      error.setIsError();
      error.setCode(resp.error[ZxError.KEY_CODE]);
      error._setMessage(resp.error[ZxError.KEY_MESSAGE]);
      error.setDetails(resp.error[ZxError.KEY_DETAILS]);
      error.setStackTrace(resp.error[ZxError.KEY_STACKTRACE]);
      if (resp.error != null) {
        cause = ZxError.convertError(resp.error);
        if (cause != null) {
          cause.setIsError();
          error = cause;
        }
      }
    }
    if ((resp != null) && (resp.exception != null)) {
      if (typeof resp.exception === "string") {
        resp.exception = JSON.parse(resp.exception);
      }
      error.setIsException();
      error.setCode(resp.exception[ZxError.KEY_CODE]);
      error.setDetails(resp.exception[ZxError.KEY_DETAILS]);
      error.setStackTrace(resp.exception[ZxError.KEY_STACKTRACE]);
      if (resp.exception != null) {
        cause = ZxError.convertError(resp.exception);
        if (cause != null) {
          cause.setIsException();
          error = cause;
        }
      }
    }
    return error;
  };

  ZxError.convertError = function(error) {
    var converted;
    if (error instanceof ZxError) {
      converted = error;
    } else if (error instanceof Error) {
      converted = new ZxError(ZxErrorCode.UNKNOWN_JS_EXCEPTION);
      converted.setDetails({
        details: error.message
      });
    } else if (error instanceof AjxException) {
      converted = new ZxError(ZxErrorCode.AJX_EXCEPTION);
      converted.setDetails({
        details: error.msg
      });
    } else if (typeof error === 'object') {
      converted = new ZxError();
      if (error[ZxError.KEY_CODE] != null) {
        converted.setCode(error[ZxError.KEY_CODE]);
      }
      if (error[ZxError.KEY_MESSAGE] != null) {
        converted._setMessage(error[ZxError.KEY_MESSAGE]);
      }
      if (error[ZxError.KEY_DETAILS] != null) {
        converted.setDetails(error[ZxError.KEY_DETAILS]);
      }
      if (error[ZxError.KEY_STACKTRACE] != null) {
        converted.setStackTrace(error[ZxError.KEY_STACKTRACE]);
      }
      if (error[ZxError.KEY_CAUSE] != null) {
        converted.initCause(ZxError.convertError(error[ZxError.KEY_CAUSE]));
      }
      if (error[ZxError.KEY_ERROR_TIME] != null) {
        converted.setTime(error[ZxError.KEY_ERROR_TIME]);
      } else {
        converted.setTime(new Date().getTime());
      }
    }
    return converted;
  };

  ZxError.prototype.toString = function(br) {
    var buffer, i, len, nativeStr, ref, row;
    if (br == null) {
      br = "<br>";
    }
    buffer = [];
    buffer.push("" + (this.getMessage()) + br);
    ref = this.getStackTrace();
    for (i = 0, len = ref.length; i < len; i++) {
      row = ref[i];
      nativeStr = row.nativeMethod ? " [native]" : "";
      buffer.push("        at " + row.className + "." + row.methodName + " ( " + row.fileName + ":" + row.lineNumber + " )" + nativeStr + br);
    }
    if (this.getCause() != null) {
      buffer.push(this.getCause().toString(br), br);
    }
    return buffer.join("");
  };

  ZxError.prototype._createStackTrace = function(error) {
    var i, len, match, oneMatch, regex, stackElement, stackStrings;
    this._trace = [];
    if (error instanceof ZxError) {
      if ((error.getStackTrace() != null) && error.getStackTrace().length === 0) {
        this._trace[0] = {
          fileName: 'UnknownFile',
          lineNumber: '0',
          className: 'Unknown',
          methodName: 'Unknown',
          nativeMethod: false
        };
      } else {
        this._trace = error.getStackTrace();
      }
    } else if (error instanceof Error || error instanceof AjxException || typeof error === 'string' || typeof error === 'undefined') {
      stackStrings = printStackTrace(error);
      stackStrings.splice(0, 5);
      match = [stackStrings.length];
      regex = XRegExp('(?:(?<ClassName>[^ ]+)\\.)?' + '(?<Method>[^@]+)' + '@[^ ]+\\/' + '(?<FileName>[^ ]+)' + '\\?[^ :]+:' + '(?<Line>\\d+)', 'x');
      for (i = 0, len = stackStrings.length; i < len; i++) {
        oneMatch = stackStrings[i];
        match = XRegExp.exec(oneMatch, regex) || [];
        if (match.length >= 4) {
          stackElement = {};
          stackElement.fileName = match.FileName || 'UnknownFile';
          stackElement.lineNumber = match.Line || '0';
          stackElement.className = match.ClassName || 'Unknown';
          stackElement.methodName = match.Method || 'Unknown';
          stackElement.nativeMethod = false;
          this._trace.push(stackElement);
        }
      }
      if (stackStrings.length === 0) {
        this._trace[0] = {
          fileName: 'UnknownFile',
          lineNumber: '0',
          className: 'Unknown',
          methodName: 'Unknown',
          nativeMethod: false
        };
      }
    }
    return this;
  };

  ZxError.exportClientErrors = function(readable) {
    if (readable == null) {
      readable = false;
    }
    if (readable) {
      return JSON.stringify(ZxError.CLIENT_ERRORS, null, "  ");
    } else {
      return JSON.stringify(ZxError.CLIENT_ERRORS);
    }
  };

  return ZxError;

})(Error);

exports = exports != null ? exports : this;

if (exports.ZxError == null) {
  exports.ZxError = ZxError;
}

if ((typeof module !== "undefined" && module !== null) && (module.exports != null)) {
  module.exports = ZxError;
}

//# sourceMappingURL=ZxError.js.map
