/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011, 2012, 2013, 2014 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxPatcher(context) {

  // DwtBaseDialog.prototype._initializeDragging Patch
  // Relates to Zimbra bug https://bugzilla.zimbra.com/show_bug.cgi?id=83352
  if (ZxUtils.CompareZimbraVersion('8.5.0') === 0 ||
    ZxUtils.CompareZimbraVersion('8.5.1') === 0 ||
    ZxUtils.CompareZimbraVersion('8.6.0') === 0 ||
    ZxUtils.CompareZimbraVersion('8.7.0') === 0 ||
    ZxUtils.CompareZimbraVersion('8.7.1') === 0
  ) {
    if (!context.DwtBaseDialog || !context.DwtBaseDialog.prototype._initializeDragging) { return; }
    context.DwtBaseDialog.prototype._initializeDragging = function(dragHandleId) {
      var dragHandle = document.getElementById(dragHandleId),
        control, p, dragObj, dragEndCb, dragCb, dragStartCb;
      if (dragHandle) {
        control = DwtControl.fromElementId(window._dwtShellId);
        if (control) {
          p = Dwt.getSize(control.getHtmlElement());
          dragObj = document.getElementById(this._htmlElId);
          dragEndCb = new AjxCallback(this, this._dragEnd);
          dragCb = new AjxCallback(this, this._duringDrag);
          dragStartCb = new AjxCallback(this, this._dragStart);

          DwtDraggable.init(dragHandle, dragObj, 0, p.x - 10, 0, p.y - 10, dragStartCb, dragCb, dragEndCb);
        }
      }
    };
  }
  if (ZxUtils.CompareZimbraVersion('8.5.0') === 0 ||
    ZxUtils.CompareZimbraVersion('8.5.1') === 0 ||
    ZxUtils.CompareZimbraVersion('8.6.0') === 0 ||
    ZxUtils.CompareZimbraVersion('8.7.0') === 0 ||
    ZxUtils.CompareZimbraVersion('8.7.1') === 0
  ) {
    if (!context.DwtBaseDialog || !context.DwtBaseDialog.prototype._dragStart) { return; }
    context.DwtBaseDialog.prototype._dragStart = function(x, y) {
      // fix for bug 3177
      if (AjxEnv.isNav && !this._ignoreSetDragBoundries) {
        this._currSize = this.getSize();
        // fix for bug 83352
        var control = DwtControl.fromElementId(window._dwtShellId),
          p;
        if (control) {
          p = Dwt.getSize(control.getHtmlElement());
          DwtDraggable.setDragBoundaries(DwtDraggable.dragEl, 0, p.x - this._currSize.x, 0, p.y - this._currSize.y);
        }
      }
    };
  }
  if (ZxUtils.CompareZimbraVersion('8.0.0') >= 0 && ZxUtils.CompareZimbraVersion('8.7.1') <= 0)
  {
    context.XFormItem.prototype.showInputTooltip =
      function (event) {
        var dwtEv = new DwtUiEvent(true);
        dwtEv.setFromDhtmlEvent(event);
        var content = this.getInheritedProperty("toolTipContent");
        if (typeof content !== "undefined" && content !== null) {
          var shell = DwtShell.getShell(window), tooltip = shell.getToolTip();
          tooltip.setContent(this.getInheritedProperty("toolTipContent"));
          tooltip.popup(dwtEv.docX, dwtEv.docY);
        }
      };
  }
}

ZxPatcher(this);
