/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */
var ZxAdminXFormItem = [
  {
    type: _GROUP_,
    cssClass: 'ZmSelectedHeaderBg',
    colSpan: '*',
    id: 'xform_header',
    items: [
      {
        type: _GROUP_,
        cssClass: 'ZxAdminSpacer',
        numCols: 3,
        width: '100%',
        colSizes: [120, '*', 410],
        align: _RIGHT_,
        items: [
          { type: _CELL_SPACER_ },
          { type: _CELL_SPACER_ },
          {
            type: _GROUP_,
            width: 410,
            numCols: 2,
            enableDisableChangeEventSources: ['config/' + ZxAdmin.KEY_NEED_MIGRATION],
            enableDisableChecks:[ZxAdmin.notNeedMigrationCheck],
            items: [
              {
                type: _GROUP_,
                width: 200,
                numCols: 1,
                valign: _TOP_,
                items: [
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_COR_reset_admin_settings'),
                    toolTipContent: zxMsg('MSG_COR_reset_admin_settings'),
                    icon: 'ZxAdmin',
                    width: 200,
                    align: _LEFT_,
                    onActivate: ZxAdmin.doResetAdminSettings,
                    availableIfModuleDisabled: true
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_DLG_Show_Path_Information'),
                    icon: 'ZxOpQueue',
                    width: 200,
                    align: _LEFT_,
                    cssStyle: 'margin-top:5px',
                    toolTipContent: zxMsg('LBL_DLG_Show_Path_Information'),
                    onActivate: ZxAdmin.doShowLogPathInfo
                  }
                ]
              },
              {
                type: _GROUP_,
                width: 200,
                numCols: 1,
                items: [
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_DLG_browse_logs'),
                    icon: 'ZxAdmin',
                    width: 200,
                    align: _LEFT_,
                    toolTipContent: zxMsg('MSG_DLG_browse_logs_tooltip'),
                    onActivate: ZxAdmin.doSelectFilterForBrowseLog
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_Show_Report'),
                    icon: 'RightObject',
                    width: 200,
                    align: _LEFT_,
                    cssStyle: 'margin-top:5px',
                    toolTipContent: zxMsg('MSG_DLG_show_report_for_admin_tooltip'),
                    onActivate: ZxAdmin.doShowMonthlyReport
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  {
    type: _ZX_ALERT_,
    style: DwtAlert.WARNING,
    visibilityChangeEventSources: ['config/' + ZxAdmin.KEY_NEED_MIGRATION],
    visibilityChecks: [ZxAdmin.needMigrationCheck],
    numCols: 2,
    items: [
      {
        type: _OUTPUT_,
        value: zxMsg('MSG_DLG_Settings_migration_is_required'),
        colSpan: 2
      },
      {
        type: _CELL_SPACER_
      },
      {
        type: _GROUP_,
        numCols: 2,
        colSizes: ['*', '*'],
        items: [
          {
            type: _DWT_BUTTON_,
            icon: 'ZxAdmin',
            label: zxMsg('LBL_Migrate_acls'),
            onActivate: ZxAdmin.doStartACLMigration
          }
        ]
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSizes: ['*'],
    width: '100%',
    tableCssStyle: 'width:100%;overflow:auto;padding-right:15px;padding-left:15px;',
    enableDisableChangeEventSources: ['config/' + ZxAdmin.KEY_NEED_MIGRATION],
    enableDisableChecks:[ZxAdmin.notNeedMigrationCheck],
    items: [
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_DLG_admin_preferences'),
        numCols: 1,
        colSizes: ['*'],
        align: _LEFT_,
        items: [
          {
            type: _CHECKBOX_,
            labelLocation: _LEFT_,
            align: _LEFT_,
            labelCssClass: 'ZxCheckboxLabel',
            ref: 'attrs/properties/' + ZxAdmin.KEY_SEND_REPORTS_TO_DELEGATED_ENABLED,
            bmolsnr: true,
            label: zxMsg('LBL_DLG_send_reports_to_delegated') + ': '
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_DLG_delegated_admins'),
        numCols: 1,
        colSizes: ['*'],
        align: _LEFT_,
        items: [
          {
            type: _ZX_LIST_VIEW_,
            id: ZxAdmin.ID_LIST_DELEGATED_ADMINS,
            ref: 'attrs/' + ZxAdmin.KEY_LIMITS,
            headerList: ZxAdmin.getDelegatedAdminsHeaderList(),
            optionalButtons: ZxAdmin.getDelegatedAdminsListButtons(),
            onSelection: ZxAdmin._onDelegatedAdminsSelected,
            filterEnabled: true,
            navigationEnabled: true
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_DLG_Domain_Settings'),
        numCols: 1,
        colSizes: ['*'],
        items: [
          {
            type: _ZX_LIST_VIEW_,
            id: ZxAdmin.ID_LIST_DOMAIN_SETTINGS,
            ref: 'attrs/' + ZxAdmin.KEY_DOMAINS,
            headerList: ZxAdmin.getDomainHeaderList(),
            optionalButtons: ZxAdmin.getDomainListButtons(),
            onSelection: ZxAdmin._onDomainSelected,
            filterEnabled: true,
            navigationEnabled: true
          }
        ]
      }
    ]
  }
];
