/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxAdminLogPathDialog(parent) {
  this._standardButtons = [DwtDialog.OK_BUTTON];

  this.attrs = {};
  this.attrs[ZxAdminLogPathDialog.KEY_PATH_VALUE] = {};

  var helpButton = new DwtDialog_ButtonDescriptor(
    ZxAdminLogPathDialog.ID_BTN_HELP,
    ZaMsg.TBB_Help,
    DwtDialog.ALIGN_LEFT,
    new AjxCallback(
      this,
      ZxUtils.openURL,
      [ZxLinks.HELP_DLG_Dialog_Change_log_path]
    )
  );

  this._extraButtons = [helpButton];

  ZaXDialog.call(
    this,
    parent,
    null,
    ZxUtils.getTitleWithIcon('ZxAdmin', zxMsg('LBL_DLG_Log_path_dialog_title')),
    '450px',
    '200px',
    null,
    null
  );

  this.initForm([], this.getMyXForm());

  ZxAdminRequest.sendRequest(
    ZxAdminRequest.TARGET_ALL,
    'ZxAdmin',
    'getPublicProperties'
  ).then(
    AjxCallback.simpleClosure(
      function(resp) {
        var tmpServer;

        for (tmpServer in resp) {
          if (!resp.hasOwnProperty(tmpServer)) { continue; }

          if (resp[tmpServer] instanceof ZxError) {
            ZxUtils.catchError(resp[tmpServer]);
          }

          if (!resp[tmpServer].ok) {
            this.attrs[ZxAdminLogPathDialog.KEY_PATH_VALUE][tmpServer] = zxMsg('LBL_NA');
          } else {
            var tmpResp = resp[tmpServer].response.properties;
            this.attrs[ZxAdminLogPathDialog.KEY_PATH_VALUE][tmpServer] = tmpResp[ZxAdmin.KEY_LOG_PATH];
          }
        }

        this.setObject(this);
      },
      this
    ),
    ZxUtils.catchError
  );

  this._helpURL = ZxLinks.HELP_DLG_Dialog_Change_log_path;
}

ZxAdminLogPathDialog.prototype = new ZaXDialog();
ZxAdminLogPathDialog.prototype.constructor = ZxAdminLogPathDialog;

ZxAdminLogPathDialog.ID_BTN_HELP = 'helpBtn';

ZxAdminLogPathDialog.KEY_PATH_VALUE = 'pathValues';

ZxAdminLogPathDialog.stringBuilder = function(val) {
  var tmpString = [],
    server;
  if (!val || ZxUtils.isObjectEmpty(val)) {
    return '<div class="DwtWait32Icon">&nbsp;</div>' + ZaMsg.splashScreenLoading;
  }

  for (server in val) {
    if (!val.hasOwnProperty(server)) { continue; }
    tmpString.push(server + ': ' + val[server]);
  }

  return tmpString.join('<br>');
};

ZxAdminLogPathDialog.prototype.getMyXForm = function() {
  var xFormObject;
  xFormObject = {
    numCols: 1,
    colSizes: ['100%'],
    items: [
      { type: _SPACER_, height: 10 },
      {
        type: _OUTPUT_,
        ref: 'attrs/' + ZxAdminLogPathDialog.KEY_PATH_VALUE,
        getDisplayValue: ZxAdminLogPathDialog.stringBuilder
      },
      { type: _SPACER_, height: 10 },
      {
        type: _OUTPUT_,
        value: zxMsg('LBL_DLG_log_path_info', ['<a href="' + ZxLinks.HELP_DLG_Dialog_Change_log_path +
          '" target="_blank">', '</a>']),
        cssStyle: 'font-size: 12px; margin-top: 5px;'
      }
    ]
  };
  return xFormObject;
};
