/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxAdminResetSettingsDialog(item) {
  var parent = item.getCurrentController().getShell();
  this._item = item;
  this._standardButtons = [DwtDialog.CANCEL_BUTTON, DwtDialog.OK_BUTTON];
  ZaXDialog.call(this, parent, null,
    ZxUtils.getTitleWithIcon('ZxAdmin', zxMsg('LBL_COR_reset_admin_settings')),
    '590px', '130px', null, null);

  this.getButton(DwtDialog.OK_BUTTON).setText(zxMsg('LBL_DLG_Execute_Reset'));
  this.getButton(DwtDialog.OK_BUTTON).setEnabled(false);

  this.registerCallback(
    DwtDialog.OK_BUTTON,
    new AjxCallback(this, this.onConfirm)
  );

  this._helpURL = ZxLinks.HELP_DLG_Dialog_ResetSettings;
  this.initForm([], this.getMyXForm());
}

ZxAdminResetSettingsDialog.prototype = new ZaXDialog();
ZxAdminResetSettingsDialog.prototype.constructor = ZxAdminResetSettingsDialog;

ZxAdminResetSettingsDialog.prototype.onConfirm = function(val) {
  ZxAdminRequest.sendRequest(
    ZxAdminRequest.TARGET_LOCAL,
    'ZxCore',
    'doDeleteAllDelegatedRights',
    {confirm: true}
  ).then(
    AjxCallback.simpleClosure(
      function(resp) {
        this.popdown();
        if (resp instanceof ZxError) {
          ZxUtils.catchError(resp);
        }else {
          this._item.getCurrentController().popupMsgDialog(resp.message);
        }
      },
      this
    ),
    ZxUtils.catchError
  );
};

ZxAdminResetSettingsDialog.prototype.checkboxOnChange = function(val) {
  this.getButton(DwtDialog.OK_BUTTON).setEnabled(val);
};

ZxAdminResetSettingsDialog.prototype.getMyXForm = function() {
  var xForm = {
    numCols: 1,
    colSizes: ['100%'],
    items: [
      {type: _SPACER_, height: 10},
      {
        type: _GROUP_,
        numCols: 1,
        colSizes: ['100%'],
        items: [
          {
            type: _OUTPUT_,
            value: [
              '<table cellspacing=0 cellpadding=0 border=0 width=100% height=100%>',
              '<tr><td valign="top">',
              AjxImg.getImageHtml(DwtMessageDialog.ICON[DwtMessageDialog.WARNING_STYLE], null, 'id=warning_Image'),
              '</td><td class="DwtMsgArea" id="', this._msgCellId, '_Msg">',
              zxMsg('MSG_COR_warninig_reset_delegation'),
              '</td></tr></table>'
            ].join('')
          },
          {type: _SPACER_, height: 15},
          {
            type: _CHECKBOX_,
            id: 'adminResetConfirmCheckboxId',
            labelCssClass: 'ZxCheckboxLabel',
            labelLocation: _LEFT_,
//            align: _LEFT_,
            label: zxMsg('MSG_COR_warninig_reset_delegation_proceed') + ': ',
            onChange: AjxCallback.simpleClosure(this.checkboxOnChange, this)
          }
        ]
      }
    ]
  };
  return xForm;
};
