/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxAdminBrowseLogOp(moduleItem) {
  ZaItem.call(this, 'ZxAdminBrowseLogsOp');
  this._init();
  this.type = ZxAdminBrowseLogOp.TYPE;
  this._modItem = moduleItem;
}

ZxAdminBrowseLogOp.TYPE = 'AdminBrowseLogsOp';
ZxAdminBrowseLogOp.prototype = new ZaItem();
ZxAdminBrowseLogOp.prototype.constructor = ZxAdminBrowseLogOp;

ZxAdminBrowseLogOp.KEY_ACCOUNT = 'adminAccount';
ZxAdminBrowseLogOp.KEY_ACTION = 'adminAction';
ZxAdminBrowseLogOp.KEY_CLIENT_IP = 'clientIP';
ZxAdminBrowseLogOp.KEY_SHOW_LOGINS = 'showAuths';
ZxAdminBrowseLogOp.KEY_OUTCOME = 'outcome';
ZxAdminBrowseLogOp.KEY_DATE_START = 'dateStart';
ZxAdminBrowseLogOp.KEY_DATE_END = 'dateEnd';
ZxAdminBrowseLogOp.KEY_ADMIN_ACTIONS = 'adminLogs';

ZxAdminBrowseLogOp.OUTCOME_CHOICES = [
  {value: 'all', label: zxMsg('LBL_DLG_All')},
  {value: 'true', label: zxMsg('LBL_DLG_Success')},
  {value: 'false', label: zxMsg('LBL_DLG_Failure')}
];

ZxAdminBrowseLogOp.ACTIONS_CHOICES = [
  {value: 'All', label: zxMsg('LBL_DLG_All')},
  {value: 'AddAccountAlias', label: 'AddAccountAlias'},
  {value: 'AddAccountLogger', label: 'AddAccountLogger'},
  {value: 'AddDistributionListAlias', label: 'AddDistributionListAlias'},
  {value: 'AddDistributionListMember', label: 'AddDistributionListMember'},
  {value: 'Auth', label: 'Auth'},
  {value: 'ConfigureZimlet', label: 'ConfigureZimlet'},
  {value: 'CopyCos', label: 'CopyCos'},
  {value: 'CreateAccount', label: 'CreateAccount'},
  {value: 'CreateCalendarResource', label: 'CreateCalendarResource'},
  {value: 'CreateCos', label: 'CreateCos'},
  {value: 'CreateDistributionList', label: 'CreateDistributionList'},
  {value: 'CreateDomain', label: 'CreateDomain'},
  {value: 'CreateSystemRetentionPolicy', label: 'CreateSystemRetentionPolicy'},
  {value: 'CreateVolume', label: 'CreateVolume'},
  {value: 'CreateZimlet', label: 'CreateZimlet'},
  {value: 'DelegateAuth', label: 'DelegateAuth'},
  {value: 'DeleteAccount', label: 'DeleteAccount'},
  {value: 'DeleteCalendarResource', label: 'DeleteCalendarResource'},
  {value: 'DeleteCos', label: 'DeleteCos'},
  {value: 'DeleteDistributionList', label: 'DeleteDistributionList'},
  {value: 'DeleteDomain', label: 'DeleteDomain'},
  {value: 'DeleteSystemRetentionPolicy', label: 'DeleteSystemRetentionPolicy'},
  {value: 'DeleteVolume', label: 'DeleteVolume'},
  {value: 'DeleteZimlet', label: 'DeleteZimlet'},
  {value: 'DeployZimlet', label: 'DeployZimlet'},
  {value: 'GrantRight', label: 'GrantRight'},
  {value: 'ModifyAccount', label: 'ModifyAccount'},
  {value: 'ModifyCalendarResource', label: 'ModifyCalendarResource'},
  {value: 'ModifyConfig', label: 'ModifyConfig'},
  {value: 'ModifyCos', label: 'ModifyCos'},
  {value: 'ModifyDelegatedAdminConstraints', label: 'ModifyDelegatedAdminConstraints'},
  {value: 'ModifyDistributionList', label: 'ModifyDistributionList'},
  {value: 'ModifyDomain', label: 'ModifyDomain'},
  {value: 'ModifySystemRetentionPolicy', label: 'ModifySystemRetentionPolicy'},
  {value: 'ModifyVolume', label: 'ModifyVolume'},
  {value: 'ModifyZimlet', label: 'ModifyZimlet'},
  {value: 'RemoveAccountAlias', label: 'RemoveAccountAlias'},
  {value: 'RemoveAccountLogger', label: 'RemoveAccountLogger'},
  {value: 'RemoveDistributionListAlias', label: 'RemoveDistributionListAlias'},
  {value: 'RemoveDistributionListMember', label: 'RemoveDistributionListMember'},
  {value: 'RenameAccount', label: 'RenameAccount'},
  {value: 'RenameCalendarResource', label: 'RenameCalendarResource'},
  {value: 'RenameCos', label: 'RenameCos'},
  {value: 'RenameDistributionList', label: 'RenameDistributionList'},
  {value: 'ResetAllLoggers', label: 'ResetAllLoggers'},
  {value: 'RevokeRight', label: 'RevokeRight'},
  {value: 'SetCurrentVolume', label: 'SetCurrentVolume'},
  {value: 'SetPassword', label: 'SetPassword'},
  {value: 'UndeployZimlet', label: 'UndeployZimlet'},
  {value: 'ZxDoAddDelegationSettings', label: 'ZxDoAddDelegationSettings'},
  {value: 'ZxDoModifyDelegationSettings', label: 'ZxDoModifyDelegationSettings'},
  {value: 'ZxDoRemoveDelegationSettings', label: 'ZxDoRemoveDelegationSettings'},
  {value: 'ZxSetDomainSettings', label: 'ZxSetDomainSettings'},
  {value: 'ZxSetZimletRights', label: 'ZxSetZimletRights'}
];

/**
 * Initialize the Browse operation with the default values.
 */
ZxAdminBrowseLogOp.prototype.init = function() {
  this.attrs = {};
  this.setAttrs = {};
  this.getAttrs = {};

  this.attrs[ZxAdminBrowseLogOp.KEY_ACCOUNT] = '';
  this.attrs[ZxAdminBrowseLogOp.KEY_ACTION] = 'All';
  this.attrs[ZxAdminBrowseLogOp.KEY_CLIENT_IP] = '';
  this.attrs[ZxAdminBrowseLogOp.KEY_SHOW_LOGINS] = false;
  this.attrs[ZxAdminBrowseLogOp.KEY_OUTCOME] = 'All';
  this.attrs[ZxAdminBrowseLogOp.KEY_DATE_START] = new Date();
  this.attrs[ZxAdminBrowseLogOp.KEY_DATE_END] = new Date();
  this.attrs[ZxAdminBrowseLogOp.KEY_ADMIN_ACTIONS] = [];

  this.setAttrs.all = true;
  this.getAttrs.all = true;
};

ZxAdminBrowseLogOp.prototype.setSelection = function(opDetails) {
  this.attrs._selection = opDetails;
};

ZxAdminBrowseLogOp.prototype.getSelection = function() {
  return this.attrs._selection;
};

ZxAdminBrowseLogOp.prototype.showDetailsDialog = function() {
  if (!this.attrs._selection || this.attrs._selection === null) {
    return;
  }
  var msgDialog = new ZxAdminLogDetailsDialog(
    ZaApp.getInstance().getCurrentController().getShell(),
    this.attrs._selection
  );
  msgDialog.popup();
};
