/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxAdminBrowseLogWizard(item) {
  this._item = item;

  var helpButton = new DwtDialog_ButtonDescriptor(
      ZaXWizardDialog.HELP_BUTTON,
      ZaMsg.TBB_Help,
      DwtDialog.ALIGN_LEFT,
      new AjxCallback(this, this._helpButtonListener)
    ),
    detailsButton = new DwtDialog_ButtonDescriptor(
      ZxAdminBrowseLogWizard.BUTTON_DETAILS,
      'Details',
      DwtDialog.ALIGN_RIGHT,
      new AjxCallback(this, this.getDetailsPopup)
    ),
    nextButton = new DwtDialog_ButtonDescriptor(
      ZaXWizardDialog.NEXT_BUTTON,
      AjxMsg._next,
      DwtDialog.ALIGN_RIGHT,
      new AjxCallback(this, this.goNext)
    ),
    prevButton = new DwtDialog_ButtonDescriptor(
      ZaXWizardDialog.PREV_BUTTON,
      AjxMsg._prev,
      DwtDialog.ALIGN_RIGHT,
      new AjxCallback(this, this.goPrev)
    ),
    buttons = [
      helpButton,
      detailsButton,
      prevButton,
      nextButton
    ];

  ZaXWizardDialog.call(this, item.getCurrentController().getShell(),
    null,
    ZxUtils.getTitleWithIcon('ZxAdmin', zxMsg('LBL_DLG_browse_logs')),
    '720px',
    '600px',
    'ZxAdminBrowseLogWizard',
    buttons
    );

  this.stepChoices = [
    {label: zxMsg('LBL_DLG_WIZ_Select_admin_and_action'),
      value: ZxAdminBrowseLogWizard.STEP_INTRO},
    {label: zxMsg('LBL_DLG_WIZ_Retrieve_infos'),
      value: ZxAdminBrowseLogWizard.STEP_LOAD_INFO},
    {label: zxMsg('LBL_DLG_WIZ_Show_information'),
      value: ZxAdminBrowseLogWizard.STEP_SHOW}
  ];

  this._helpURL = ZxLinks.HELP_DLG_About_Browse_Logs;
  this.initForm(ZxAdminBrowseLogWizard.XModel, this.getMyXForm());

  this._localXForm.addListener(DwtEvent.XFORMS_FORM_DIRTY_CHANGE,
    new AjxListener(this, this.handleXFormChange));
}

ZxAdminBrowseLogWizard.prototype = new ZaXWizardDialog();
ZxAdminBrowseLogWizard.prototype.constructor = ZxAdminBrowseLogWizard;

ZxAdminBrowseLogWizard.MAX_RESULTS = 1000;

ZxAdminBrowseLogWizard.STEP_INDEX = 1;
ZxAdminBrowseLogWizard.STEP_INTRO = ZxAdminBrowseLogWizard.STEP_INDEX++;
ZxAdminBrowseLogWizard.STEP_LOAD_INFO = ZxAdminBrowseLogWizard.STEP_INDEX++;
ZxAdminBrowseLogWizard.STEP_SHOW = ZxAdminBrowseLogWizard.STEP_INDEX++;

ZxAdminBrowseLogWizard.COL_ID_ADMIN = 'admin';
ZxAdminBrowseLogWizard.BUTTON_DETAILS = 14;
ZxAdminBrowseLogWizard.COL_ID_ACTION = 'action';
ZxAdminBrowseLogWizard.COL_ID_TIME = 'time';
ZxAdminBrowseLogWizard.COL_ID_CLIENT_IP = 'clientIP';
ZxAdminBrowseLogWizard.STR_MODULE_DISABLED = 'Request ignored since module is disabled';

ZxAdminBrowseLogWizard.XModel = [
  {type: _STRING_, id: ZxAdminBrowseLogOp.KEY_ACCOUNT,
    ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_ACCOUNT},
  {type: _STRING_, id: ZxAdminBrowseLogOp.KEY_ACTION,
    ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_ACTION,
    choices: ZxAdminBrowseLogOp.ACTIONS_CHOICES},
  {type: _STRING_, id: ZxAdminBrowseLogOp.KEY_CLIENT_IP,
    ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_CLIENT_IP},
  {type: _ENUM_, id: ZxAdminBrowseLogOp.KEY_SHOW_LOGINS,
    ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_SHOW_LOGINS,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _STRING_, id: ZxAdminBrowseLogOp.KEY_OUTCOME,
    ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_OUTCOME,
    choices: ZxAdminBrowseLogOp.OUTCOME_CHOICES},
  {type: _DATE_, id: ZxAdminBrowseLogOp.KEY_DATE_START,
    ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_DATE_START},
  {type: _DATE_, id: ZxAdminBrowseLogOp.KEY_DATE_END,
    ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_DATE_END},

  {type: _LIST_, id: ZxAdminBrowseLogOp.KEY_ADMIN_ACTIONS,
    ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_ADMIN_ACTIONS}

];

ZaXDialog.XFormModifiers['ZxAdminBrowseLogWizard'] = [];

ZxAdminBrowseLogWizard.prototype.miniType = 2;

ZxAdminBrowseLogWizard.geHeaderList = function() {
  var headerList = [];
  headerList.push(new ZaListHeaderItem(
    ZxAdminBrowseLogWizard.COL_ID_ADMIN,
    zxMsg('LBL_DLG_Admin'),
    null,
    null,
    null,
    null,
    true,
    true
  ));
  headerList.push(new ZaListHeaderItem(
    ZxAdminBrowseLogWizard.COL_ID_ACTION,
    zxMsg('LBL_DLG_Action'),
    null,
    null,
    null,
    null,
    true,
    true
  ));
  headerList.push(new ZaListHeaderItem(
    ZxAdminBrowseLogWizard.COL_ID_TIME,
    zxMsg('LBL_DLG_Time'),
    null,
    '130px',
    null,
    null,
    true,
    true
  ));
  headerList.push(new ZaListHeaderItem(
    ZxAdminBrowseLogWizard.COL_ID_CLIENT_IP,
    zxMsg('LBL_DLG_Client_IP'),
    null,
    null,
    null,
    null,
    true,
    true
  ));
  //headerList.push(new ZaListHeaderItem("ZXASuccess" , "Success" , null, null, null, null, true, true));
  return headerList;
};

ZxAdminBrowseLogWizard.XFormModifier = function(xFormObject) {
  var cases = [],
    step_intro,
    step_load,
    step_show;

  step_intro = {
    type: _CASE_,
    caseKey: ZxAdminBrowseLogWizard.STEP_INTRO,
    items: [
      {
        type: _ZAWIZ_TOP_GROUPER_,
        label: zxMsg('LBL_DLG_WIZ_Select_admin_and_action'),
        numCols: 1,
        colSizes: ['*'],
        items: [
          { type: _SPACER_, height: 10 },
          {
            type: _OUTPUT_,
            colSpan: 2,
            value: zxMsg('MSG_DLG_INTRO_Browse_log_wizard'),
            align: _MIDDLE_
          },
          { type: _SPACER_, height: 10 },
          {
            type: _TOP_GROUPER_,
            label: zxMsg('LBL_DLG_WIZ_Select_Basic'),
            numCols: 1,
            colSpan: 2,
            colSizes: ['*'],
            items: [
              {
                type: _DYNSELECT_,
                ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_ACCOUNT,
                label: zxMsg('LBL_DLG_Admin') + ': ',
                dataFetcherClass: ZaSearch,
                dataFetcherMethod: ZaSearch.prototype.dynSelectSearch,
                dataFetcherTypes: [ZaSearch.ACCOUNTS],
                dataFetcherAttrs: [ZaItem.A_zimbraId, ZaItem.A_cn, ZaAccount.A_name,
                  ZaAccount.A_displayname, ZaAccount.A_mail],
                editable: true,
                forceUpdate: true
              },
              {
                type: _OSELECT1_,
                ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_ACTION,
                label: zxMsg('LBL_DLG_Action') + ': ',
                choices: ZxAdminBrowseLogOp.ACTIONS_CHOICES
              }
            ]
          },
          {
            type: _TOP_GROUPER_,
            label: zxMsg('LBL_DLG_WIZ_Select_advanced'),
            numCols: 1,
            colSpan: 2,
            colSizes: ['*'],
            items: [
              {
                type: _INPUT_,
                label: zxMsg('LBL_DLG_Client_IP') + ': ',
                ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_CLIENT_IP
              },
              {
                type: _CHECKBOX_,
                labelCssClass: 'ZxCheckboxLabel',
                labelLocation: _LEFT_,
                align: _LEFT_,
                label: zxMsg('LBL_DLG_Show_logins') + ': ',
                ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_SHOW_LOGINS
              },
              {
                type: _OSELECT1_,
                label: zxMsg('LBL_DLG_Outcome') + ': ',
                ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_OUTCOME,
                choices: ZxAdminBrowseLogOp.OUTCOME_CHOICES
              },
              {
                type: _DWT_DATE_,
                label: zxMsg('LBL_Start') + ': ',
                bmolsnr: true,
                ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_DATE_START
              },
              {
                type: _DWT_DATE_,
                label: zxMsg('LBL_End') + ': ',
                bmolsnr: true,
                ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_DATE_END
              }
            ]
          }
        ]
      }
    ]
  };

  step_load = {
    type: _CASE_,
    caseKey: ZxAdminBrowseLogWizard.STEP_LOAD_INFO,
    items: [
      {
        type: _ZAWIZ_TOP_GROUPER_,
        label: zxMsg('LBL_DLG_WIZ_Retrieve_infos'),
        numCols: 1,
        colSizes: ['*'],
        items: [
          {
            type: _OUTPUT_,
            cssStyle: 'padding-top: 10px',
            value: '<div class="DwtWait32Icon">&nbsp;</div><b>' + zxMsg('LBL_DLG_WIZ_Retrieving_log_infos') + '</b>'
          }
        ]
      }
    ]
  };

  step_show = {
    type: _CASE_,
    caseKey: ZxAdminBrowseLogWizard.STEP_SHOW,
    numCols: 1,
    colSizes: ['*'],
    items: [
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        visibilityChecks: [function() {
          var val = this.getInstanceValue();
          return ZxUtils.isArray(val) && val.length > ZxAdminBrowseLogWizard.MAX_RESULTS;
        }],
        ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_ADMIN_ACTIONS,
        bmolsnr: true,
        style: DwtAlert.WARNING,
        iconVisible: true,
        content: zxMsg('MSG_DLG_Report_too_big_result_incomplete'),
        colSpan: '*'
      },
      {
        type: _ZAWIZ_TOP_GROUPER_,
        label: zxMsg('LBL_DLG_WIZ_Show_information'),
        numCols: 1,
        colSizes: ['*'],
        forceUpdate: true,
        items: [
          {
            type: _ZX_LIST_VIEW_,
            id: 'DWT_ADMIN_LOGS',
            ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_ADMIN_ACTIONS,
            headerList: ZxAdminBrowseLogWizard.geHeaderList(),
            filterEnabled: true,
            navigationEnabled: true,
            onSelection: ZxAdminBrowseLogWizard._showLogOp
          }
//          {
//            type: _OUTPUT_,
//            cssStyle: 'padding-top: 10px',
//            ref: 'attrs/' + ZxAdminBrowseLogOp.KEY_ADMIN_ACTIONS
//          }
        ]
      }
    ]
  };

  cases.push(step_intro);
  cases.push(step_load);
  cases.push(step_show);

  xFormObject.items = [
    {
      type: _OUTPUT_,
      align: _CENTER_,
      valign: _TOP_,
      ref: ZaModel.currentStep,
      choices: this.stepChoices,
      valueChangeEventSources: [ZaModel.currentStep],
      labelClickMethod: function() {
        var sourceValue = this.getInheritedProperty('sourceValue'),
          instanceValue = this.getInstanceValue();
        if (sourceValue < instanceValue) {}
      }
    },
    {
      type: _SEPARATOR_,
      align: _CENTER_,
      valign: _TOP_
    },
    {
      type: _SPACER_,
      align: _CENTER_,
      valign: _TOP_
    },
    {
      type: _SWITCH_,
      align: _LEFT_,
      valign: _TOP_,
      items: cases
    }
  ];
};
ZaXDialog.XFormModifiers['ZxAdminBrowseLogWizard'].push(ZxAdminBrowseLogWizard.XFormModifier);

/**
 * When something is changed (also the page number),
 * validate the inputs and enable/disable wizard buttons.
 */
ZxAdminBrowseLogWizard.prototype.handleXFormChange = function() {
  var obj = this.getObject(),
    cStep = obj[ZaModel.currentStep];
  ZxUtils.log(cStep, 'Wizard step');

  if (this._localXForm.hasErrors()) {
  } else {
    this._button[DwtWizardDialog.PREV_BUTTON].setEnabled(true);

    if (cStep === ZxAdminBrowseLogWizard.STEP_INTRO) {
      this.getButton(DwtDialog.CANCEL_BUTTON).setEnabled(true);
      this._button[DwtWizardDialog.PREV_BUTTON].setEnabled(false);
      this._button[ZxAdminBrowseLogWizard.BUTTON_DETAILS].setEnabled(false);
      this._button[DwtWizardDialog.NEXT_BUTTON].setEnabled(true);

      if (obj.attrs[ZxAdminBrowseLogOp.KEY_DATE_START] > obj.attrs[ZxAdminBrowseLogOp.KEY_DATE_END]) {
        // The date of the start of the search must be behind of the end date.
        this.getButton(DwtWizardDialog.NEXT_BUTTON).setEnabled(false);
      }

      return;
    }

    if (cStep === ZxAdminBrowseLogWizard.STEP_LOAD_INFO) {
      this.getButton(DwtDialog.CANCEL_BUTTON).setEnabled(true);
      this.getButton(DwtWizardDialog.PREV_BUTTON).setEnabled(false);
      this._button[ZxAdminBrowseLogWizard.BUTTON_DETAILS].setEnabled(false);
      this.getButton(DwtWizardDialog.NEXT_BUTTON).setEnabled(false);

      var reqObj = {}, tmpStart, tmpEnd;

      if (obj.attrs[ZxAdminBrowseLogOp.KEY_ACCOUNT] !== '') {
        reqObj.admin = obj.attrs[ZxAdminBrowseLogOp.KEY_ACCOUNT];
      }
      if (obj.attrs[ZxAdminBrowseLogOp.KEY_ACTION] !== '' && obj.attrs[ZxAdminBrowseLogOp.KEY_ACTION] !== 'All') {
        reqObj.actionName = obj.attrs[ZxAdminBrowseLogOp.KEY_ACTION];
      }
      if (obj.attrs[ZxAdminBrowseLogOp.KEY_ACTION] === 'Auth') {
        reqObj.showAuths = true;
      }
      if (obj.attrs[ZxAdminBrowseLogOp.KEY_SHOW_LOGINS] === true) {
        reqObj.showAuths = true;
      }
      if (obj.attrs[ZxAdminBrowseLogOp.KEY_CLIENT_IP]) {
        reqObj.clientIP = obj.attrs[ZxAdminBrowseLogOp.KEY_CLIENT_IP];
      }

      tmpStart = obj.attrs[ZxAdminBrowseLogOp.KEY_DATE_START];
      tmpEnd = obj.attrs[ZxAdminBrowseLogOp.KEY_DATE_END];
      tmpStart.setHours(0);
      tmpStart.setMinutes(0);
      tmpStart.setSeconds(0);
      tmpStart.setMilliseconds(0);
      tmpEnd.setHours(23);
      tmpEnd.setMinutes(59);
      tmpEnd.setSeconds(59);
      tmpEnd.setMilliseconds(999);
      reqObj.dateStart = tmpStart.getTime();
      reqObj.dateEnd = tmpEnd.getTime();
      reqObj.timeOrderDescending = true;
      reqObj.maxResultSize = ZxAdminBrowseLogWizard.MAX_RESULTS;
      reqObj.outcome = obj.attrs[ZxAdminBrowseLogOp.KEY_OUTCOME];

      ZxAdminRequest.sendRequest(
        ZxAdminRequest.TARGET_LOCAL,
        'ZxAdmin',
        'doShowAdminActivity',
        reqObj
      ).then(
        AjxCallback.simpleClosure(
          function(resp) {

            if (!(resp instanceof ZxError)) {
              var response = resp.response, i = 0;

              while (i < response.adminActions.length) {
                if (response.adminActions[i].admin === 'zimbra') {
                  response.adminActions[i].admin = 'system';
                }
                i = i + 1;
              }

              this._containedObject.attrs[ZxAdminBrowseLogOp.KEY_ADMIN_ACTIONS] = response.adminActions;
              this.goNext();

            } else {
              ZeXtrasItem.showMessageDialog(resp.getMessage());
//              var errMsg = resp[this._item.getServerName()].error;
//              if (errMsg === ZxAdminBrowseLogWizard.STR_MODULE_DISABLED) {
//                ZeXtrasItem.showMessageDialog(zxMsg('MSG_DLG_Cannot_show_report_module_disabled'));
//                this.popdown();
//              }
            }
          },
          this
        ),
        ZxUtils.catchError
      );
      if (this._containedObject && this._containedObject.attrs && this._containedObject.attrs._selection) {
        delete this._containedObject.attrs._selection;
      }
      return;
    }

    if (cStep === ZxAdminBrowseLogWizard.STEP_SHOW) {
      this.getButton(DwtDialog.CANCEL_BUTTON).setEnabled(true);
      this.getButton(DwtWizardDialog.PREV_BUTTON).setEnabled(true);
      this.getButton(DwtWizardDialog.NEXT_BUTTON).setEnabled(false);
      this._button[ZxAdminBrowseLogWizard.BUTTON_DETAILS].setEnabled(true);
      return;
    }

  }
};

/**
 * When a row is clicked, show the operation details.
 * @param {DwtSelectionEvent} ev
 * @this Dwt_List_XFormItem
 */
ZxAdminBrowseLogWizard._showLogOp = function(ev) {
  if (ev.detail === DwtListView.ITEM_DBL_CLICKED) {
    this.getInstance().setSelection(ev.item);
    this.getInstance().showDetailsDialog();
  }
  if (ev.detail === DwtListView.ITEM_SELECTED) {
    this.getInstance().setSelection(ev.item);
  }
};

ZxAdminBrowseLogWizard.prototype.getDetailsPopup = function() {
  this._containedObject.showDetailsDialog();
};

/**
 * Move to previous page.
 * This also trigger a check of the entire form.
 */
ZxAdminBrowseLogWizard.prototype.goPrev = function() {
  if (this._containedObject[ZaModel.currentStep] === ZxAdminBrowseLogWizard.STEP_SHOW) {
    this.goPage(ZxAdminBrowseLogWizard.STEP_INTRO);
  } else {
    this.goPage(this._containedObject[ZaModel.currentStep] - 1);
  }
  this.handleXFormChange();
};

/**
 * Move to next page.
 * This also trigger a check of the entire form.
 */
ZxAdminBrowseLogWizard.prototype.goNext = function() {
  this.goPage(this._containedObject[ZaModel.currentStep] + 1);
  this.handleXFormChange();
};

/**
 * Set the instance object.
 * When a wizard (on Z8) is moved as running tasks, when is resumed,
 * Zimbra invoke this function to restore the form with the correct informations.
 * @param {ZxRestoreOp} entry
 */
ZxAdminBrowseLogWizard.prototype.setObject = function(entry) {
  this._containedObject = entry;

  this._containedObject[ZaModel.currentStep] = entry[ZaModel.currentStep] || ZxAdminBrowseLogWizard.STEP_INTRO;
  this._localXForm.setInstance(this._containedObject);
};
