/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

var ZxBackupModel = [
  {type: _STRING_, id: ZxBackup.KEY_BACKUP_PATH,
    ref: 'attrs/properties/' + ZxBackup.KEY_BACKUP_PATH},
  {type: _NUMBER_, id: ZxBackup.KEY_SPACE_THRESHOLD,
    ref: 'attrs/properties/' + ZxBackup.KEY_SPACE_THRESHOLD},
  {type: _ENUM_, id: ZxBackup.KEY_FULLSCAN_START_TIME,
    ref: 'attrs/properties/' + ZxBackup.KEY_FULLSCAN_START_TIME,
    choices: ZxUtils.HOURS},
  {type: _ENUM_, id: ZxBackup.KEY_FULLSCAN_PURGE_WEEKDAY,
    ref: 'attrs/properties/' + ZxBackup.KEY_FULLSCAN_PURGE_WEEKDAY,
    choices: ZxUtils.WEEKDAYS},
  {type: _ENUM_, id: ZxBackup.KEY_DO_FULLSCAN,
    ref: 'attrs/properties/' + ZxBackup.KEY_DO_FULLSCAN,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _ENUM_, id: ZxBackup.KEY_PURGE_CUSTOMIZATIONS,
    ref: 'attrs/properties/' + ZxBackup.KEY_PURGE_CUSTOMIZATIONS,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _ENUM_, id: ZxBackup.KEY_BACKUP_CUSTOMIZATIONS,
    ref: 'attrs/properties/' + ZxBackup.KEY_BACKUP_CUSTOMIZATIONS,
    choices: ZaModel.BOOLEAN_CHOICES1},

  {type: _NUMBER_, id: ZxBackup.KEY_DATA_RETENTION,
    ref: 'attrs/properties/' + ZxBackup.KEY_DATA_RETENTION},
  {type: _STRING_, id: ZxBackup.KEY_REALTIME,
    ref: 'attrs/properties/' + ZxBackup.KEY_REALTIME},

  {type: _LIST_, id: ZxBackup.KEY_COSLIST_ENABLED,
    ref: 'attrs/coslist/' + ZxBackup.KEY_COSLIST_ENABLED},
  {type: _LIST_, id: ZxBackup.KEY_COSLIST_DISABLED,
    ref: 'attrs/coslist/' + ZxBackup.KEY_COSLIST_DISABLED},

  {type: _STRING_, id: ZxBackup.KEY_STAT_SMART_ZXVERSION,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_ZXVERSION},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_SMART_NUM_ACTIVE_ACCOUNTS,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_ACTIVE_ACCOUNTS},
  {type: _STRING_, id: ZxBackup.KEY_STAT_SMART_ZVERSION,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_ZVERSION},
  {type: _DATE_, id: ZxBackup.KEY_STAT_SMART_FIRST_SCAN,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_FIRST_SCAN},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_SMART_NUM_DELETED_ACCOUNTS,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_DELETED_ACCOUNTS},
  {type: _DATE_, id: ZxBackup.KEY_STAT_SMART_LAST_SMARTSCAN,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_LAST_SMARTSCAN},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_PURGE_NUM_PURGED_ACCOUNTS,
    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_NUM_PURGED_ACCOUNTS},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_PURGE_NUM_PURGED_ITEMS,
    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_NUM_PURGED_ITEMS},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_FULL_NUM_TOAL_ACCOUNTS,
    ref: 'attrs/' + ZxBackup.KEY_STAT_FULL_NUM_TOAL_ACCOUNTS},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_PURGE_NUM_PURGED_FILES,
    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_NUM_PURGED_FILES},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_FULL_NUM_BACKUPPED_ITEMS,
    ref: 'attrs/' + ZxBackup.KEY_STAT_FULL_NUM_BACKUPPED_ITEMS},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_FULL_NUM_DELETED_FILES,
    ref: 'attrs/' + ZxBackup.KEY_STAT_FULL_NUM_DELETED_FILES},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_PURGE_PROCESSED_ITEMS_PER_SECOND,
    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_PROCESSED_ITEMS_PER_SECOND},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_SMART_PROCESSED_ITEMS_PER_SECOND,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_PROCESSED_ITEMS_PER_SECOND},

  {type: _STRING_, id: ZxBackup.KEY_STAT_SMART_ZXVERSION,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_ZXVERSION},
  {type: _STRING_, id: ZxBackup.KEY_STAT_SMART_ZVERSION,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_ZVERSION},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_SMART_NUM_BACKUPPED_ITEMS,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_BACKUPPED_ITEMS},
  {type: _NUMBER_, id: ZxBackup.KEY_STAT_SMART_NUM_DELETED_ITEMS,
    ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_DELETED_ITEMS},

  {type: _ENUM_, id: ZxBackup.KEY_PATH_EMPTY,
    ref: 'attrs/' + ZxBackup.KEY_PATH_EMPTY,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _ENUM_, id: ZxBackup.KEY_PATH_EXISTS,
    ref: 'attrs/' + ZxBackup.KEY_PATH_EXISTS,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _ENUM_, id: ZxBackup.KEY_PATH_READABLE,
    ref: 'attrs/' + ZxBackup.KEY_PATH_READABLE,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _ENUM_, id: ZxBackup.KEY_PATH_VALID,
    ref: 'attrs/' + ZxBackup.KEY_PATH_VALID,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _ENUM_, id: ZxBackup.KEY_PATH_WRITABLE,
    ref: 'attrs/' + ZxBackup.KEY_PATH_WRITABLE,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _ENUM_, id: ZxBackup.KEY_PATH_CASE_SENSITIVE,
    ref: 'attrs/' + ZxBackup.KEY_PATH_CASE_SENSITIVE,
    choices: ZaModel.BOOLEAN_CHOICES1},
  {type: _ENUM_, id: ZxBackup.KEY_PATH_LOCK_OK,
    ref: 'attrs/' + ZxBackup.KEY_PATH_LOCK_OK,
    choices: ZaModel.BOOLEAN_CHOICES1}
];
