/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxBackupOperations() {
}

ZaOperation.ZX_RESTORE = ++ZA_OP_INDEX;
ZaOperation.ZX_RESTORE_ON_NEW = ++ZA_OP_INDEX;
ZaOperation.ZX_RESTORE_FROM_LIST = ++ZA_OP_INDEX;

ZxBackupOperations.doUndelete = function() {
  var restore = new ZaOperation(
    ZaOperation.ZX_RESTORE,
    zxMsg('LBL_BCK_restore'),
    zxMsg('LBL_BCK_restore'),
    'ZxRestore',
    'ZxRestore',
    new AjxListener(this, function() {
      var item = ZeXtras.getModuleItem('ZxBackup', this._currentObject.attrs[ZaAccount.A_mailHost]);
      item.doUndelete(this._currentObject);
    })
  );

  if (this._popupOperations) {
    this._popupOperations[ZaOperation.ZX_RESTORE] = restore;
  }

  if (this._toolbarOperations) {
    this._toolbarOperations[ZaOperation.ZX_RESTORE] = restore;
    this._toolbarOrder.push(ZaOperation.ZX_RESTORE);
  }
};

ZxBackupOperations.doUndeleteFromList = function() {
  var restoreFromAccountList = new ZaOperation(
    ZaOperation.ZX_RESTORE_FROM_LIST,
    zxMsg('LBL_BCK_restore'),
    zxMsg('LBL_BCK_restore'),
    'ZxRestore',
    'ZxRestore',
    new AjxListener(this, function() {
      var item,
        account,
        selection = this._contentView.getSelection();

      if (!selection || selection.length !== 1) {
        return;
      }
      account = selection[0];
      if (account.type !== ZaItem.ACCOUNT && account.type !== ZaItem.RESOURCE) {
        return;
      }

      item = ZeXtras.getModuleItem('ZxBackup', account.attrs[ZaAccount.A_mailHost]);
      item.doUndelete(account);
    })
  );

  if (this._popupOperations) {
    this._popupOperations[ZaOperation.ZX_RESTORE_FROM_LIST] = restoreFromAccountList;
  }

  if (this._toolbarOperations && this._toolbarOrder) {
    this._toolbarOperations[ZaOperation.ZX_RESTORE_FROM_LIST] = restoreFromAccountList;

    if (this._defaultType === ZaItem.ACCOUNT || this._defaultType === ZaItem.RESOURCE) {
      this._toolbarOrder.push(ZaOperation.ZX_RESTORE_FROM_LIST);
    }
  }
};
