/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxBackupToolbarModifier() {
  if (ZaController.initToolbarMethods['ZaAccountListController']) {
    ZaController.initToolbarMethods.ZaAccountListController.push(
      ZxBackupOperations.doUndeleteFromList
    );
  }
  if (ZaController.initToolbarMethods['ZaAccountViewController']) {
    ZaController.initToolbarMethods.ZaAccountViewController.push(
      ZxBackupOperations.doUndelete
    );
  }
  if (ZaController.initToolbarMethods['ZaResourceController']) {
    ZaController.initToolbarMethods.ZaResourceController.push(
      ZxBackupOperations.doUndelete
    );
  }
  if (ZaController.initToolbarMethods['ZaSearchListController']) {
    ZaController.initToolbarMethods.ZaSearchListController.push(
      ZxBackupOperations.doUndeleteFromList
    );
  }
  if (ZaController.changeActionsStateMethods['ZaAccountListController']) {
    ZaController.changeActionsStateMethods.ZaAccountListController.push(
      ZxBackupToolbarModifier.onSelectionChange
    );
  }
  if (ZaController.changeActionsStateMethods['ZaSearchListController']) {
    ZaController.changeActionsStateMethods.ZaSearchListController.push(
      ZxBackupToolbarModifier.onSelectionChange
    );
  }
}

ZxBackupToolbarModifier.onSelectionChange = function() {
  var count = this._contentView.getSelectionCount(),
    toolbarOperation,
    popupOperation;

  if (typeof this._toolbarOperations !== 'undefined') {
    if (this._toolbarOperations[ZaOperation.ZX_RESTORE_FROM_LIST]) {
      toolbarOperation = this._toolbarOperations[ZaOperation.ZX_RESTORE_FROM_LIST];
      toolbarOperation.enabled = count === 1;
      if (this._toolbar.getButton(toolbarOperation.id)) {
        this._toolbar.getButton(toolbarOperation.id).setEnabled(toolbarOperation.enabled);
      }
    }

    if (this._toolbarOperations[ZaOperation.ZX_RESTORE_FROM_LIST]) {
      toolbarOperation = this._toolbarOperations[ZaOperation.ZX_RESTORE_FROM_LIST];
      toolbarOperation.enabled = count === 1;
      if (this._toolbar.getButton(toolbarOperation.id)) {
        this._toolbar.getButton(toolbarOperation.id).setEnabled(toolbarOperation.enabled);
      }
    }

    if (this._toolbarOperations[ZaOperation.ZX_RESTORE_ON_NEW]) {
      toolbarOperation = this._toolbarOperations[ZaOperation.ZX_RESTORE_ON_NEW];
      toolbarOperation.enabled = count === 1;
      if (this._toolbar.getButton(toolbarOperation.id)) {
        this._toolbar.getButton(toolbarOperation.id).setEnabled(toolbarOperation.enabled);
      }
    }
  }

  if (typeof this._popupOperations !== 'undefined') {
    if (this._popupOperations[ZaOperation.ZX_RESTORE_FROM_LIST]) {
      popupOperation = this._popupOperations[ZaOperation.ZX_RESTORE_FROM_LIST];
      popupOperation.enabled = count === 1;
    }
  }
};
