/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */
var ZxBackupXFormItem = [
  {
    type: _GROUP_,
    cssClass: 'ZmSelectedHeaderBg',
    colSpan: '*',
    id: 'xform_header',
    items: [
      {
        type: _GROUP_,
        cssClass: 'ZxBackupSpacer',
        numCols: 3,
        width: '100%',
        colSizes: ['160px', '*', '410px'],
        items: [
          { type: _CELL_SPACER_ },
          {
            type: _OUTPUT_,
            ref: 'name',
            valign: _TOP_,
            cssClass: 'AdminTitle'
          },
          {
            type: _GROUP_,
            width: 410,
            numCols: 2,
            items: [
              {
                type: _GROUP_,
                width: 200,
                numCols: 1,
                items: [
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_Run_something', ['Smartscan']),
                    width: 200,
                    align: _LEFT_,
                    toolTipContent: zxMsg('MSG_BCK_Smartscan_button_tooltip'),
                    onActivate: ZxBackup.doStartSmartScan,
                    icon: 'Properties',
                    visibilityChecks: [ZxBackup.checkInitialized],
                    visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID],
                    enableDisableChecks: [ZxBackup.checkInitialized],
                    enableDisableChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID]
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_Run_something', ['Purge']),
                    width: 200,
                    cssStyle: 'margin-top:5px',
                    align: _LEFT_,
                    toolTipContent: zxMsg('MSG_BCK_Purge_button_tooltip'),
                    onActivate: ZxBackup.doStartPurge,
                    icon: 'SearchAll',
                    visibilityChecks: [ZxBackup.checkInitialized],
                    visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID],
                    enableDisableChecks: [ZxBackup.checkInitialized],
                    enableDisableChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID]
                  }
                ]
              },
              {
                type: _GROUP_,
                width: 200,
                numCols: 1,
                items: [
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_BCK_Restore_deleted_accounts'),
                    width: 200,
                    align: _LEFT_,
                    toolTipContent: zxMsg('LBL_BCK_Restore_deleted_accounts'),
                    onActivate: ZxBackup.doRestoreDeletedAccount,
                    icon: 'ZxBackup',
                    visibilityChecks: [ZxBackup.checkInitialized],
                    visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID],
                    enableDisableChecks: [ZxBackup.checkInitialized],
                    enableDisableChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID]
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_BCK_Initialize_now'),
                    width: 200,
                    align: _LEFT_,
                    toolTipContent: zxMsg('MSG_BCK_Initialize_button_tooltip'),
                    onActivate: ZxBackup.doStartSmartScanInitBackup,
                    icon: 'MigrationWiz',
                    visibilityChecks: [ZxBackup.checkNotInitialized],
                    visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID],
                    enableDisableChecks: [ZxBackup.checkInitialize, ZxBackup.checkNotInitialized],
                    enableDisableChangeEventSources: [
                        'attrs/' + ZxBackup.KEY_PATH_VALID,
                        'attrs/' + ZxBackup.KEY_STAT_SMART_FIRST_SCAN
                    ]
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_BCK_Stop_operations'),
                    toolTipContent: zxMsg('LBL_BCK_Stop_operations_tooltip'),
                    width: 200,
                    cssStyle: 'margin-top:5px',
                    align: _LEFT_,
                    onActivate: ZxBackup.doStopAllOperations,
                    icon: 'Cancel'
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSpan: 2,
    width: '100%',
    colSizes: ['100%'],
    items: [
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        ref: 'attrs/' + ZxBackup.KEY_PATH_WRITABLE,
        visibilityChecks: [ZxBackup.checkPathNotWritable],
        visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_WRITABLE],
        bmolsnr: true,
        getDisplayValue: function(newVal) {
          return zxMsg('MSG_BCK_path_not_readable_writable');
        },
        style: DwtAlert.WARNING,
        iconVisible: true
      },
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        ref: 'attrs/' + ZxBackup.KEY_PATH_CASE_SENSITIVE,
        visibilityChecks: [ZxBackup.checkCaseInSensitive],
        visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_CASE_SENSITIVE],
        bmolsnr: true,
        getDisplayValue: function(newVal) {
          return zxMsg(
            'MSG_BCK_Backup_destination_is_case_insensitive',
            ['<a href="' + ZxLinks.BCK_Case_insensitive_info + '">',
              '</a>']
          );
        },
        style: DwtAlert.WARNING,
        iconVisible: true
      },
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        ref: 'attrs/' + ZxBackup.KEY_PATH_VALID,
        visibilityChecks: [ZxBackup.checkNotInitialized],
        visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID],
        bmolsnr: true,
        getDisplayValue: function(newVal) {
          return zxMsg(
            'MSG_BCK_Backup_path_not_initialized',
            [
              '<a href="' + ZxLinks.BCK_BackupFirstInitialization + '" target="_blank">', '</a>',
              '<a href="' + ZxLinks.BCK_BackupNotAvailable + '" target="_blank">', '</a>'
            ]
          );
        },
        style: DwtAlert.WARNING,
        iconVisible: true
      },
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        ref: 'attrs/' + ZxBackup.KEY_PATH_VALID,
        visibilityChecks: [ZxBackup.checkDontInitialize],
        visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID],
        bmolsnr: true,
        getDisplayValue: function(newVal) {
          return zxMsg('MSG_BCK_Backup_path_being_initialized');
        },
        style: DwtAlert.WARNING,
        iconVisible: true
      },
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        ref: 'attrs/' + ZxBackup.KEY_PATH_LOCK_OK,
        visibilityChecks: [ZxBackup.checkAlreadyInUse],
        visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID,
          'attrs/' + ZxBackup.KEY_PATH_LOCK_OK],
        bmolsnr: true,
        getDisplayValue: function(newVal) {
          return zxMsg('MSG_BCK_Backup_path_used_by_other_server');
        },
        style: DwtAlert.WARNING,
        iconVisible: true
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSizes: ['100%'],
    tableCssStyle: 'width:100%;overflow:auto;padding-right:15px;padding-left:15px;',
    items: [
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_BCK_Basic_configuration'),
        numCols: 2,
        colSizes: ['50%', '50%'],
        items: [
          {
            type: _GROUP_,
            numCols: 2,
            colSizes: ['*', '*'],
            cssStyle: 'margin-left:10px',
            items: [
              {
                type: _TEXTFIELD_,
                ref: 'attrs/properties/' + ZxBackup.KEY_BACKUP_PATH,
                bmolsnr: true,
                label: zxMsg('LBL_BCK_Backup_path') + ': ',
                labelLocation: _LEFT_,
                width: 200
              },
              {
                type: _TEXTFIELD_,
                ref: 'attrs/properties/' + ZxBackup.KEY_SPACE_THRESHOLD,
                bmolsnr: true,
                label: zxMsg('LBL_BCK_Minimum_space_threshold') + ' (MB):',
                labelLocation: _LEFT_,
                width: '50px',
                onChange: ZxUtils.checkNumber
              },
              {
                type: _CHECKBOX_,
                labelLocation: _LEFT_,
                align: _LEFT_,
                labelCssClass: 'ZxCheckboxLabel',
                ref: 'attrs/properties/' + ZxBackup.KEY_FULLSCAN_SCHEDULING,
                bmolsnr: true,
                label: zxMsg('LBL_BCK_Enable_scheduling') + ': '
              },
              {
                type: _OSELECT1_,
                ref: 'attrs/properties/' + ZxBackup.KEY_FULLSCAN_START_TIME,
                bmolsnr: true,
                label: zxMsg('LBL_BCK_Daily_smartscan_sceduling1') + ': ',
                choices: ZxUtils.HOURS,
                labelLocation: _LEFT_,
                width: '80px',
                cssStyle: 'margin-top: 5px'
              },
              {
                type: _OSELECT1_,
                ref: 'attrs/properties/' + ZxBackup.KEY_FULLSCAN_PURGE_WEEKDAY,
                bmolsnr: true,
                label: zxMsg('LBL_BCK_Daily_smartscan_sceduling2') + ': ',
                choices: ZxUtils.WEEKDAYS,
                labelLocation: _LEFT_,
                cssStyle: 'margin-top: 5px',
                width: '80px'
              },
              {
                type: _CHECKBOX_,
                labelLocation: _LEFT_,
                align: _LEFT_,
                ref: 'attrs/properties/' + ZxBackup.KEY_DO_FULLSCAN,
                labelCssClass: 'ZxCheckboxLabel',
                bmolsnr: true,
                label: zxMsg('LBL_BCK_Do_smartscan_on_startup') + ': '
              },
              {
                type: _CHECKBOX_,
                labelLocation: _LEFT_,
                align: _LEFT_,
                ref: 'attrs/properties/' + ZxBackup.KEY_BACKUP_CUSTOMIZATIONS,
                labelCssClass: 'ZxCheckboxLabel',
                bmolsnr: true,
                label: zxMsg('LBL_BCK_backup_customizations') + ': '
              },
              {
                type: _CHECKBOX_,
                labelLocation: _LEFT_,
                align: _LEFT_,
                ref: 'attrs/properties/' + ZxBackup.KEY_PURGE_CUSTOMIZATIONS,
                labelCssClass: 'ZxCheckboxLabel',
                bmolsnr: true,
                label: zxMsg('LBL_BCK_purge_customizations') + ': ',
                enableDisableChecks: [ZxBackup.isCustomizationBackupEnabled],
                enableDisableChangeEventSources: ['attrs/properties/' + ZxBackup.KEY_BACKUP_CUSTOMIZATIONS]
              }
            ]
          },
          {
            type: _GROUP_,
            numCols: 1,
            width: '100%',
            colSizes: ['100%'],
            items: [
              {
                type: _GROUPER_,
                label: zxMsg('LBL_BCK_Data_retention_policies'),
                numCols: 3,
                colSizes: ['*', '*', '*'],
                items: [
                  {
                    type: _TEXTFIELD_,
                    ref: 'attrs/properties/' + ZxBackup.KEY_DATA_RETENTION,
                    bmolsnr: true,
                    label: zxMsg('LBL_BCK_Data_retention1'),
                    cssStyle: 'font-weight: bold; padding-right: 10px;',
                    onChange: ZxUtils.checkNumber,
                    width: 100
                  },
                  {type: _OUTPUT_, value: zxMsg('LBL_BCK_Data_retention2')}
                ]
              },
              {
                type: _GROUPER_,
                label: zxMsg('LBL_BCK_Real_time_scanner'),
                numCols: 4,
                colSizes: ['*', '*', '*', '*'],
                items: [
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/properties/' + ZxBackup.KEY_REALTIME,
                    bmolsnr: true,
                    label: zxMsg('LBL_BCK_Current_status') + ': ', // TODO: Add translation into getDisplayValue method
                    cssStyle: 'font-weight: bold; padding-right: 10px;'
                  },
                  {
                    id: 'realTimeEnableButton',
                    type: _DWT_BUTTON_,
                    icon: 'ToggleStatus',
                    label: ZaMsg.TBB_Enable,
                    onActivate: ZxBackup.doEnableRealtime,
                    ref: 'attrs/properties/' + ZxBackup.KEY_REALTIME,
                    bmolsnr: true,
                    visibilityChangeEventSources: ['attrs/properties/' + ZxBackup.KEY_REALTIME],
                    visibilityChecks: [function() {
                      return !(this.getInstanceValue() === 'Enabled');
                    }]
                  },
                  {
                    id: 'realTimeDisableButton',
                    type: _DWT_BUTTON_,
                    icon: 'ToggleStatus',
                    label: ZaMsg.TBB_Disable,
                    onActivate: ZxBackup.doDisableRealtime,
                    ref: 'attrs/properties/' + ZxBackup.KEY_REALTIME,
                    bmolsnr: true,
                    visibilityChangeEventSources: ['attrs/properties/' + ZxBackup.KEY_REALTIME],
                    visibilityChecks: [function() {
                      return !(this.getInstanceValue() === 'Disabled');
                    }]
                  }
                ]
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_BCK_COS_Management'),
        numCols: 1,
        colSizes: ['*'],
        items: [
          {
            type: _GROUP_,
            numCols: 3,
            colSizes: ['*', '100', '*'],
            items: [
              {
                type: _ZAWIZ_TOP_GROUPER_,
                label: zxMsg('LBL_BCK_Backup_enabled'),
                colSizes: ['*'],
                numCols: 1,
                valign: _TOP_,
                items: [
                  {
                    type: _ZX_LIST_VIEW_,
                    id: 'enabledCOSList',
                    ref: 'attrs/coslist/' + ZxBackup.KEY_COSLIST_ENABLED,
                    filterEnabled: true
                  }
                ]
              },
              {
                type: _GROUP_,
                colSizes: ['*'],
                numCols: 1,
                cssClass: 'ZxListCenterButtons',
                items: [
                  {
                    type: _DWT_BUTTON_,
                    label: ZaMsg.TBB_Disable + ' &gt;',
                    onActivate: function(ev) {
                      ZxBackup.doEnableDisableBackupForCOS(this.getForm(), ev, 'enabledCOSList', 'disabledCOSList');
                    }
                  },
                  {
                    type: _DWT_BUTTON_,
                    cssStyle: 'margin-top: 10px',
                    label: '&lt; ' + ZaMsg.TBB_Enable,
                    onActivate: function(ev) {
                      ZxBackup.doEnableDisableBackupForCOS(this.getForm(), ev, 'disabledCOSList', 'enabledCOSList');
                    }
                  }
                ]
              },
              {
                type: _ZAWIZ_TOP_GROUPER_,
                label: zxMsg('LBL_BCK_Backup_disabled'),
                valign: _TOP_,
                bmolsnr: true,
                colSizes: ['*'],
                numCols: 1,
                items: [
                  {
                    type: _ZX_LIST_VIEW_,
                    id: 'disabledCOSList',
                    ref: 'attrs/coslist/' + ZxBackup.KEY_COSLIST_DISABLED,
                    filterEnabled: true
                  }
                ]
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_statistics'),
        ref: 'attrs/' + ZxBackup.KEY_PATH_VALID,
        visibilityChecks: [ZxBackup.checkInitialized],
        visibilityChangeEventSources: ['attrs/' + ZxBackup.KEY_PATH_VALID],
        bmolsnr: true,
        numCols: 1,
        colSizes: ['*'],
        items: [
          {
            type: _GROUP_,
            numCols: 2,
            colSizes: ['50%', '50%'],
            width: '100%',
            valign: _TOP_,
            items: [
              {
                type: _GROUPER_,
                label: zxMsg('LBL_BCK_Last_smartscan'),
                numCols: 4,
                valign: _TOP_,
                colSizes: ['25%', '25%', '25%', '25%'],
                items: [
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_LAST_SMARTSCAN,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_Last_smartscan') + ': ',
                        getDisplayValue: function(val) {
                            if (!val) { return ''; }
                            return ZxUtils.computeWordyDateStr(
                                new Date(),
                                val
                            );
                        }
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_FIRST_SCAN,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_system_initialization') + ': ',
                        getDisplayValue: function(val) {
                            if (!val) { return ''; }
                            return ZxUtils.computeWordyDateStr(
                                new Date(),
                                val
                            );
                        }
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_NEW_ACCOUNTS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_new_accounts') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_ACTIVE_ACCOUNTS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_active_accounts') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_SKIPPED_ACCOUNTS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_skipped_accounts') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_UPDATED_ACCOUNTS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_updated_accounts') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_BACKUPPED_ITEMS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_backupped_items') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_DELETED_ACCOUNTS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_deleted_accounts') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_NEW_ITEMS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_new_items') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_UPDATED_ITEMS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_updated_items') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_NUM_DELETED_ITEMS,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_deleted_items') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_ZXVERSION,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_zxversion') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_ZVERSION,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_zversion') + ': '
                    },
                    {
                        type: _OUTPUT_,
                        ref: 'attrs/' + ZxBackup.KEY_STAT_SMART_PROCESSED_ITEMS_PER_SECOND,
                        bmolsnr: true,
                        cssStyle: 'font-weight: bold;',
                        label: zxMsg('LBL_BCK_stat_processed_item_per_second') + ': '
                    }
                ]
              },
              {
                type: _GROUPER_,
                label: zxMsg('LBL_BCK_stat_last_purge'),
                numCols: 4,
                valign: _TOP_,
                colSizes: ['25%', '25%', '25%', '25%'],
                items: [
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_NUM_PURGED_ACCOUNTS,
                    bmolsnr: true,
                    cssStyle: 'font-weight: bold;',
                    label: zxMsg('LBL_BCK_stat_purged_accounts') + ': '
                  },
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_NUM_PURGED_ITEMS,
                    bmolsnr: true,
                    cssStyle: 'font-weight: bold;',
                    label: zxMsg('LBL_BCK_stat_purged_items') + ': '
                  },
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_NUM_PURGED_FILES,
                    bmolsnr: true,
                    cssStyle: 'font-weight: bold;',
                    label: zxMsg('LBL_BCK_stat_purged_files') + ': '
                  },
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_PROCESSED_ITEMS_PER_SECOND,
                    bmolsnr: true,
                    cssStyle: 'font-weight: bold;',
                    label: zxMsg('LBL_BCK_stat_processed_item_per_second') + ': '
                  },
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/' + ZxBackup.KEY_STAT_PURGE_NUM_PURGED_SERVER_CONF,
                    bmolsnr: true,
                    cssStyle: 'font-weight: bold;',
                    label: zxMsg('LBL_BCK_stat_purged_server_conf') + ': '
                  },
                  {type: _OUTPUT_, cssStyle: 'font-weight: bold;', label: ' '},
                  {type: _OUTPUT_, cssStyle: 'font-weight: bold;', label: ' '},
                  {type: _OUTPUT_, cssStyle: 'font-weight: bold;', label: ' '},
                  {type: _OUTPUT_, cssStyle: 'font-weight: bold;', label: ' '},
                  {type: _OUTPUT_, cssStyle: 'font-weight: bold;', label: ' '}
                ]
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_BCK_Import_export'),
        numCols: 2,
        colSizes: [100, 100],
        items: [
          {
            type: _DWT_BUTTON_,
            label: zxMsg('LBL_BCK_Import_bckp'),
            cssStyle: 'margin: 5px',
            icon: 'Migration', //'DuplicateServer',
            onActivate: ZxBackup.doStartImportWizard
          },
          {
            type: _DWT_BUTTON_,
            label: zxMsg('LBL_BCK_Export_bckp'),
            cssStyle: 'margin: 5px',
            icon: 'Backup', //'ApplianceMigration',
            onActivate: ZxBackup.doStartExportWizard
          }
        ]
      }
    ]
  }
];
