/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */
var ZxChatXFormItem = [
  {
    type: _GROUP_,
    cssClass: 'ZmSelectedHeaderBg',
    colSpan: '*',
    id: 'xform_header',
    items: [
      {
        type: _GROUP_,
        cssClass: 'ZxChatSpacer',
        numCols: 2,
        width: '100%',
        colSizes: ['160px', '*'],
        items: [
          { type: _CELL_SPACER_ },
          {
            type: _OUTPUT_,
            ref: 'name',
            valign: _TOP_,
            cssClass: 'AdminTitle'
          }
        ]
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSpan: 2,
    width: '100%',
    colSizes: ['100%'],
    items: [
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        visibilityChecks: [function() { return !(ZxUtils.isZ8Up()); }],
        containerCssStyle: 'font-weight: bolder;color:red;padding-bottom:0px',
        style: DwtAlert.WARNING,
        iconVisible: true,
        content: zxMsg('MSG_CHT_version_not_supported'),
        colSpan: '*'
      },
      {
        type: _DWT_ALERT_,
        ref: 'attrs/info/' + ZxChat.KEY_INFO_ZIMLET_FOUND,
        bmolsnr: true,
        cssClass: 'DwtTabTable',
        visibilityChecks: [ZxChat.checkZimletNotInstalled],
        visibilityChangeEventSources: ['attrs/info/' + ZxChat.KEY_ZIMLET_INSTALLED, 'attrs/info/' + ZxChat.KEY_ZIMLET_ENABLED],
        containerCssStyle: 'padding-bottom:0px',
        style: DwtAlert.WARNING,
        iconVisible: true,
        content: zxMsg(
          'MSG_CHT_zimlet_missing',
          ['<a href="' + ZxLinks.CHT_Installation_Zimlet_Guide + '" target="_blank">', '</a>']
        ),
        colSpan: '*'
      },
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        visibilityChecks: [ZxChat.checkZimletInstalled, ZxChat.checkZimletNotEnabled],
        visibilityChangeEventSources: ['attrs/info/' + ZxChat.KEY_ZIMLET_INSTALLED, 'attrs/info/' + ZxChat.KEY_ZIMLET_ENABLED],
        containerCssStyle: 'padding-bottom:0px',
        style: DwtAlert.WARNING,
        iconVisible: true,
        content: zxMsg('MSG_CHT_zimlet_installed_not_enabled'),
        colSpan: '*'
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSizes: ['*'],
    width: '100%',
    tableCssStyle: 'width:100%;overflow:auto;padding-right:15px;padding-left:15px;',
    items: [
      {
        type: _TOP_GROUPER_,
        label: 'ZxChat Server',
        numCols: 1,
        colSizes: ['*'],
        align: _LEFT_,
        items: [
          {
            type: _ZAWIZ_TOP_GROUPER_,
            label: zxMsg('LBL_DLG_admin_preferences'),
            valign: _TOP_,
            colSizes: ['*'],
            numCols: 1,
            items: [
              {
                type: _GROUP_,
                colSizes: ['*', '*', '*'],
                numCols: 3,
                cssStyle: 'margin: 5px',
                items: [
                  {
                    type: _OUTPUT_,
                    value: zxMsg('LBL_CHT_hazelcast_moved'),
                    colSpan: 2
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_CHT_go_to_global_config'),
                    onActivate: function() {
                      ZeXtras.followMenuItems([
                        ZxMenuIds.CONFIGURE_GLOBAL,
                        ZxMenuIds.CONFIGURE_GLOBAL_ZXCHAT
                      ]);
                    }
                  }
                ]
              }
            ]
          },
          {
            type: _ZAWIZ_TOP_GROUPER_,
            label: zxMsg('LBL_statistics'),
            valign: _TOP_,
            colSizes: ['*'],
            numCols: 1,
            items: [
              {
                type: _GROUP_,
                colSizes: [230, '*'],
                numCols: 2,
                cssStyle: 'margin: 5px',
                items: [
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/stats/' + ZxChat.KEY_STATS_ACTIVE_USER_COUNT,
                    bmolsnr: true,
                    cssStyle: 'font-weight: bold',
                    label: zxMsg('LBL_CHT_users_online') + ': '
                  },
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/stats/' + ZxChat.KEY_STATS_ACTIVE_SESSION_COUNT,
                    bmolsnr: true,
                    cssStyle: 'font-weight: bold',
                    label: zxMsg('LBL_CHT_opened_sessions') + ': '
                  }
                ]
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: 'Zimlet',
        numCols: 1,
        colSizes: ['*'],
        align: _LEFT_,
        items: [
          {
            type: _GROUP_,
            colSizes: [250, '*', '*'],
            numCols: 3,
            cssStyle: 'margin: 5px',
            items: [
              {
                type: _OUTPUT_,
                ref: 'attrs/info/' + ZxChat.KEY_INFO_ZIMLET_VERSION,
                bmolsnr: true,
                cssStyle: 'margin-right: 5px; font-weight: bold',
                label: zxMsg('LBL_CHT_current_version') + ': '
              },
              {
                type: _DWT_BUTTON_,
                label: zxMsg('LBL_COR_update_check'),
                icon: 'Refresh',
                onActivate: ZxChat.doChekUpdates
              },
              {type: _SPACER_, height: 10},
              {
                type: _OUTPUT_,
                ref: 'attrs/info/' + ZxChat.KEY_INFO_ZIMLET_AVAILABLE_VERSION,
                bmolsnr: true,
                cssStyle: 'margin-right: 5px; font-weight: bold',
                label: zxMsg('LBL_COR_update_available_version') + ': '
              },
              {
                type: _DWT_BUTTON_,
                label: zxMsg('LBL_deploy'),
                icon: 'Deploy',
                onActivate: ZxChat.doDeployLatestZimlet,
                enableDisableChangeEventSources: [
                  'attrs/info/' + ZxChat.KEY_INFO_ZIMLET_AVAILABLE_VERSION
                ],
                enableDisableChecks: [
                  function() {
                    var availableVersion = this.getInstanceValue(
                        'attrs/info/' + ZxChat.KEY_INFO_ZIMLET_AVAILABLE_VERSION
                    );
                    try {
                       return Number(availableVersion) > 0;
                    } catch (err) {
                      return false;
                    }
                  }
                ],
                visibilityChecks: [
                  function() {
                    return ZxUtils.isZ7Up();
                  }
                ]
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_CHT_Security_Settings'),
        numCols: 1,
        colSizes: ['*'],
        align: _LEFT_,
        items: [
          {
            type: _GROUP_,
            colSizes: [250, '*'],
            numCols: 2,
            cssStyle: 'margin: 5px',
            items: [
              {
                type: _CHECKBOX_,
                labelLocation: _LEFT_,
                align: _LEFT_,
                labelCssClass: 'ZxCheckboxLabel',
                ref: 'attrs/properties/' + ZxChat.KEY_USE_LEGACY_SSL_PORT,
                bmolsnr: true,
                label: zxMsg('MSG_CHT_Use_Legacy_SSL_Port') + ': '
              },
              {
                type: _CHECKBOX_,
                labelLocation: _LEFT_,
                align: _LEFT_,
                labelCssClass: 'ZxCheckboxLabel',
                ref: 'attrs/properties/' + ZxChat.KEY_ALLOW_UNENCRYPTED_PASSWORD,
                bmolsnr: true,
                label: zxMsg('MSG_CHT_Allow_Unencrypted_password') + ': '
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_CHT_Utilites'),
        numCols: 1,
        colSizes: ['100%'],
        items: [
          {
            type: _ZAWIZ_TOP_GROUPER_,
            label: zxMsg('LBL_CHT_Friendship_users'),
            colSizes: ['*'],
            numCols: 1,
            cssStyle: 'margin: 5px',
            items: [
              {
                type: _GROUP_,
                colSizes: ['*', '*', '*'],
                numCols: 3,
                cssStyle: 'margin: 5px',
                items: [
                  {
                    type: _OUTPUT_,
                    colSpan: 3,
                    value: zxMsg('MSG_CHT_add_all_members_of_distribution_list') + ': '
                  },
                  {
                    type: _DYNSELECT_,
                    id: 'distributionList',
                    ref: 'attr/' + ZxChat.KEY_TMP_DISTRIBUTION_LIST_NAME,
                    label: zxMsg('LBL_Distribution_list'),
                    toolTipContent: ZaMsg.tt_StartTypingDLName,
                    dataFetcherMethod: ZaSearch.prototype.dynSelectSearchGroups,
                    dataFetcherClass: ZaSearch,
                    width: 'auto',
                    cssStyle: 'margin-right: 5px',
                    onChange: function(value, event, form) {
                      if (value instanceof ZaItem) {
                        this.setInstanceValue(value.name);
                      } else {
                        this.setInstanceValue(value);
                      }
                    },
                    keyUp: function(value, event, form) {
                      if (value instanceof ZaItem) {
                        this.setInstanceValue(value.name);
                      } else {
                        this.setInstanceValue(value);
                      }
                    }
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_CHT_connect_group'),
                    onActivate: ZxChat.doConnectGroup
                  }
                ]
              },
              {
                type: _GROUP_,
                colSizes: ['*', '*', '*', '*'],
                numCols: 4,
                cssStyle: 'margin: 5px',
                items: [
                  {
                    type: _OUTPUT_,
                    value: zxMsg('MSG_CHT_add_two_user_as_buddies') + ': ',
                    colSpan: 4
                  },
                  {
                    type: _DYNSELECT_,
                    id: 'firstAccount',
                    ref: 'attr/' + ZxChat.KEY_TMP_FIRST_USER,
                    dataFetcherClass: ZaSearch,
                    dataFetcherMethod: ZaSearch.prototype.dynSelectSearch,
                    dataFetcherTypes: [ZaSearch.ACCOUNTS],
                    dataFetcherAttrs: [
                      ZaItem.A_zimbraId,
                      ZaItem.A_cn,
                      ZaAccount.A_name,
                      ZaAccount.A_displayname,
                      ZaAccount.A_mail
                    ],
                    label: zxMsg('LBL_Accounts'),
                    editable: true,
                    forceUpdate: true,
                    choices: new XFormChoices([], XFormChoices.OBJECT_REFERENCE_LIST, 'name', 'name'),
                    onChange: function(value, event, form) {
                      if (value instanceof ZaItem) {
                        this.setInstanceValue(value.name);
                      } else {
                        this.setInstanceValue(value);
                      }
                    },
                    keyUp: function(value, event, form) {
                      if (value instanceof ZaItem) {
                        this.setInstanceValue(value.name);
                      } else {
                        this.setInstanceValue(value);
                      }
                    },
                    cssStyle: 'margin-right: 5px'
                  },
                  {
                    type: _DYNSELECT_,
                    id: 'secondAccount',
                    ref: 'attr/' + ZxChat.KEY_TMP_SECOND_USER,
                    dataFetcherClass: ZaSearch,
                    dataFetcherMethod: ZaSearch.prototype.dynSelectSearch,
                    dataFetcherTypes: [ZaSearch.ACCOUNTS],
                    dataFetcherAttrs: [
                      ZaItem.A_zimbraId,
                      ZaItem.A_cn,
                      ZaAccount.A_name,
                      ZaAccount.A_displayname,
                      ZaAccount.A_mail
                    ],
                    editable: true,
                    forceUpdate: true,
                    choices: new XFormChoices([], XFormChoices.OBJECT_REFERENCE_LIST, 'name', 'name'),
                    onChange: function(value, event, form) {
                      if (value instanceof ZaItem) {
                        this.setInstanceValue(value.name);
                      } else {
                        this.setInstanceValue(value);
                      }
                    },
                    keyUp: function(value, event, form) {
                      if (value instanceof ZaItem) {
                        this.setInstanceValue(value.name);
                      } else {
                        this.setInstanceValue(value);
                      }
                    },
                    cssStyle: 'margin-right: 5px'
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: zxMsg('LBL_CHT_connect_account'),
                    onActivate: ZxChat.doConnectBuddies
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  }
];
