/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

/**
 * Create the ZxCore object.
 * @constructor
 */
function ZxCore() {
  ZxModule.call(this, ZxCore.MOD_ID, zxMsg('LBL_ZxCore'), 'ZxCore');

  this.registerLoadMethod(this.loadMethod, 'ZxCoreInit');
  this.registerModifyMethod(this.modifyMethod, 'ZxCoreInit');

  this._helpURL = ZxLinks.HELP_COR_Core;

  this.attrs[ZxModule.KEY_ENABLED_ON_STARTUP] = true;
  this.attrs[ZxModule.KEY_RUNNING] = true;
}

ZxCore.prototype = new ZxModule();
ZxCore.prototype.constructor = ZxCore;
ZxCore.MOD_ID = 'ZxCore';

ZxCore.KEY_NOTIFICATION_TO = 'ZxCore_NTMail';
ZxCore.KEY_NOTIFICATION_FROM = 'ZxCore_NTMailFrom';
ZxCore.KEY_NOTIFICATION_LICENSE_ADDITIONAL = 'ZxCore_LicenseWarningRecipients';
ZxCore.KEY_NOTIFICATION_LEVEL = 'ZxCore_NTLevel';
ZxCore.KEY_OVERRIDE_NE_MOBILE = "ZxCore_OverrideNEMobile";
ZxCore.KEY_OVERRIDE_NE_POWERSTORE = "ZxPowerstore_EnableHsmOnNe";
ZxCore.KEY_LOG_LEVEL = 'ZxCore_LogLevel';
ZxCore.KEY_NOTIFY_UPDATES = 'ZxCore_NotifyUpdates';
ZxCore.KEY_UPDATE_AVAILABLE = 'updateAvailable';
ZxCore.KEY_UPDATE_CURRENT_VERSION = 'currentVersion';
ZxCore.KEY_UPDATE_CURRENT_COMMIT = 'currentCommit';
ZxCore.KEY_UPDATE_AVAILABLE_COMMIT = 'availableCommit';
ZxCore.KEY_UPDATE_LAST_UPDATE = 'lastUpdate';
ZxCore.KEY_LICENSE_STATUS = 'status';
ZxCore.KEY_LICENSE_TYPE = 'type';
ZxCore.KEY_LICENSE_TYPE_ISP_V2 = 'ispLegacy';
ZxCore.KEY_LICENSE_COMPANY = 'company';
ZxCore.KEY_LICENSE_RESELLER = 'reseller';
ZxCore.KEY_LICENSE_CUSTOMER = 'customer';
ZxCore.KEY_LICENSE_DATE_START = 'dateStart';
ZxCore.KEY_LICENSE_DATE_START_TEXT = 'dateStart_TEXT';
ZxCore.KEY_LICENSE_DATE_END = 'dateEnd';
ZxCore.KEY_LICENSE_DATE_END_TEXT = 'dateEnd_TEXT';
ZxCore.KEY_LICENSE_MAINTENANCE_END_TEXT = 'maintenanceEnd_TEXT';
ZxCore.KEY_LICENSE_ORDER_ID = 'order_id';
ZxCore.KEY_LICENSE_SERVER_ID = 'serverID';
ZxCore.KEY_LICENSE_LAST_VALIDATION = 'lastLicenseValidation';
ZxCore.KEY_LICENSE_RENEW_TIME_LEFT = 'renewTimeLeft';
ZxCore.KEY_LICENSE_HIDE_RENEW_TIME_LEFT = 'hideRenewTimeLeft';
ZxCore.KEY_LICENSE_LICENSED_USER = 'licensedUsers';
ZxCore.KEY_LICENSE_LICENSED_USER_TEXT = 'licensed_users_text';
ZxCore.KEY_LICENSE_COUNT_RESOURCE = 'resourceCount';
ZxCore.KEY_LICENSE_COUNT_ACCOUNT = 'accountCount';
ZxCore.KEY_LICENSE_COUNT_ACCOUNT_TEXT = 'accountCountText';
ZxCore.KEY_LICENSE_COUNT_TOTAL = 'accountTotal';
ZxCore.KEY_LICENSE_ZIMBRA_VERSION = 'zimbraVersion';
ZxCore.KEY_LICENSE_EXPIRED = 'expired';
ZxCore.KEY_LICENSE_NOT_YET_VALID = 'notYetValid';
ZxCore.KEY_LICENSE_ZXADMIN = 'ZxAdmin';
ZxCore.KEY_LICENSE_ZXBACKUP = 'ZxBackup';
ZxCore.KEY_LICENSE_ZXCHAT = 'ZxChat';
ZxCore.KEY_LICENSE_ZXMOBILE = 'ZxMobile';
ZxCore.KEY_LICENSE_ZXPOWERSTORE = 'ZxPowerstore';
ZxCore.KEY_MOBILE_HANDLER_REGISTERED = 'mobileHandlerRegistered';
ZxCore.KEY_RUNNING_MODS = 'modsRunning';
ZxCore.KEY_ENABLED_ON_STARTUP_MODS = 'modsEnabledStartup';
ZxCore.KEY_SEND_FULL_ERROR_REPORTS = 'ZxCore_SendFullErrorReports';
ZxCore.KEY_CLIENT_ZIMLET_DEPLOYED = 'isClientZimletDeployed';

ZxCore.ClientUploadFormId = 'ZxCoreLicenseFileSelector';

ZxCore.UPLOAD_STATUS_PROGRESS = 1;
ZxCore.UPLOAD_STATUS = 'uploadStatus';

ZxCore.LogLevels = [
  {value: 0, label: zxMsg('LBL_LVL_debug')},
  {value: 1, label: zxMsg('LBL_LVL_information')},
  {value: 2, label: zxMsg('LBL_LVL_warning')},
  {value: 3, label: zxMsg('LBL_LVL_error')},
  {value: 4, label: zxMsg('LBL_LVL_critical')}
];

ZxCore.prototype.loadMethod = function(by, val) {
// ZxUtils.log(arguments, 'Called load method');
  this.attrs[ZxCore.KEY_MOBILE_HANDLER_REGISTERED] = false;
  this.attrs[ZxModule.KEY_ENABLED_ON_STARTUP] = true;
  this.attrs[ZxModule.KEY_RUNNING] = true;

  this.attrs.properties = {};
  this.attrs.properties[ZxCore.KEY_NOTIFY_UPDATES] = 'FALSE';
  this.attrs.properties[ZxCore.KEY_OVERRIDE_NE_MOBILE] = false;
  this.attrs.properties[ZxCore.KEY_NOTIFICATION_FROM] = ZaMsg.splashScreenLoading;
  this.attrs.properties[ZxCore.KEY_NOTIFICATION_TO] = ZaMsg.splashScreenLoading;
  this.attrs.properties[ZxCore.KEY_NOTIFICATION_LICENSE_ADDITIONAL] = ZaMsg.splashScreenLoading;
  this.attrs.properties[ZxCore.KEY_NOTIFICATION_LEVEL] = 0;
  this.attrs.properties[ZxCore.KEY_LOG_LEVEL] = 0;
  this.attrs.properties[ZxCore.KEY_OVERRIDE_NE_POWERSTORE] = false;
  this.attrs.properties[ZxCore.KEY_SEND_FULL_ERROR_REPORTS] = false;

  this.attrs.updateinfo = {};
  this.attrs.updateinfo[ZxCore.KEY_UPDATE_AVAILABLE] = ZaMsg.splashScreenLoading;
  this.attrs.updateinfo[ZxCore.KEY_UPDATE_CURRENT_VERSION] = ZaMsg.splashScreenLoading;
  this.attrs.updateinfo[ZxCore.KEY_UPDATE_LAST_UPDATE] = ZaMsg.splashScreenLoading;

  this.attrs.statuses = {};
  this.attrs.statuses[ZxCore.KEY_LICENSE_ZXMOBILE] = false;

  this.attrs.license = {};
  this.attrs.license[ZxCore.KEY_LICENSE_COMPANY] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_CUSTOMER] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_RESELLER] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_DATE_START] = new Date(0);
  this.attrs.license[ZxCore.KEY_LICENSE_DATE_END] = new Date(0);
  this.attrs.license[ZxCore.KEY_LICENSE_EXPIRED] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_NOT_YET_VALID] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_ORDER_ID] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_LICENSED_USER] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_COUNT_ACCOUNT] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_COUNT_RESOURCE] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_TYPE] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_TYPE_ISP_V2] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_ZIMBRA_VERSION] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_SERVER_ID] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_LAST_VALIDATION] = new Date(0);
  this.attrs.license[ZxCore.KEY_LICENSE_RENEW_TIME_LEFT] = 0;
  this.attrs.license[ZxCore.KEY_LICENSE_HIDE_RENEW_TIME_LEFT] = true;

  this.attrs.license.modules = {};
  this.attrs.license.modules[ZxCore.KEY_LICENSE_ZXADMIN] = false;
  this.attrs.license.modules[ZxCore.KEY_LICENSE_ZXBACKUP] = false;
  this.attrs.license.modules[ZxCore.KEY_LICENSE_ZXCHAT] = false;
  this.attrs.license.modules[ZxCore.KEY_LICENSE_ZXMOBILE] = false;
  this.attrs.license.modules[ZxCore.KEY_LICENSE_ZXPOWERSTORE] = false;

  this.attrs.license[ZxCore.KEY_LICENSE_STATUS] = ZaMsg.splashScreenLoading;

  this.attrs.license[ZxCore.KEY_LICENSE_DATE_START_TEXT] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_DATE_END_TEXT] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_MAINTENANCE_END_TEXT] = ZaMsg.splashScreenLoading;

  this.attrs.license[ZxCore.KEY_LICENSE_COUNT_TOTAL] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_LICENSED_USER_TEXT] = ZaMsg.splashScreenLoading;
  this.attrs.license[ZxCore.KEY_LICENSE_COUNT_ACCOUNT_TEXT] = ZaMsg.splashScreenLoading;

  this.attrs[ZxCore.KEY_RUNNING_MODS] = {};
  this.attrs[ZxCore.KEY_RUNNING_MODS][ZxCore.KEY_LICENSE_ZXADMIN] = null;
  this.attrs[ZxCore.KEY_RUNNING_MODS][ZxCore.KEY_LICENSE_ZXBACKUP] = null;
  this.attrs[ZxCore.KEY_RUNNING_MODS][ZxCore.KEY_LICENSE_ZXCHAT] = null;
  this.attrs[ZxCore.KEY_RUNNING_MODS][ZxCore.KEY_LICENSE_ZXMOBILE] = null;
  this.attrs[ZxCore.KEY_RUNNING_MODS][ZxCore.KEY_LICENSE_ZXPOWERSTORE] = null;

  this.attrs[ZxCore.KEY_ENABLED_ON_STARTUP_MODS] = {};
  this.attrs[ZxCore.KEY_ENABLED_ON_STARTUP_MODS][ZxCore.KEY_LICENSE_ZXADMIN] = false;
  this.attrs[ZxCore.KEY_ENABLED_ON_STARTUP_MODS][ZxCore.KEY_LICENSE_ZXBACKUP] = false;
  this.attrs[ZxCore.KEY_ENABLED_ON_STARTUP_MODS][ZxCore.KEY_LICENSE_ZXCHAT] = false;
  this.attrs[ZxCore.KEY_ENABLED_ON_STARTUP_MODS][ZxCore.KEY_LICENSE_ZXMOBILE] = false;
  this.attrs[ZxCore.KEY_ENABLED_ON_STARTUP_MODS][ZxCore.KEY_LICENSE_ZXPOWERSTORE] = false;

  this.attrs[ZxCore.KEY_CLIENT_ZIMLET_DEPLOYED] = false;

  var controller = this.getCurrentController(),
    server = this.getCurrentServer(),
    zxLicense = ZeXtras.getLicense();

  if (controller) {
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COMPANY, zxLicense.getCompany(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_CUSTOMER, zxLicense.getCustomer(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_RESELLER, zxLicense.getReseller(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_DATE_START, zxLicense.getDateStart(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_DATE_END, zxLicense.getDateEnd(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_EXPIRED, zxLicense.isExpired(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_NOT_YET_VALID, zxLicense.isNotYetValid(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_ORDER_ID, zxLicense.getOrderID(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_LICENSED_USER, zxLicense.getLicensedUsers(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_ACCOUNT, zxLicense.getCountAccount(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_RESOURCE, zxLicense.getCountResource(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_TYPE, zxLicense.getType(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_TYPE_ISP_V2, zxLicense.isISPV2(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_SERVER_ID, zxLicense.getServerID(server));

    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_TOTAL,
      zxLicense.getCountAccount(server) + zxLicense.getCountResource(server));

    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_ZIMBRA_VERSION,
      (zxLicense.getLicensedZimbraVersion(server) || ''));

    controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXADMIN,
      zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXADMIN].licensed);
    controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXBACKUP,
      zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXBACKUP].licensed);
    controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXCHAT,
      zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXCHAT].licensed);
    controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXMOBILE,
      zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXMOBILE].licensed);
    controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXPOWERSTORE,
      zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].licensed);

    if (ZaSettings.isNetworkVersion()) {
      var enabled = zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].enabledOnNE &&
        zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].enabled;
      controller.setInstanceValue('statuses/' + ZxCore.KEY_LICENSE_ZXPOWERSTORE, enabled);
    } else {
      controller.setInstanceValue('statuses/' + ZxCore.KEY_LICENSE_ZXPOWERSTORE,
        zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].enabled);
    }

    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_DATE_START_TEXT,
      ZxUtils.UTCDateString(zxLicense.getDateStart(server), zxMsg('LBL_Unlimited')));

    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_DATE_END_TEXT,
      ZxUtils.UTCDateString(zxLicense.getDateEnd(server), zxMsg('LBL_Unlimited')));

    if (zxLicense.getType(server) === ZxLicense.LICENSE_PERPETUAL_V2) {
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_MAINTENANCE_END_TEXT,
        ZxUtils.UTCDateString(zxLicense.getDateEndMaintenance(server), zxMsg('LBL_Unlimited')));
    }

    controller.setInstanceValue('properties/' + ZxCore.KEY_OVERRIDE_NE_POWERSTORE,
      zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].enabledOnNE);

    if( zxLicense.isEmptyLicense(server) ) {
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS, zxMsg('LBL_Unlicensed'));
    } else if (zxLicense.isNotYetValid(server)) {
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS,
        '<span style="color:red;">' + zxMsg('LBL_NotYetValid') + '</span>');
    } else if (zxLicense.isExpired(server)) {
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS,
        '<span style="color:red;">' + zxMsg('LBL_Expired') + '</span>');
    } else if ((zxLicense.isUserExceeded(server) && (zxLicense.isPurchased(server) || zxLicense.isPerpetual(server)))) {
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS,
        '<span style="color:red;">' + zxMsg('LBL_undersized') + '</span>' +
        ' <a href="' + ZxLinks.COR_License_how_work + '" style="font-size:9" target="_blank">' +
        '(' + zxMsg('LBL_more_info') + ')</a>');
    } else {
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS, zxMsg('LBL_Valid'));
    }

    if (zxLicense.isUserExceeded(server) && (zxLicense.isPurchased(server) || zxLicense.isPerpetual(server))) {
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_LICENSED_USER_TEXT,
        '<span style="color:red;">' + this.attrs.license[ZxCore.KEY_LICENSE_LICENSED_USER] + '</span>');
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_ACCOUNT_TEXT,
        '<span style="color:red;">' + this.attrs.license[ZxCore.KEY_LICENSE_COUNT_ACCOUNT] + '</span>');

    } else {
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_LICENSED_USER_TEXT,
        zxLicense.getLicensedUsers(server));
      controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_ACCOUNT_TEXT,
        zxLicense.getCountAccount(server));

    }
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_LAST_VALIDATION,
      zxLicense.getLastValidation(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_RENEW_TIME_LEFT,
      zxLicense.getRenewTimeLeft(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_HIDE_RENEW_TIME_LEFT,
      zxLicense.hideRenewTimeLeft(server));
  }

  ZxAdminRequest.sendRequest(
    this.getCurrentServer(),
    'ZxCore',
    'getPublicProperties',
    {}
  ).then(
    AjxCallback.simpleClosure(
      function(resp) {
        // ZxUtils.log(resp, 'Response for ZxCore.getPublicProperties()');
        var response = resp.response,
          controller = this.getCurrentController();

        this.attrs.properties[ZxCore.KEY_NOTIFICATION_FROM] = response.properties[ZxCore.KEY_NOTIFICATION_FROM];
        this.attrs.properties[ZxCore.KEY_NOTIFICATION_TO] = response.properties[ZxCore.KEY_NOTIFICATION_TO];
        this.attrs.properties[ZxCore.KEY_NOTIFICATION_LEVEL] = response.properties[ZxCore.KEY_NOTIFICATION_LEVEL];
        this.attrs.properties[ZxCore.KEY_LOG_LEVEL] = response.properties[ZxCore.KEY_LOG_LEVEL];
        this.attrs.properties[ZxCore.KEY_NOTIFY_UPDATES] =
          (response.properties[ZxCore.KEY_NOTIFY_UPDATES] === 'true');
        this.attrs.properties[ZxCore.KEY_OVERRIDE_NE_MOBILE] =
          response.properties[ZxCore.KEY_OVERRIDE_NE_MOBILE] === 'false';
        this.attrs.properties[ZxCore.KEY_NOTIFICATION_LICENSE_ADDITIONAL] =
          response.properties[ZxCore.KEY_NOTIFICATION_LICENSE_ADDITIONAL];
        this.attrs.properties[ZxCore.KEY_SEND_FULL_ERROR_REPORTS] =
          (response.properties[ZxCore.KEY_SEND_FULL_ERROR_REPORTS] === 'true');

        this.attrs[ZxModule.KEY_ENABLED_ON_STARTUP] = true;
        this.attrs[ZxModule.KEY_RUNNING] = true;

        controller.setInstanceValue(
          'properties/' + ZxCore.KEY_NOTIFICATION_FROM,
          response.properties[ZxCore.KEY_NOTIFICATION_FROM]
        );
        controller.setInstanceValue(
          'properties/' + ZxCore.KEY_NOTIFICATION_TO,
          response.properties[ZxCore.KEY_NOTIFICATION_TO]
        );
        controller.setInstanceValue(
          'properties/' + ZxCore.KEY_NOTIFICATION_LEVEL,
          response.properties[ZxCore.KEY_NOTIFICATION_LEVEL]
        );
        controller.setInstanceValue(
          'properties/' + ZxCore.KEY_LOG_LEVEL,
          response.properties[ZxCore.KEY_LOG_LEVEL]
        );
        controller.setInstanceValue(
          'properties/' + ZxCore.KEY_NOTIFY_UPDATES,
          (response.properties[ZxCore.KEY_NOTIFY_UPDATES] === 'true')
        );
        controller.setInstanceValue(
          'properties/' + ZxCore.KEY_OVERRIDE_NE_MOBILE,
          (response.properties[ZxCore.KEY_OVERRIDE_NE_MOBILE] === 'false')
        );
        controller.setInstanceValue(
          'properties/' + ZxCore.KEY_NOTIFICATION_LICENSE_ADDITIONAL,
          response.properties[ZxCore.KEY_NOTIFICATION_LICENSE_ADDITIONAL]
        );
        controller.setInstanceValue(
          'properties/' + ZxCore.KEY_SEND_FULL_ERROR_REPORTS,
          (response.properties[ZxCore.KEY_SEND_FULL_ERROR_REPORTS] === 'true')
        );

        controller.setInstanceValue(
          'attrs/' + ZxModule.KEY_ENABLED_ON_STARTUP,
          true
        );
        controller.setInstanceValue(
          'attrs/' + ZxModule.KEY_RUNNING,
          true
        );
      },
      this
    ),
    this._getDefaultCatchErrorFcn()
  );

  ZxAdminRequest.sendRequest(
    this.getCurrentServer(),
    'ZxCore',
    'getUpdateInfo'
  ).then(
    AjxCallback.simpleClosure(
      function(resp) {
        // ZxUtils.log(resp, 'Response for ZxCore.getLicenseInfo()');
        var response = resp.response,
          controller = this.getCurrentController();

        this.attrs.updateinfo[ZxCore.KEY_UPDATE_AVAILABLE] = response.availableVersion;
        this.attrs.updateinfo[ZxCore.KEY_UPDATE_AVAILABLE_COMMIT] = response.availableCommit;

        if (Number(response.lastUpdate) == 0) {
          this.attrs.updateinfo[ZxCore.KEY_UPDATE_LAST_UPDATE] = zxMsg('MSG_COR_checkupdate_none');
          controller.setInstanceValue(
            'updateinfo/' + ZxCore.KEY_UPDATE_LAST_UPDATE,
            zxMsg('MSG_COR_checkupdate_none')
          );
        }
        else {
          this.attrs.updateinfo[ZxCore.KEY_UPDATE_LAST_UPDATE] = ZxUtils.computeWordyDateStr(
            new Date(),
            Number(response.lastUpdate)
          );
          controller.setInstanceValue(
              'updateinfo/' + ZxCore.KEY_UPDATE_LAST_UPDATE,
            ZxUtils.computeWordyDateStr(
              new Date(),
              Number(response.lastUpdate)
            )
          );
        }

        this.attrs.updateinfo[ZxCore.KEY_UPDATE_CURRENT_VERSION] = response.currentVersion;
        this.attrs.updateinfo[ZxCore.KEY_UPDATE_CURRENT_COMMIT] = response.currentCommit;

        controller.setInstanceValue(
          'updateinfo/' + ZxCore.KEY_UPDATE_AVAILABLE,
          response.availableVersion
        );

        controller.setInstanceValue(
          'updateinfo/' + ZxCore.KEY_UPDATE_AVAILABLE_COMMIT,
          response.availableCommit
        );

        controller.setInstanceValue(
          'updateinfo/' + ZxCore.KEY_UPDATE_CURRENT_VERSION,
          response.currentVersion
        );

        controller.setInstanceValue(
          'updateinfo/' + ZxCore.KEY_UPDATE_CURRENT_COMMIT,
          response.currentCommit
        );
      },
      this
    ),
    this._getDefaultCatchErrorFcn()
  );

  ZxAdminRequest.sendRequest(
    this.getCurrentServer(),
    'ZxMobile',
    'isHandleRegistered',
    {}
  ).then(
    AjxCallback.simpleClosure(
      function(resp) {
      // ZxUtils.log(resp, 'Response for ZxCore.getLicenseInfo()');
        var response = resp.response,
          controller = this.getCurrentController();
        this.attrs[ZxCore.KEY_MOBILE_HANDLER_REGISTERED] = response.isRegistered;
        controller.setInstanceValue(ZxCore.KEY_MOBILE_HANDLER_REGISTERED, response.isRegistered);
      },
      this
    ),
    this._getDefaultCatchErrorFcn()
  );

  ZxAdminRequest.sendRequest(
    this.getCurrentServer(),
    'ZxCore',
    'getAllServicesStatus'
  ).then(
    AjxCallback.simpleClosure(
      function(resp) {
        if (resp.response) {
          var controller = this.getCurrentController(),
            mod;

          for (mod in resp.response) {
            if (!resp.response.hasOwnProperty(mod)) { continue; }
            this.attrs[ZxCore.KEY_RUNNING_MODS][mod] = resp.response[mod].running;
            this.attrs[ZxCore.KEY_ENABLED_ON_STARTUP_MODS][mod] =
              resp.response[mod][ZxModule.KEY_ENABLED_ON_STARTUP];

            controller.setInstanceValue(ZxCore.KEY_RUNNING_MODS + '/' + mod, resp.response[mod].running);
            controller.setInstanceValue(
              ZxCore.KEY_ENABLED_ON_STARTUP_MODS + '/' + mod,
              resp.response[mod][ZxModule.KEY_ENABLED_ON_STARTUP]
            );
          }

        }
      },
      this
    ),
    this._getDefaultCatchErrorFcn()
  );

  var clientZimlet = ZaZimlet.getAll().getItemById('com_zextras_client');
  this.attrs[ZxCore.KEY_CLIENT_ZIMLET_DEPLOYED] = (!!clientZimlet);
  controller.setInstanceValue(ZxCore.KEY_CLIENT_ZIMLET_DEPLOYED, (!!clientZimlet));
};

/**
 * Upload a license.
 * @param {object} form
 */
ZxCore.prototype._doUploadLicense = function(form) {
  this._setUploadManager(new AjxPost(this._getUploadLicenseFrameId()));
  var clientUploadCallback = new AjxCallback(this, this._uploadLicenseCallback),
    um = this._getUploadManager();
  window._zxUploadManager = um;
  try {
    um.execute(clientUploadCallback, form);
    form.value = '';
  } catch (ex) {
    ZaApp.getInstance().getCurrentController().popupErrorDialog(
      zxMsg('MSG_COR_license_unable_to_upload')
    );
  }
};

/**
 * Create the license frame uploader for this item istance.
 * @return {string}
 */
ZxCore.prototype._getUploadLicenseFrameId = function() {
  if (!this._uploadManagerIframeId) {
    var iframeId = Dwt.getNextId(),
      html = ['<iframe name="', iframeId, '" id="', iframeId, '" src="',
        (AjxEnv.isIE && location.protocol === 'https:') ? appContextPath + '/public/blank.html' : 'javascript:""',
        '" style="position: absolute; top: 0; left: 0; visibility: hidden"></iframe>'],
      div = document.createElement('div');
    div.innerHTML = html.join('');
    document.body.appendChild(div.firstChild);
    this._uploadManagerIframeId = iframeId;
  }
  return this._uploadManagerIframeId;
};

/**
 * Set the license upload manager.
 * @param {AjxPost} uploadManager
 */
ZxCore.prototype._setUploadManager = function(uploadManager) {
  this._uploadManager = uploadManager;
};

/**
 * Get the license upload manager.
 * @return {AjxPost}
 */
ZxCore.prototype._getUploadManager = function() {
  return this._uploadManager;
};

/**
 * Function called when license info are available.
 * @param {ZxLicense} zxLicense
 */
ZxCore.prototype._setLicenseInfo = function(zxLicense) {
  var controller = this.getCurrentController(),
    server = this.getCurrentServer();

  if (!controller) {
    return;
  }

  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COMPANY, zxLicense.getCompany(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_CUSTOMER, zxLicense.getCustomer(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_RESELLER, zxLicense.getReseller(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_DATE_START, zxLicense.getDateStart(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_DATE_END, zxLicense.getDateEnd(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_EXPIRED, zxLicense.isExpired(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_NOT_YET_VALID, zxLicense.isNotYetValid(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_ORDER_ID, zxLicense.getOrderID(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_LICENSED_USER, zxLicense.getLicensedUsers(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_ACCOUNT, zxLicense.getCountAccount(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_RESOURCE, zxLicense.getCountResource(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_TYPE, zxLicense.getType(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_TYPE_ISP_V2, zxLicense.isISPV2(server));

  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_TOTAL,
    zxLicense.getCountAccount(server) + zxLicense.getCountResource(server));

  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_ZIMBRA_VERSION,
    (zxLicense.getLicensedZimbraVersion(server) || ''));

  controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXADMIN,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXADMIN].licensed);
  controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXBACKUP,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXBACKUP].licensed);
  controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXCHAT,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXCHAT].licensed);
  controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXMOBILE,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXMOBILE].licensed);
  controller.setInstanceValue('license/modules/' + ZxCore.KEY_LICENSE_ZXPOWERSTORE,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXBACKUP].licensed);

  controller.setInstanceValue('statuses/' + ZxCore.KEY_LICENSE_ZXADMIN,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXADMIN].enabled);
  controller.setInstanceValue('statuses/' + ZxCore.KEY_LICENSE_ZXBACKUP,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXBACKUP].enabled);
  controller.setInstanceValue('statuses/' + ZxCore.KEY_LICENSE_ZXCHAT,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXCHAT].enabled);
  controller.setInstanceValue('statuses/' + ZxCore.KEY_LICENSE_ZXMOBILE,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXMOBILE].enabled);

  if (ZaSettings.isNetworkVersion()) {
    var enabled = zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].enabledOnNE &&
      zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].enabled;
    controller.setInstanceValue('statuses/' + ZxCore.KEY_LICENSE_ZXPOWERSTORE, enabled);
  } else {
    controller.setInstanceValue('statuses/' + ZxCore.KEY_LICENSE_ZXPOWERSTORE,
      zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].enabled);
  }

  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_DATE_START_TEXT,
    ZxUtils.UTCDateString(zxLicense.getDateStart(server), zxMsg('LBL_Unlimited')));

  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_DATE_END_TEXT,
    ZxUtils.UTCDateString(zxLicense.getDateEnd(server), zxMsg('LBL_Unlimited')));

  controller.setInstanceValue('properties/' + ZxCore.KEY_OVERRIDE_NE_POWERSTORE,
    zxLicense.getModules(server)[ZxCore.KEY_LICENSE_ZXPOWERSTORE].enabledOnNE);

  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_LAST_VALIDATION,
    zxLicense.getLastValidation(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_RENEW_TIME_LEFT,
    zxLicense.getRenewTimeLeft(server));
  controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_HIDE_RENEW_TIME_LEFT,
    zxLicense.hideRenewTimeLeft(server));

  if (zxLicense.isNotYetValid(server)) {
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS,
      '<span style="color:red;">' + zxMsg('LBL_NotYetValid') + '</span>');
  } else if (zxLicense.isExpired(server)) {
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS,
      '<span style="color:red;">' + zxMsg('LBL_Expired') + '</span>');
  } else if ((zxLicense.isUserExceeded(server) && (zxLicense.isPurchased(server) || zxLicense.isPerpetual(server)))) {
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS,
      '<span style="color:red;">' + zxMsg('LBL_undersized') + '</span>' +
      ' <a href="' + ZxLinks.COR_License_how_work + '" style="font-size:9" target="_blank">' +
      '(' + zxMsg('LBL_more_info') + ')</a>');
  } else {
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_STATUS, zxMsg('LBL_Valid'));
  }

  if (zxLicense.isUserExceeded(server) && (zxLicense.isPurchased(server) || zxLicense.isPerpetual(server))) {
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_LICENSED_USER_TEXT,
      '<span style="color:red;">' + zxLicense.getLicensedUsers(server) + '</span>');
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_ACCOUNT_TEXT,
      '<span style="color:red;">' + zxLicense.getCountAccount(server) + '</span>');

  } else {
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_LICENSED_USER_TEXT,
      zxLicense.getLicensedUsers(server));
    controller.setInstanceValue('license/' + ZxCore.KEY_LICENSE_COUNT_ACCOUNT_TEXT,
      zxLicense.getCountAccount(server));
  }

  ZxUtils.log('ZxCore License Informations Updated.');
};

/**
 * Callback invoked when a license is uploaded.
 * @param {string} status is a string that will be parsed aj JSON Object.
 */
ZxCore.prototype._uploadLicenseCallback = function(status) {
  var controller = this.getCurrentController(),
    result = JSON.parse(status),
    msgDialog,
    contactDialog,
    expired,
    message = [];

  if (result.outcome === 'ok') {
    contactDialog = new ZxLicenseContactDialog(
      controller.getShell(),
      '450px',
      '200px',
      this,
      result.payment_mail,
      result.store_mail,
      result.current_notif_value
    );
    contactDialog.popup();

//    ZeXtras.loadVersion(new AjxCallback(ZeXtras, ZeXtras._onVersionInfo));

  } else if (result.outcome === 'error') {
    controller.popupWarningDialog(
      zxMsg('LBL_COR_license_not_valid_check_file') + '<br><br>' + result.error
    );

  } else { // assuming result.outcome === 'warnings'
    //license warning
    expired = (ZxUtils.indexOf(result.propertyKeys, 'upload_failed_expired') !== -1);
    msgDialog = new DwtMessageDialog({
      buttons: (expired ? [DwtDialog.DISMISS_BUTTON] : [DwtDialog.YES_BUTTON, DwtDialog.NO_BUTTON]),
      extraButtons: [],
      title: '',
      parent: controller._shell
    });
    message.push(
      zxMsg('MSG_COR_Following_warings_detected',
        [ZxLicense.buildUploadWarningMessage(result.propertyKeys, result.templateMap)])
    );

    if (!expired) {
      message.push(zxMsg('MSG_COR_do_you_want_to_upload_license'));

      msgDialog.registerCallback(
        DwtDialog.YES_BUTTON,
        new AjxCallback(
          this,
          function() {
            msgDialog.getButton(DwtDialog.YES_BUTTON).setEnabled(false);

            ZxAdminRequest.sendRequest(this.getCurrentServer(), 'ZxCore', 'doWebConfirmLicense', {}).
              then(AjxCallback.simpleClosure(
                function(res) {
                  // TODO: Consider the case: Response not valid or error.
                  var response = res;

                  contactDialog = new ZxLicenseContactDialog(
                    controller.getShell(),
                    '450px',
                    '200px',
                    this,
                    response.payment_mail,
                    response.current_notif_value
                  );
                  msgDialog.popdown();
                  contactDialog.popup();
                },
                this
              ), ZxUtils.catchError);
          }
        )
      );
    }

    msgDialog.setMessage(
      message.join('<br>'),
      DwtMessageDialog.WARNING_STYLE,
      ZxUtils.getTitleWithIcon('ZeXtras', 'ZeXtras')
    );
    msgDialog.popup();
  }
};

/**
 * If the license is not limited to a zimbra version, hide the limited version.
 * @return {boolean}
 * @this XFormItemFactory
 */
ZxCore.checkHideVersionLimit = function() {
  return this.getInstanceValue('attrs/license/' + ZxCore.KEY_LICENSE_ZIMBRA_VERSION) !== '';
};

/**
 * Hide the 'license valid until' if there are no license expiration date.
 * @return {boolean}
 * @this XFormItemFactory
 */
ZxCore.checkHideLicenseDateEnd = function() {
  var time = this.getInstanceValue('attrs/license/' + ZxCore.KEY_LICENSE_DATE_END);
  if (!time) {
    return false;
  }
  return !isNaN(this.getInstanceValue('attrs/license/' + ZxCore.KEY_LICENSE_DATE_END).getTime());
};

/**
 * Hide the 'New version available' warning.
 * @return {boolean}
 * @this XFormItemFactory
 */
ZxCore.checkNewZextrasVersionAvailableWarning = function() {
  var val = this.getInstanceValue('attrs/updateinfo/' + ZxCore.KEY_UPDATE_AVAILABLE);
  return (val !== 'none' && val !== ZaMsg.splashScreenLoading);
};

/**
 * Hide the 'User exceeded' warning.
 * @return {boolean}
 * @this XFormItemFactory
 */
ZxCore.checkOverquotaWarning = function() {
  var server = this.getInstance().name,
    license = ZeXtras.getLicense();
  return (license.isUserExceeded(server) && (license.isPurchased(server) || license.isPerpetual(server)));
};

/**
 * Refresh the view of the module.
 * @param {String} server
 */
ZxCore.refreshView = function(server) {
  var item = ZeXtras.getModuleItem('ZxCore', server);
  item.refreshView();
};

/**
 * Invoke the function to enable/disable the Backup Module at startup.
 * @param {boolean} enable
 * @this XFormItemFactory
 */
ZxCore.doEnableDisableBackup = function(enable) {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxBackup', server);
  if (item) {
    item.__doEnableDisableModuleOnStartup(enable, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Invoke the function to start the Backup Module
 * @this XFormItemFactory
 */
ZxCore.doStartBackup = function() {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxBackup', server);
  if (item) {
    item.__doStartStopModule(true, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Invoke the function to stop the Backup Module
 * @this XFormItemFactory
 */
ZxCore.doStopBackup = function() {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxBackup', server);
  if (item) {
    item.__doStartStopModule(false, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Invoke the function to enable/disable the Chat Module at startup.
 * @param {boolean} enable
 * @this XFormItemFactory
 */
ZxCore.doEnableDisableChat = function(enable) {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxChat', server);
  if (item) {
    item.__doEnableDisableModuleOnStartup(enable, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Invoke the function to start the Chat Module
 * @this XFormItemFactory
 */
ZxCore.doStartChat = function() {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxChat', server);
  if (item) {
    item.__doStartStopModule(true, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Invoke the function to stop the Chat Module
 * @this XFormItemFactory
 */
ZxCore.doStopChat = function() {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxChat', server);
  if (item) {
    item.__doStartStopModule(false, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Invoke the function to enable/disable the Mobile Module at startup.
 * @param {boolean} enable
 * @this XFormItemFactory
 */
ZxCore.doEnableDisableMobile = function(enable) {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxMobile', server);
  if (item) {
    item.__doEnableDisableModuleOnStartup(
      enable,
      AjxCallback.simpleClosure(ZxCore.refreshView, this, server)
    );
  }
};

/**
 * Invoke the function to enable/disable the Mobile handler for Zimbra Network edition.
 * @param {boolean} override
 * @this Checkbox_XFormItem
 */
ZxCore.doOverrideNEMobile = function(override) {
  var server = this.getInstance().id,
    /**
     * ZeXtras Mobile Module item for current server.
     * @type {ZxMobile|undefined}
     */
    item = ZeXtras.getModuleItem('ZxMobile', server);
  if (item) {
    item.__overrideNE(
      !override,
      AjxCallback.simpleClosure(ZxCore.refreshView, this, server)
    );
  }
};

/**
 * Invoke the function to start the Mobile Module
 * @this XFormItemFactory
 */
ZxCore.doStartMobile = function() {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxMobile', server);
  if (item) {
    item.__doStartStopModule(
      true,
      AjxCallback.simpleClosure(ZxCore.refreshView, this, server)
    );
  }
};

/**
 * Invoke the function to stop the Mobile Module
 * @this XFormItemFactory
 */
ZxCore.doStopMobile = function() {
  var server = this.getInstance().id,
    //mobileNEOverriden = this.getInstance().attrs.properties.ZxCore_OverrideNEMobile,
    item = ZeXtras.getModuleItem('ZxMobile', server);
  if (item) {
    item.__doStartStopModule(
      false,
      //mobileNEOverriden === 'true',
      AjxCallback.simpleClosure(ZxCore.refreshView, this, server)
    );
  }
};

/**
 * Invoke the function to enable/disable the Powerstore Module at startup.
 * @param {boolean} enable
 * @this XFormItemFactory
 */
ZxCore.doEnableDisablePowerstore = function(enable) {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxPowerstore', server);
  if (item) {
    item.__doEnableDisableModuleOnStartup(enable, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Invoke the function to start the Powerstore Module
 * @this XFormItemFactory
 */
ZxCore.doStartPowerstore = function() {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxPowerstore', server);
  if (item) {
    item.__doStartStopModule(true, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Invoke the function to stop the Powerstore Module
 * @this XFormItemFactory
 */
ZxCore.doStopPowerstore = function() {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxPowerstore', server);
  if (item) {
    item.__doStartStopModule(false, AjxCallback.simpleClosure(ZxCore.refreshView, this, server));
  }
};

/**
 * Get the visibility value for 'restart required' needed for Mobile Module to be functional.
 * @return {boolean}
 * @this XFormItemFactory
 */
ZxCore.checkMobileRestartRequired = function() {
  var server = this.getInstance().id,
    item = ZeXtras.getModuleItem('ZxCore', server),
    isRegistered = this.getInstanceValue('attrs/' + ZxCore.KEY_MOBILE_HANDLER_REGISTERED),
    isEnabled = this.getInstance().attrs.statuses[ZxCore.KEY_LICENSE_ZXMOBILE] === true;

  if (!ZaSettings.isNetworkVersion()) {
    return false;
  }

  return !isRegistered && isEnabled;
};

/**
 * Callback invoked when new license information are available.
 * @param {ZxLicense} license
 */
ZxCore.prototype._onLicenseInfo = function(license) {
  this._setLicenseInfo(license);
};

/**
 * Check if new updates are available.
 * @this ZxCore
 */
ZxCore.doCheckUpdate = function() {
  var item = ZeXtras.getModuleItem(ZxCore, this.getForm().getInstance().id),
    controller = item.getCurrentController(),
    loadingDialog = new ZxCheckUpdateDialog(
      controller.getShell(),
      item
    );
  loadingDialog.popup();
};

/**
 * Start the process to remove the license from ZeXtras Installation and revert to Trial mode.
 * @param ev
 */
ZxCore.doRemoveLicense = function(ev) {
  var item = ZeXtras.getModuleItem(ZxCore, this.getForm().getInstance().id);

  if (ZeXtras.isZeXtrasSuite()) {
      var controller = item.getCurrentController(),
      loadingDialog = new ZxRemoveLicenseDialog(
        controller.getShell(),
        item
      );
    loadingDialog.popup();
  } else {
    ZxAdminRequest.sendRequest(
      item.getServerName(),
      item.getID(),
      'doRemoveLicense',
      {
        iamsure: true
      }
    ).then(
      (function(_item) {
        return function(resp) {
          _item.loadMethod();
          ZeXtras.getLicense().invalidate();
        }
      })(item),
      ZxUtils.catchError
    );
  }
};

/**
 * Check the license validation for ISP license.
 */
ZxCore.doCheckLicenseValidation = function(ev) {
  var item = ZeXtras.getModuleItem(ZxCore, this.getForm().getInstance().id);
  item._doCheckLicenseValidation.apply(this);
};

ZxCore.prototype._doCheckLicenseValidation = function() {
  var item = ZeXtras.getModuleItem(ZxCore, this.getForm().getInstance().id),
    controller = item.getCurrentController(),
    loadingDialog = new ZxISPRenewDialog(
      controller.getShell(),
      item
    );
  loadingDialog.popup();
};

/**
 * Upload the license, this function is triggered when a file is selected in the
 * "Upload license" form.
 * @param {object} fromElement
 * @param {string} serverID
 */
ZxCore.doUploadLicense = function(formElement, serverID) {
  var item = ZeXtras.getModuleItem(ZxCore, serverID);
  item._doUploadLicense(formElement);
};

/**
 * Get the localized display message (and coloured) for modules licensing informations.
 * @param {boolean|undefined} val
 * @return {string}
 */
ZxCore.getLicensedDispalyValue = function(val) {
  if (val === true) {
    return zxMsg('LBL_Licensed');
  } else if (val === false) {
    return '<span style="color: red;">' + zxMsg('LBL_Unlicensed') + '</span>';
  } else {
    return ZaMsg.splashScreenLoading;
  }
};

/**
 * Visibility checks for module enabled at startup.
 * @param {string} modName
 * @return {boolean}
 * @this Checkbox_XFormItem
 */
ZxCore.checkEnableModuleOnStartup = function(modName) {
  return this.getInstanceValue('attrs/' + ZxCore.KEY_ENABLED_ON_STARTUP_MODS + '/' + modName);
};

/**
 * Get the string to display the module status if is running or not.
 * @param {string} mod
 * @return {String}
 */
ZxCore.getStatusDisplayValue = function(mod) {
  var running = this.getInstanceValue('attrs/' + ZxCore.KEY_RUNNING_MODS + '/' + mod);
  if (running) {
    return zxMsg('LBL_Running');
  } else if (running === null) {
    return ZaMsg.splashScreenLoading;
  } else {
    return '<span style="color:red;">' + zxMsg('LBL_Stopped') + '</span>';
  }
};

/**
 * Visibility checks for module running status.
 * @param {string} modName
 * @return {boolean}
 */
ZxCore.checkRunningModule = function(modName) {
  return this.getInstanceValue('attrs/' + ZxCore.KEY_RUNNING_MODS + '/' + modName);
};

ZxCore.displayClientErrors = function() {
  var item = ZeXtras.getModuleItem(ZxCore, this.getForm().getInstance().id),
    dialog = new ZxDwtDisplayErrorsDialog(ZaApp.getInstance().getAppCtxt());
  dialog.popup();
};

/**
 * Deploy the latest client zimlet.
 * @param {DwtSelectionEvent} ev
 * @this {Dwt_Button_XFormItem}
 */
ZxCore.doDeployLatestZimlet = function(ev) {
  var server = this.getInstance().id;
  ZeXtras.getModuleItem('ZxCore', server)._doDeployLatestClientZimlet();
};

/**
 * Deploy the latest version of the ZeXtras client zimlet.
 */
ZxCore.prototype._doDeployLatestClientZimlet = function() {
  var depDialog = new ZxDeployClientZimletDialog(
      this.getCurrentController().getShell(),
      null,
      '100px',
      zxMsg('LBL_CORE_deploy_latest_zimlet_client_version'),
      {},
      AjxCallback.simpleClosure(ZxCore.refreshView, this, this.id)
    );
  depDialog.deployZimlet(this.getCurrentServer(), this);
};

/**
 * Check if the ZeXtras Client zimlet is deployed.
 * @return {boolean}
 */
ZxCore.checkClientZimletDeployed = function() {
  return this.getInstanceValue('attrs/' + ZxCore.KEY_CLIENT_ZIMLET_DEPLOYED);
};

/**
 * Chech if the ZeXtras Client zimlet is not deployed.
 * @return {boolean}
 */
ZxCore.checkClientZimletNotDeployed = function() {
  return !(this.getInstanceValue('attrs/' + ZxCore.KEY_CLIENT_ZIMLET_DEPLOYED));
};

/**
 * Check if the license is a ZxLicense.LICENSE_PERPETUAL_V2 type.
 * @return {boolean}
 */
ZxCore.checkIsLicensePerpetualV2 = function() {
  return (this.getInstanceValue('attrs/license/' + ZxCore.KEY_LICENSE_TYPE) === ZxLicense.LICENSE_PERPETUAL_V2);
};

/**
 * Check if the license is NOT a ZxLicense.LICENSE_PERPETUAL_V2 type.
 * @return {boolean}
 */
ZxCore.checkIsNotLicensePerpetualV2 = function() {
  return (this.getInstanceValue('attrs/license/' + ZxCore.KEY_LICENSE_TYPE) !== ZxLicense.LICENSE_PERPETUAL_V2);
};

ZxCore.getZimbraVersionLimitedLicenceDispalyValue = function() {
  var licensedZimbraVersion = this.getInstanceValue('attrs/license/' + ZxCore.KEY_LICENSE_ZIMBRA_VERSION);
  if (/([0-9]+\.?)+/.test(licensedZimbraVersion)) {
    return licensedZimbraVersion.match(/([0-9])+/)[0];
  }
  return this.getInstanceValue('attrs/license/' + ZxCore.KEY_LICENSE_ZIMBRA_VERSION);
};
