/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxISPRenewDialog(parent, item, callback) {
  this._standardButtons = [DwtDialog.CANCEL_BUTTON];
  this._item = item;
  this._controller = item.getCurrentController();
  this._callbackExternal = callback;
  ZaXDialog.call(this, parent, null, ZxUtils.getTitleWithIcon('ZeXtras', zxMsg('LBL_ISP_Validation')),
    '400px', '50px', null, null);
  this._msgCellId = Dwt.getNextId();
  this._dwtIdIcon = Dwt.getNextId();

  this.initForm([], this.getMyXForm());
  this.setObject({});

  this.registerCallback(
    DwtDialog.CANCEL_BUTTON,
    new AjxCallback(
      this,
      function() {
        this.popdown();
      }
    )
  );

  var updateDialogCbk = AjxCallback.simpleClosure(
      this.setMessage,
      this
    );

  ZxAdminRequest.sendRequest(
    item.getServerName(),
    item.getID(),
    'doISPRenewal'
  ).then(
    AjxCallback.simpleClosure(
      function(item, resp) {
        ZeXtras.getLicense().invalidate();
        this.setMessage(ZxISPRenewDialog.SUCCESS, zxMsg('MSG_COR_renew_isp_success'));
      },
      this,
      item
    ),
    AjxCallback.simpleClosure(
      this.catchError,
      this
    )
  );

  this._helpURL = ZxLinks.HELP_COR_Dialog_CheckUpdate;
}

ZxISPRenewDialog.prototype = new ZaXDialog();
ZxISPRenewDialog.prototype.constructor = ZxISPRenewDialog;

ZxISPRenewDialog.FAILURE = 'failure';
ZxISPRenewDialog.PENDING = 'pending';
ZxISPRenewDialog.SUCCESS = 'success';

ZxISPRenewDialog.prototype.setMessage = function(status, message) {
  var msgCell = document.getElementById(this._msgCellId),
    iconCell = document.getElementById(this._dwtIdIcon),
    btn = this.getButton(DwtDialog.CANCEL_BUTTON);

  if (status === ZxISPRenewDialog.PENDING) {
    iconCell.innerHTML = '<div class="DwtWait32Icon">&nbsp;</div>';
  } else if (status === ZxISPRenewDialog.SUCCESS) {
    iconCell.innerHTML =
      AjxImg.getImageHtml(DwtMessageDialog.ICON[DwtMessageDialog.INFO_STYLE], null, null, false, false);
    btn.setText(ZaMsg.TBB_Close);
  } else {
    iconCell.innerHTML =
      AjxImg.getImageHtml(DwtMessageDialog.ICON[DwtMessageDialog.WARNING_STYLE], null, null, false, false);
    btn.setText(ZaMsg.TBB_Close);
  }
  msgCell.innerHTML = message;
};

/**
 * Get the XForm Object of the checkupdate window.
 * @return {{numCols: number, colSizes: Array, items: Array}}
 */
ZxISPRenewDialog.prototype.getMyXForm = function() {
  var xFormObject = {
    numCols: 1,
    colSizes: ['100%'],
    items: [
      {type: _SPACER_, height: 10},
      {
        type: _GROUP_,
        numCols: 2,
        colSizes: ['32', '*'],
        items: [
          {
            type: _OUTPUT_,
            value: '<div id="' + this._dwtIdIcon + '"><div class="DwtWait32Icon">&nbsp</div></div>'
          },
          {
            type: _OUTPUT_,
            value: '<div id="' + this._msgCellId + '">' +
              zxMsg('MSG_COR_renew_isp_pending') +
              '</div>'
          }
        ]
      }
    ]
  };
  return xFormObject;
};

/**
 * catch error
 * @param {ZxError|Error} error
 */
ZxISPRenewDialog.prototype.catchError = function(error) {
  this.popdown();
  ZxUtils.catchError(error);
};
