/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxLicenseContactDialog(parent, w, h, item, payment_mail, store_mail, current_notif_value) {
  this._standardButtons = [DwtDialog.OK_BUTTON, DwtDialog.CANCEL_BUTTON];
  ZaXDialog.call(this, parent, null, ZxUtils.getTitleWithIcon('ZeXtras', zxMsg('LBL_COR_License_Notification')),
    w, h, null, null);
  this._item = item;

  current_notif_value = current_notif_value || '';
  payment_mail = payment_mail || '';
  store_mail = store_mail || '';
  var newValue = current_notif_value;
  if (ZxUtils.indexOf(current_notif_value, payment_mail) < 0) {
    newValue += payment_mail;
  }

  if (ZxUtils.indexOf(current_notif_value, store_mail) < 0) {
    if (newValue.length > 0) {
      newValue += ';';
    }
    newValue += store_mail;
  }

  this.initForm([], this.getMyXForm());
  this.setObject({licensemails: newValue});

  this.registerCallback(
    DwtDialog.OK_BUTTON,
    new AjxCallback(
      this,
      function() {
        this.getButton(DwtDialog.OK_BUTTON).setEnabled(false);
        var value = this._containedObject.licensemails;
        ZxAdminRequest.sendRequest(
          ZxAdminRequest.TARGET_ALL,
          'ZxCore',
          'setPublicProperties',
          {
            properties: {
              ZxCore_LicenseWarningRecipients: value
            }
          }
        ).then(AjxCallback.simpleClosure(
          function(resp) {
            var server;
            for (server in resp) {
              if (!resp.hasOwnProperty(server)) {
                continue;
              }
              if (resp[server] instanceof ZxError) {
                ZxUtils.catchError(resp[server]);
              }
            }
            ZeXtras.getLicense().invalidate();
            this._item.fireLoadMethods();
            this.popdown();
          },
          this
        ), ZxUtils.catchError);
      }
    )
  );

  this.registerCallback(
    DwtDialog.CANCEL_BUTTON,
    new AjxCallback(
      this,
      function() {
        ZeXtras.getLicense().invalidate();
        this._item.fireLoadMethods();
        this.popdown();
      }
    )
  );

  this._helpURL = ZxLinks.HELP_COR_Dialog_ContactForLicense;
}

ZxLicenseContactDialog.prototype = new ZaXDialog();
ZxLicenseContactDialog.prototype.constructor = ZxLicenseContactDialog;

ZxLicenseContactDialog.prototype.getMyXForm = function() {
  var xFormObject = {
    numCols: 1,
    colSizes: ['100%'],
    items: [
      {
        type: _GROUP_,
        numCols: 1,
        colSizes: ['*'],
        items: [{
          type: _OUTPUT_,
          value: zxMsg('MSG_COR_Specify_license_notification_addresses')
        }]
      },
      {
        type: _GROUP_,
        numCols: 1,
        colSizes: ['*'],
        items: [{
          type: _TEXTFIELD_,
          ref: 'licensemails',
          label: zxMsg('LBL_Emails') + ': ',
          width: '300',
          onChange: function(value) {
            this.setInstanceValue(value);
            var arr = value.split(';'),
              win = this.getForm().parent,
              okBtn = win.getButton(DwtDialog.OK_BUTTON),
              i = 0,
              valid = true;

            for (i = 0; i < arr.length; i = i + 1) {
              if (arr[i] !== '' && !ZxUtils.validateEmail(arr[i])) {
                valid = false;
              }
            }
            okBtn.setEnabled(valid);
          }
        }]
      }
    ]
  };
  return xFormObject;
};
