/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

var ZxMobileXFormItem = [
  {
    type: _GROUP_,
    cssClass: 'ZmSelectedHeaderBg',
    colSpan: '*',
    id: 'xform_header',
    items: [
      {
        type: _GROUP_,
        cssClass: 'ZxMobileSpacer',
        numCols: 3,
        width: '100%',
        colSizes: ['160px', '*', '410px'],
        items: [
          { type: _CELL_SPACER_ },
          {
            type: _OUTPUT_,
            ref: 'name',
            valign: _TOP_,
            cssClass: 'AdminTitle'
          },
          {
            type: _GROUP_,
            width: 410,
            numCols: 1,
            items: [
              {
                type: _GROUP_,
                width: 220,
                numCols: 2,
                items: [
                  {
                    type: _DWT_BUTTON_,
                    icon: 'Search',
                    width: 200,
                    align: _LEFT_,
                    label: 'COS ' + zxMsg('LBL_enabled'),
                    toolTipContent: zxMsg('LBL_Search'),
                    onActivate: function() {
                      ZxMobile.doButtonsSearch(ZaSearch.COSES);
                    }
                  },
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/stats/' + ZxMobile.KEY_COS_ENABLED,
                    cssStyle: 'font-weight:bold;',
                    align: _RIGHT_
                  },
                  {
                    type: _DWT_BUTTON_,
                    icon: 'Search',
                    width: 200,
                    align: _LEFT_,
                    cssStyle: 'margin-top:5px',
                    label: zxMsg('LBL_Accounts') + ' ' + zxMsg('LBL_enabled'),
                    toolTipContent: zxMsg('LBL_Search'),
                    onActivate: function() {
                      ZxMobile.doButtonsSearch(ZaSearch.ACCOUNTS);
                    }
                  },
                  {
                    type: _OUTPUT_,
                    ref: 'attrs/stats/' + ZxMobile.KEY_ACCOUNT_ENABLED,
                    cssStyle: 'font-weight:bold;',
                    align: _RIGHT_
                  }
                ]
              }
            ]
          }
        ]
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSpan: 2,
    width: '100%',
    colSizes: ['100%'],
    items: [
      {
        type: _DWT_ALERT_,
        visibilityChecks: [ZxMobile.checkNotHasAccountOrCos],
        visibilityChangeEventSources: [
          'attrs/stats/' + ZxMobile.KEY_COS_ENABLED,
          'attrs/stats/' + ZxMobile.KEY_ACCOUNT_ENABLED
        ],
        style: DwtAlert.WARNING,
        iconVisible: true,
        content: zxMsg(
          'MSG_MOB_Warning_initial_configuration',
          ['<a href =' + ZxLinks.MOB_INFO_SETUP + ' target="_blank">' + ZxLinks.MOB_INFO_SETUP + '</a>']
        )
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSizes: ['*'],
    width: '100%',
    tableCssStyle: 'width:100%;overflow:auto;padding-right:15px;padding-left:15px;',
    items: [
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_MOB_Performance_tuning') + ' ' + ZxUtils.getInfoIcon(ZxLinks.HELP_MOB_Settings),
        numCols: 1,
        colSizes: ['*'],
        align: _LEFT_,
        items: [
          {
            type: _GROUP_,
            colSizes: [250, '*'],
            numCols: 2,
            cssStyle: 'margin: 5px',
            items: [
              {
                type: _TEXTFIELD_,
                ref: 'attrs/properties/' + ZxMobile.KEY_NOTIFICATION_LATENCY,
                label: zxMsg('LBL_MOB_Notification_latency') + ': ',
                bmolsnr: true,
                enableDisableChecks: [ZxMobile.checkNotUsingInstant],
                enableDisableChangeEventSources: ['attrs/properties/' + ZxMobile.KEY_USE_INSTANT_NOTIFICATIONS],
                toolTipContent: zxMsg('MSG_MOB_TOOLTIP_Notification_latency')
              },
              {
                type: _CHECKBOX_,
                labelCssClass: 'ZxCheckboxLabel',
                ref: 'attrs/properties/' + ZxMobile.KEY_USE_INSTANT_NOTIFICATIONS,
                label: zxMsg('MSG_MOB_Use_instant_notifications') + ': ',
                bmolsnr: true,
                labelLocation: _LEFT_,
                align: _LEFT_,
                toolTipContent: zxMsg('MSG_MOB_TOOLTIP_Use_instant_notifications')
              },
              {
                type: _CHECKBOX_,
                labelCssClass: 'ZxCheckboxLabel',
                ref: 'attrs/properties/' + ZxMobile.KEY_PROVISIONING_ENABLED,
                label: zxMsg('LBL_MOB_Enable_Mobile_Policy') + ': ',
                bmolsnr: true,
                labelLocation: _LEFT_,
                align: _LEFT_,
                onChange: function(value, ev, form) {
                  ZxMobile.doEnableDisableProvisioning(value);
                  this.setInstanceValue(value);
                  return value;
                }
              },
              {
                type: _TEXTFIELD_,
                ref: 'attrs/properties/' + ZxMobile.KEY_MAX_PING_HEARTBEAT,
                label: zxMsg('LBL_MOB_Max_ping_heartbeat') + ': ',
                bmolsnr: true,
                toolTipContent: zxMsg('MSG_MOB_TOOLTIP_Maximum_ping_heartbeat')
              },
              {
                type: _OSELECT1_,
                labelCssClass: 'ZxCheckboxLabel',
                ref: 'attrs/properties/' + ZxMobile.KEY_MAX_EAS_SAMSUNG_VERSION,
                bmolsnr: true,
                label: zxMsg('LBL_MOB_Max_eap_version_for_samsung') + ': ',
                choices: ZxMobile.EAS_VERSIONS,
                labelLocation: _LEFT_,
                align: _LEFT_
              },
              {
                type: _OSELECT1_,
                labelCssClass: 'ZxCheckboxLabel',
                ref: 'attrs/properties/' + ZxMobile.KEY_MAX_EAS_GLOBAL_VERSION,
                bmolsnr: true,
                label: zxMsg('LBL_MOB_Max_eap_global_version') + ': ',
                choices: ZxMobile.EAS_VERSIONS,
                labelLocation: _LEFT_,
                align: _LEFT_
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_MOB_Registered_devices'),
        bmolsnr: true,
        numCols: 1,
        colSizes: ['*'],
        items: [
          //{
          //  type: _GROUP_,
          //  numCols: 2,
          //  items: [{
          //    type: _CHECKBOX_,
          //    label: 'Show only online devices',
          //    onChange: ZxMobile._showOnlyOnlineDevices
          //  }]
          //},
          {
            type: _ZX_LIST_VIEW_,
            ref: 'attrs/' + ZxMobile.KEY_SESSIONS,
            headerList: ZxMobile.getSessionsListHeader(),
            filterEnabled: true,
            navigationEnabled: true,
            hideIfEmpty: false,
            optionalButtons: ZxMobile.getSessionListButtons(),
            onSelection: ZxMobile._onDeviceSelected
          }
        ]
      }
    ]
  }
];
