/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxMobileAppListView(parent, className, posStyle, headerList) {
  ZaListView.call(this, parent, className, posStyle, headerList);
}

ZxMobileAppListView.prototype = new ZaListView();
ZxMobileAppListView.prototype.constructor = ZxMobileAppListView;
//ZxMobileAppListView.prototype.toString = function() { return 'ZxMobileAppListView'; };

ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplication = 'zimbraMobilePolicyApprovedApplication';
ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplicationList = 'zimbraMobilePolicyApprovedApplicationList';
ZxMobileAppListView.A_zimbraMobilePolicyUnapprovedInROMApplication = 'zimbraMobilePolicyUnapprovedInROMApplication';
ZxMobileAppListView.A_ApprovedAppSelection = 'approved_app_selection';
ZxMobileAppListView.A_BlockedAppSelection = 'blocked_app_selection';
ZxMobileAppListView.A_ApprovedAppName = 'approved_app_name';
ZxMobileAppListView.A_ApprovedAppHash = 'approved_app_hash';
ZxMobileAppListView.A_BlockedAppName = 'blocked_app_name';

ZxMobileAppListView.prototype._createItemHtml = function (item) {
  var div = document.createElement('div'),
    html = [];
  div[DwtListView._STYLE_CLASS] = 'Row';
  div[DwtListView._SELECTED_STYLE_CLASS] = div[DwtListView._STYLE_CLASS] + '-' + DwtCssStyle.SELECTED;
  div.className = div[DwtListView._STYLE_CLASS];
  this.associateItemWithElement(item, div, DwtListView.TYPE_LIST_ITEM);

  html.push('<table width="100%" cellspacing="0" cellpadding="0">');
  html.push('<tr>');

  html.push('<td width="250px" style="padding-left:2px;padding-right:3px"><nobr>');
  html.push(item);
  html.push('</nobr></td>');
  html.push('</table>');
  div.innerHTML = html.join('');
  return div;
};

ZxMobileAppListView.onBlockedAppSelectionListener = function(ev) {
  var arr = this.widget.getSelection();
  if (arr && arr.length) {
    arr.sort();
    this.setInstanceValue(arr, ZxMobileAppListView.A_BlockedAppSelection);
  } else {
    this.setInstanceValue(null, ZxMobileAppListView.A_BlockedAppSelection);
  }
};

ZxMobileAppListView.onApprovedAppSelectionListener = function(ev) {
  var arr = this.widget.getSelection();
  if (arr && arr.length) {
    arr.sort();
    this.setInstanceValue(arr, ZxMobileAppListView.A_ApprovedAppSelection);
  } else {
    this.setInstanceValue(null, ZxMobileAppListView.A_ApprovedAppSelection);
  }
};

ZxMobileAppListView.removeBlockedAppButtonListener = function() {
  var instance = this.getInstance(),
    selection,
    apps,
    cnt,
    i;

  if (instance[ZxMobileAppListView.A_BlockedAppSelection] &&
      instance.attrs[ZxMobileAppListView.A_zimbraMobilePolicyUnapprovedInROMApplication]) {

    selection = AjxUtil.arrayAsHash(instance[ZxMobileAppListView.A_BlockedAppSelection]);
    apps = instance.attrs[ZxMobileAppListView.A_zimbraMobilePolicyUnapprovedInROMApplication];
    cnt = instance[ZxMobileAppListView.A_BlockedAppSelection].length;

    ZxUtils.log(apps, zxMsg('LBL_MOB_Blocked_apps_removed'));
    for (i = apps.length - 1; i >= 0 && cnt > 0; i = i - 1) {
      if (selection[apps[i]]) {
        cnt = cnt - 1;
        apps.splice(i, 1);
      }
    }
    this.setInstanceValue(apps, ZxMobileAppListView.A_zimbraMobilePolicyUnapprovedInROMApplication);
    this.getForm().parent.setDirty(true);
  }
};

ZxMobileAppListView.removeApprovedAppButtonListener = function() {
  var instance = this.getInstance(),
    selection,
    apps,
    cnt,
    i,
    hash,
    hashs = [],
    arr = [];

  if (instance[ZxMobileAppListView.A_ApprovedAppSelection] &&
      instance.attrs[ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplicationList]) {

    selection = AjxUtil.arrayAsHash(instance[ZxMobileAppListView.A_ApprovedAppSelection]);
    apps = instance.attrs[ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplicationList];
    cnt = instance[ZxMobileAppListView.A_ApprovedAppSelection].length;

    ZxUtils.log(apps, zxMsg('LBL_MOB_Approved_apps_removed'));
    for (i = apps.length - 1; i >= 0 && cnt > 0; i = i - 1) {
      if (selection[apps[i]]) {
        cnt = cnt - 1;
        apps.splice(i, 1);
      }
    }

    for (i in apps) {
      hash = apps[i].split(':')[1];
      arr.push(hash);
    }
    this.setInstanceValue(apps, ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplicationList);
    this.setInstanceValue(arr, ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplication);
    this.getForm().parent.setDirty(true);
  }
};

ZxMobileAppListView.isRemoveBlockedAppEnabled = function() {
  return (!AjxUtil.isEmpty(this.getInstanceValue(
    ZxMobileAppListView.A_BlockedAppSelection
  )));
};

ZxMobileAppListView.isRemoveApprovedAppEnabled = function() {
  return (!AjxUtil.isEmpty(this.getInstanceValue(
    ZxMobileAppListView.A_ApprovedAppSelection
  )));
};

ZxMobileAppListView.addBlockedAppButtonListener = function() {
  var instance = this.getInstance(),
    formPage = this.getForm().parent,
    dlg,
    obj = {};

  if (!formPage.addBlockedAppDlg) {

    formPage.addBlockedAppDlg = new ZxAddBlockedAppDialog(
      ZaApp.getInstance().getAppCtxt().getShell(),
      '450px',
      '120px',
      zxMsg('LBL_MOB_Add_blocked_application')
    );

    formPage.addBlockedAppDlg.registerCallback(
      DwtDialog.OK_BUTTON,
      ZxMobileAppListView.addBlockedApp,
      this.getForm(),
      null
    );
  }

  dlg = formPage.addBlockedAppDlg;

  obj[ZxMobileAppListView.A_BlockedAppName] = '';
  dlg.setObject(obj);
  dlg.popup();
};

ZxMobileAppListView.addApprovedAppButtonListener = function() {
  var instance = this.getInstance(),
    formPage = this.getForm().parent,
    dlg,
    obj = {};

  if (!formPage.addApprovedAppDlg) {

    formPage.addApprovedAppDlg = new ZxAddApprovedAppDialog(
      ZaApp.getInstance().getAppCtxt().getShell(),
      '450px',
      '120px',
      zxMsg('LBL_MOB_Add_approved_application')
    );

    formPage.addApprovedAppDlg.registerCallback(
      DwtDialog.OK_BUTTON,
      ZxMobileAppListView.addApprovedApp,
      this.getForm(),
      null
    );
  }

  dlg = formPage.addApprovedAppDlg;

  obj[ZxMobileAppListView.A_ApprovedAppHash] = '';
  dlg.setObject(obj);
  dlg.popup();
};

ZxMobileAppListView.addBlockedApp = function() {
  var dlg = this.parent.addBlockedAppDlg,
    obj,
    appName,
    arr;

  if (dlg) {
    dlg.popdown();
    obj = dlg.getObject();
    appName = obj[ZxMobileAppListView.A_BlockedAppName];

    if (!AjxUtil.isEmpty(appName)) {
      arr = this.getInstanceValue(ZxMobileAppListView.A_zimbraMobilePolicyUnapprovedInROMApplication);
      if (!arr) {
        arr = [];
      }
      arr.push(appName);

      ZxUtils.log(arr, zxMsg('LBL_MOB_Blocked_apps_added'));

      this.setInstanceValue(arr, ZxMobileAppListView.A_zimbraMobilePolicyUnapprovedInROMApplication);

      this.parent.setDirty(true);
    }
  }
};

ZxMobileAppListView.addApprovedApp = function() {
  var dlg = this.parent.addApprovedAppDlg,
    obj,
    appHash,
    arr;

  if (dlg) {
    dlg.popdown();
    obj = dlg.getObject();
    appHash = obj[ZxMobileAppListView.A_ApprovedAppHash];

    if (!AjxUtil.isEmpty(appHash)) {

      arr = this.getInstanceValue(ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplicationList);
      if (!arr) {
        arr = [];
      }
      arr.push(appHash);

      ZxUtils.log(arr, zxMsg('LBL_MOB_Approved_apps_added'));

      this.setInstanceValue(arr, ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplicationList);

      arr = this.getInstanceValue(ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplication);
      if (!arr) {
        arr = [];
      }
      arr.push(appHash);
      this.setInstanceValue(arr, ZxMobileAppListView.A_zimbraMobilePolicyApprovedApplication);

      this.parent.setDirty(true);
    }
  }
};
