/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */
function ZxOpQueueDialog(parent, w, h, title, operations) {
  ZxNotifications.selectedOperation = null;
  var helpUrl = ZxLinks.HELP_NOT_Dialog_OpInfo,
    helpButton = new DwtDialog_ButtonDescriptor(
      ZaXDialog.HELP_BUTTON,
      ZaMsg.TBB_Help,
      DwtDialog.ALIGN_LEFT,
      new AjxCallback(
        this,
        ZxUtils.openURL,
        [helpUrl]
      )
    ),
    infoButton = new DwtDialog_ButtonDescriptor(
      'infoButtonId',
      ZaMsg.Domain_AuthTestMessage,
      DwtDialog.ALIGN_LEFT,
      new AjxCallback(
        this,
        function() {
          var list = this._localXForm.getChildren()[0],
            item;
          if (list.getSelectionCount() > 0) {
            item = list.getSelection()[0];
            ZxNotifications.showOpInfo(item);
          }
        }
      )
    );

  this._extraButtons = [helpButton, infoButton];
  this._standardButtons = [DwtDialog.OK_BUTTON];
  ZaXDialog.call(this, parent, null, title, w, h, null, null);
  this.initForm([], this.getMyXForm());

  var i, list = [];
  for (i in operations) {
    if (!operations.hasOwnProperty(i)) { continue; }
    list.push(operations[i]);
  }
  this.setObject({opList: list});

  this._helpURL = ZxLinks.HELP_NOT_Dialog_OpQueue;
}

ZxOpQueueDialog.prototype = new ZaXDialog;
ZxOpQueueDialog.prototype.constructor = ZxOpQueueDialog;

ZxOpQueueDialog.prototype.getMyXForm = function() {
  var xFormObject = {
    numCols: 1,
    colSizes: ['100%'],
    items: [
      {
        type: _DWT_LIST_,
        id: 'ZXOperationsQueueList',
        ref: 'opList',
        headerList: ZxOpQueueListView.getHeaderList(),
        widgetClass: ZxOpQueueListView
      }
    ]
  };
  return xFormObject;
};
