/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */
function ZxOpQueueListView() {
  DwtListView.apply(this, arguments);
  this.addSelectionListener(new AjxListener(this, this._listSelectionListener));
}

ZxOpQueueListView.prototype = new DwtListView();
ZxOpQueueListView.prototype.constructor = ZxOpQueueListView;

/**
 *
 * @param {string[]} htmlArr
 * @param {number} idx
 * @param {ZxOperation} item
 * @param {string} field
 * @param {integer} colIdx
 * @param {{}} params
 * @return {*}
 */
ZxOpQueueListView.prototype._getCellContents = function(htmlArr, idx, item, field, colIdx, params) {

  if (field === 'ZXNOpName') {
    htmlArr[idx++] = item.getOpData().descName;

  } else if (field === 'ZXNOpState') {
    htmlArr[idx++] = item.getOpData().state;

  } else if (field === 'ZXNOpHost') {
    htmlArr[idx++] = item.getOpData().host;

  } else if (field === 'ZXNOpTime') {
    htmlArr[idx++] = item.getOpData().startTime;

  } else {

    htmlArr[idx++] = item[colIdx].toString ? item[colIdx].toString() : item[colIdx];
  }

  return idx;
};

ZxOpQueueListView.getHeaderList = function() {
  var headerList = [];
  //headerList.push(new ZaListHeaderItem('ZXNOpId', 'Operation ID', null, '250px', null, 'ZXNOpId', false, true));
  headerList.push(
    new ZaListHeaderItem('ZXNOpName', zxMsg('LBL_NOT_operation'),
      null, 'auto', null, 'ZXNOpName', false, true)
  );
  headerList.push(
    new ZaListHeaderItem('ZXNOpState', zxMsg('LBL_NOT_state'),
      null, '50px', null, 'ZXNOpState', false, true)
  );
  headerList.push(
    new ZaListHeaderItem('ZXNOpHost', zxMsg('LBL_NOT_host'),
      null, '150px', null, 'ZXNOpHost', false, true)
  );
  headerList.push(
    new ZaListHeaderItem('ZXNOpTime', zxMsg('LBL_NOT_time'),
      null, '150px', null, 'ZXNOpTime', false, true)
  );
  return headerList;
};

ZxOpQueueListView.prototype._listSelectionListener = function(ev) {
  if (ev.detail === DwtListView.ITEM_DBL_CLICKED && ev.item) {
//    var message = AjxMessageFormat.format(
//      zxMsg('MSG_NOT_monitor_progress_info'),
//      ['<span style="margin-left:0.3em;">', '</span>', '<b>', '</b>',
//        '<br/>', 'zxsuite ' + ev.item[5] + 'monitor' + ev.item[4]]
//    );
    ZxNotifications.showOpInfo(ev.item);

  } else if (ev.detail === DwtListView.ITEM_SELECTED) {
//    ZXNotifications.selectedOperation = ev;
  }
};
