/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

var ZxPowerstoreXFormItem = [
  {
    type: _GROUP_,
    cssClass: 'ZmSelectedHeaderBg',
    colSpan: '*',
    id: 'xform_header',
    items: [
      {
        type: _GROUP_,
        cssClass: 'ZxPowerstoreSpacer',
        numCols: 3,
        width: '100%',
        colSizes: ['160px', '*', '200px'],
        items: [
          { type: _CELL_SPACER_ },
          {
            type: _OUTPUT_,
            ref: 'name',
            valign: _TOP_,
            cssClass: 'AdminTitle'
          },
          {
            type: _GROUP_,
            width: 200,
            numCols: 1,
            items: [
              {
                type: _DWT_BUTTON_,
                label: zxMsg('LBL_HSM_Apply_policy'),
                icon: 'ZxPowerstore',
                width: 200,
                align: _LEFT_,
                onActivate: ZxPowerstore.doStartOperations
              },
              {
                type: _DWT_BUTTON_,
                label: zxMsg('LBL_HSM_Stop_operation'),
                cssStyle: 'margin-top:5px',
                icon: 'Cancel',
                width: 200,
                align: _LEFT_,
                onActivate: ZxPowerstore.doStopOperations
              }
            ]
          }
        ]
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSpan: 2,
    width: '100%',
    colSizes: ['100%'],
    items: [
      {
        type: _DWT_ALERT_,
        cssClass: 'DwtTabTable',
        ref: 'attrs/' + ZxPowerstore.KEY_HSMS,
        visibilityChangeEventSources: ['attrs/' + ZxPowerstore.KEY_HSMS],
        bmolsnr: true,
        getDisplayValue: function(newVal) {
          return zxMsg('MSG_HSM_invalid_policy_found',
            ['<span style="color:red;">', '</span>']);
        },
        visibilityChecks: [ZxPowerstore.checkInvalidHSMPresence],
        containerCssStyle: 'padding-bottom:0px',
        style: DwtAlert.WARNING,
        iconVisible: true,
        colSpan: '*'
      }
    ]
  },
  {
    type: _GROUP_,
    numCols: 1,
    colSizes: ['100%'],
    tableCssStyle: 'width:100%;overflow:auto;padding-right:15px;padding-left:15px;',
    items: [
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_HSM_volumes_management'),
        numCols: 1,
        colSizes: ['*'],
        items: [
          {
            type: _GROUP_,
            numCols: 3,
            colsizes: ['*', '30', '*'],
            items: [
              {
                type: _ZAWIZ_TOP_GROUPER_,
                label: zxMsg('LBL_HSM_Primary_Volumes'),
                colSizes: ['*'],
                numCols: 1,
                items: [
                  {
                    type: _DWT_LIST_,
                    id: 'primaryVolumes',
                    ref: 'attrs/' + ZxPowerstore.KEY_PRIMARIES,
                    emptyText: zxMsg('MSG_HSM_No_primary_volumes_defined'),
                    height: 150,
                    cssClass: 'DLSource primaryVolumes',
                    widgetClass: ZxPowerstoreVolumeListView,
                    multiSelect: false,
                    headerList: ZxPowerstoreVolumeListView.getHeaderList()
                  },
                  {
                    type: _GROUP_,
                    numCols: 5,
                    colSizes: ['*', '*', '*', '*', '*'],
                    cssStyle: 'margin-top: 10px; margin-bottom: 10px',
                    items: [
                      {
                        type: _DWT_BUTTON_,
                        label: ZaMsg.NAD_Add,
                        icon: 'Add',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doAddRow(
                            ev,
                            ZxPowerstoreVolumeListView.PANEL_PRIMARY
                          );
                          return false;
                        }
                      },
                      {
                        type: _DWT_BUTTON_,
                        label: ZaMsg.TBB_Edit,
                        icon: 'Edit',
                        cssStyle: 'margin-left: 10px',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doModifyRow(ev, ZxPowerstoreVolumeListView.PANEL_PRIMARY);
                        }
                      },
                      {
                        type: _DWT_BUTTON_,
                        label: ZaMsg.TBB_Delete,
                        icon: 'Delete',
                        cssStyle: 'margin-left: 10px',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doDeleteRow(ev, ZxPowerstoreVolumeListView.PANEL_PRIMARY);
                        }
                      },
                      {
                        type: _DWT_BUTTON_,
                        label: zxMsg('LBL_HSM_Deduplicate'),
                        icon: 'ZxDeduplicate',
                        toolTipContent: zxMsg('MSG_HSM_Deduplicate'),
                        cssStyle: 'margin-left: 10px',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doStartDeduplicate(ev, ZxPowerstoreVolumeListView.PANEL_PRIMARY);
                        }
                      }
                    ]
                  }
                ]
              },
              {
                type: _GROUP_,
                numCols: 1,
                colSizes: ['*'],
                items: [
                  {
                    type: _DWT_BUTTON_,
                    label: '&rarr;',
                    // width: 20 ,
                    onActivate: function(ev) {
                      ZxPowerstore.doMoveVolume(this, ev, ZxPowerstoreVolumeListView.PANEL_PRIMARY, ZxPowerstoreVolumeListView.PANEL_SECONDARY);
                    }
                  },
                  {type: _SPACER_, height: 10},
                  {
                    type: _DWT_BUTTON_,
                    label: '&larr;',
                    // width: 20 ,
                    onActivate: function(ev) {
                      ZxPowerstore.doMoveVolume(this, ev, ZxPowerstoreVolumeListView.PANEL_SECONDARY, ZxPowerstoreVolumeListView.PANEL_PRIMARY);
                    }
                  }
                ]
              },
              {
                type: _ZAWIZ_TOP_GROUPER_,
                label: zxMsg('LBL_HSM_Secondary_Volumes'),
                colSizes: ['*'],
                numCols: 1,
                items: [
                  {
                    type: _DWT_LIST_,
                    id: 'secondaryVolumes',
                    height: 150,
                    cssClass: 'DLSource secondaryVolumes',
                    ref: 'attrs/' + ZxPowerstore.KEY_SECONDARIES,
                    cssStyle: 'border: 1px solid grey',
                    multiSelect: false,
                    emptyText: zxMsg('MSG_HSM_No_secondary_volumes_defined'),
                    widgetClass: ZxPowerstoreVolumeListView,
                    headerList: ZxPowerstoreVolumeListView.getHeaderList()
                  },
                  {
                    type: _GROUP_,
                    numCols: 6,
                    colSizes: ['*', '*', '*', '*', '*', '*'],
                    cssStyle: 'margin-top: 10px; margin-bottom: 10px',
                    items: [
                      {
                        type: _DWT_BUTTON_,
                        label: ZaMsg.NAD_Add,
                        icon: 'Add',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doAddRow(
                            ev,
                            ZxPowerstoreVolumeListView.PANEL_SECONDARY
                          );
                          return false;
                        }
                      },
                      {
                        type: _DWT_BUTTON_,
                        label: ZaMsg.TBB_Edit,
                        icon: 'Edit',
                        cssStyle: 'margin-left: 10px',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doModifyRow(ev, ZxPowerstoreVolumeListView.PANEL_SECONDARY);
                        }
                      },
                      {
                        type: _DWT_BUTTON_,
                        label: ZaMsg.TBB_Delete,
                        icon: 'Delete',
                        cssStyle: 'margin-left: 10px',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doDeleteRow(ev, ZxPowerstoreVolumeListView.PANEL_SECONDARY);
                        }
                      },
                      {
                        type: _DWT_BUTTON_,
                        label: zxMsg('LBL_HSM_Stats'),
                        icon: 'Properties',
                        cssStyle: 'margin-left: 10px',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doShowStatistics(ev, ZxPowerstoreVolumeListView.PANEL_SECONDARY);
                        }
                      },
                      {
                        type: _DWT_BUTTON_,
                        label: zxMsg('LBL_HSM_Deduplicate'),
                        toolTipContent: zxMsg('MSG_HSM_Deduplicate'),
                        icon: 'ZxDeduplicate',
                        cssStyle: 'margin-left: 10px',
                        onActivate: function(ev) {
                          ZxPowerstoreVolumeListView.doStartDeduplicate(ev, ZxPowerstoreVolumeListView.PANEL_SECONDARY);
                        }
                      },
                      { type: _CELL_SPACER_ }
                    ]
                  }
                ]
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_HSM_storage_management_policy'),
        numCols: 1,
        colSizes: ['100%'],
//        tableCssStyle: 'width:100%;overflow:auto;padding-right:15px;padding-left:15px;',
        items: [
          {
            type: _GROUP_,
            numCols: 2,
            colSizes: [250, '*'],
            items: [
              {
                type: _CHECKBOX_,
                labelLocation: _LEFT_,
                align: _LEFT_,
                labelCssClass: 'ZxCheckboxLabel',
                ref: 'attrs/properties/' + ZxPowerstore.KEY_HSM_MOVE_SCHEDULING_ENABLED,
                bmolsnr: true,
                label: zxMsg('MSG_HSM_Enable_policy_scheduling') + ': '
              },
              {
                type: _OSELECT1_,
                ref: 'attrs/properties/' + ZxPowerstore.KEY_HSM_SCHEDULED_TIME,
                width: 100,
                label: zxMsg('LBL_HSM_Policy_application_scheduled_for') + ': ',
                choices: ZxUtils.HOURS,
                bmolsnr: true,
                enableDisableChangeEventSources: ['attrs/properties/' + ZxPowerstore.KEY_HSM_MOVE_SCHEDULING_ENABLED],
                enableDisableChecks: [function() {
                  return this.getInstanceValue('attrs/properties/' + ZxPowerstore.KEY_HSM_MOVE_SCHEDULING_ENABLED) === true;
                }]
              }
            ]
          },
          {
            type: _GROUP_,
            numCols: 1,
            colSizes: ['*'],
            cssStyle: 'margin-top: 10px; margin-left: 5px; margin-right: 5px;',
            tableCssStyle:'width:100%',
            items: [
              {
                type: _DWT_LIST_,
                id: 'hsmList',
                ref: 'attrs/' + ZxPowerstore.KEY_HSM_LIST,
                cssClass: 'DLSource hsmList',
                width: '99%',
                height: 150,
                emptyText: zxMsg('MSG_HSM_No_policy_defined'),
                multiSelect: false,
                widgetClass: ZxPowerstoreHSMListView,
                headerList: ZxPowerstoreHSMListView.getHeaderList()
              },
              {
                type: _GROUP_,
                numCols: 3,
                colSizes: ['*', '*', '*'],
                cssStyle: 'margin-top: 10px; margin-bottom: 10px',
                items: [
                  {
                    type: _DWT_BUTTON_,
                    label: ZaMsg.NAD_Add,
                    icon: 'Add',
                    onActivate: function(ev) {
                      ZxPowerstoreHSMListView.doAddModifyRow(ev, 'hsmList', true);
                    }
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: ZaMsg.TBB_Edit,
                    icon: 'Edit',
                    cssStyle: 'margin-left: 10px',
                    onActivate: function(ev) {
                      ZxPowerstoreHSMListView.doAddModifyRow(ev, 'hsmList', false);
                    }
                  },
                  {
                    type: _DWT_BUTTON_,
                    label: ZaMsg.TBB_Delete,
                    icon: 'Delete',
                    cssStyle: 'margin-left: 10px',
                    onActivate: function(ev) {
                      ZxPowerstoreHSMListView.doDeleteRow(ev, 'hsmList');
                    },
                    enableDisableChecks: [function() {
                      if (this.getInstanceValue('attrs/' + ZxPowerstore.KEY_HSM_LIST).length !== 1)
                        return true;
                      else
                        return this.getInstanceValue('attrs/' + ZxPowerstore.KEY_HSM_LIST)[0][0] !== "message,document:before:-30days";
                    }]
                  }
                ]
              }
            ]
          }
        ]
      },
      {
        type: _TOP_GROUPER_,
        label: zxMsg('LBL_HSM_cache_settings'),
        numCols: 1,
        colSizes: ['100%'],
//        tableCssStyle: 'width:100%;overflow:auto;padding-right:15px;padding-left:15px;',
        items: [
          {
            type: _GROUP_,
            numCols: 2,
            colSizes: [250, '*'],
            items: [
              {
                type: _TEXTFIELD_,
                ref: 'attrs/' + ZxPowerstore.KEY_CACHE_PATH,
                bmolsnr: true,
                label: zxMsg('LBL_HSM_cache_path') + ': ',
                labelLocation: _LEFT_,
                width: 200
              },
              {
                type: _TEXTFIELD_,
                ref: 'attrs/' + ZxPowerstore.KEY_CACHE_SIZE,
                bmolsnr: true,
                label: zxMsg('LBL_HSM_cache_size') + ': ',
                labelLocation: _LEFT_,
                width: 120
              }
            ]
          }
        ]
      }
    ]
  }
];
