/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxDeleteHSMDialog(parent, item, policy) {
  if (arguments.length === 0) {
    return;
  }

  this._item = item;
  this._policy = policy;
  this._controller = parent;
  DwtMessageDialog.call(
    this,
    {
      buttons: [DwtDialog.YES_BUTTON, DwtDialog.NO_BUTTON],
      parent: parent
    }
  );
  this.setMessage(
    zxMsg('MSG_LBL_Confirm_policy_delete', [policy]),
    DwtMessageDialog.WARNING_STYLE,
    ZxUtils.getTitleWithIcon('ZxPowerstore', zxMsg('LBL_HSM_Confirm_policy_delete'))
  );

  this.registerCallback(
    DwtDialog.YES_BUTTON,
    new AjxCallback(
      this,
      function() {
        this.setButtonEnabled(DwtDialog.YES_BUTTON, false);
        this.setButtonEnabled(DwtDialog.NO_BUTTON, false);

        ZxAdminRequest.sendRequest(
          item.getCurrentServer(),
          'ZxPowerstore',
          'removeHSMPolicy',
          {
            hsmPolicy: this._policy
          }
        ).then(AjxCallback.simpleClosure(
          function(controller, dialog, resp) {
            this.fireLoadMethods();
            dialog.popdown();
            controller.popupMsgDialog(resp.response.message);
          },
          this._item,
          this._controller,
          this
        ),
        AjxCallback.simpleClosure(
          function(ex) {
            this.popdown();
            ZxUtils.catchError(ex);
          },
          this
        ));
      },
      []
    )
  );

  this._helpURL = ZxLinks.HELP_HSM_Dialog_AddModify_HSM;
}

ZxDeleteHSMDialog.prototype = new DwtMessageDialog();
ZxDeleteHSMDialog.prototype.constructor = ZxDeleteHSMDialog;
