/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxStartDeduplicateVolumeDialog(parent, item, volumeId, volumeName) {
  if (arguments.length === 0) {
    return;
  }

  this._controller = parent;
  this._volumeId = volumeId;
  this._volumeName = volumeName;
  DwtMessageDialog.call(
    this,
    {
      buttons: [DwtDialog.YES_BUTTON, DwtDialog.NO_BUTTON],
      parent: parent
    }
  );
  this.setMessage(
    zxMsg('MSG_HSM_Confirm_start_deduplicate', [volumeName]),
    DwtMessageDialog.WARNING_STYLE,
    ZxUtils.getTitleWithIcon('ZxPowerstore', zxMsg('LBL_HSM_Confirm_start_deduplicate', [volumeName]))
  );

  this.registerCallback(
    DwtDialog.YES_BUTTON,
    new AjxCallback(
      this,
      function() {
        this.setButtonEnabled(DwtDialog.YES_BUTTON, false);
        this.setButtonEnabled(DwtDialog.NO_BUTTON, false);

        ZxAdminRequest.sendRequest(
          item.getCurrentServer(),
          'ZxPowerstore',
          'doDeduplicate',
          {
            volumeNameList: [this._volumeName],
            dryrun: false
          }
        ).then(AjxCallback.simpleClosure(
            function(dialog, resp) {
              dialog.popdown();
              ZeXtras.getOperationsManager().requestUpdate();
            },
            this._controller,
            this
          ),
          AjxCallback.simpleClosure(
            function(ex) {
              this.popdown();
              ZxUtils.catchError(ex);
            },
            this
          ));
      },
      []
    )
  );

  //this._helpURL = ZxLinks.HELP_HSM_Dialog_AddModify_HSM;
}

ZxStartDeduplicateVolumeDialog.prototype = new DwtMessageDialog();
ZxStartDeduplicateVolumeDialog.prototype.constructor = ZxStartDeduplicateVolumeDialog;
