/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxHSMCheckboxWidget() {}

ZxHSMCheckboxWidget.TYPE_MESSAGE = 5;
ZxHSMCheckboxWidget.TYPE_DOCUMENT = 8;
ZxHSMCheckboxWidget.TYPE_TASK = 15;
ZxHSMCheckboxWidget.TYPE_APPOINTMENT = 11;
ZxHSMCheckboxWidget.TYPE_CONTACT = 6;
ZxHSMCheckboxWidget.TYPE_CHAT = 16;

XFormItemFactory.createItemType('_ZE_HSM_CHECKBOX_', 'zx_hsm_checkbox', ZxHSMCheckboxWidget, Checkbox_XFormItem);

ZxHSMCheckboxWidget.prototype.getDisplayValue = function (value) {
  var type = this.getInheritedProperty('cbType');
  return (ZxUtils.indexOf(value, type) >= 0);
};

ZxHSMCheckboxWidget.prototype.elementChanged = function(value, instanceValue, event) {
  var type = this.getInheritedProperty('cbType');
  if (value) {
    instanceValue = instanceValue.concat(type);
  } else {
    instanceValue = (function() {
      var i, len, results, val;
      results = [];
      for (i = 0, len = instanceValue.length; i < len; i++) {
        val = instanceValue[i];
        if (val !== type) {
          results.push(val);
        }
      }
      return results;
    })();
  }
  this.getForm().itemChanged(this.getParentItem(), instanceValue, event);
};
