/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxHSMTypesGroupWidget() {}

XFormItemFactory.createItemType('_ZE_HSM_TYPES_', 'zx_hsm_group', ZxHSMTypesGroupWidget, Composite_XFormItem);

ZxHSMTypesGroupWidget.prototype.initializeItems = function() {
  this.items = [
    {
      type: _GROUP_,
      ref: '.',
      numCols: 2,
      colSizes: ['*', '*'],
      isTabGroup: true,
      items: [
        {
          type: _ZE_HSM_CHECKBOX_,
          ref: '.',
          valign: _MIDDLE_,
          label: '<table><tbody><tr><td width="20px"><div class="ImgZXMail"></div></td><td>' + zxMsg("LBL_Emails") + '</td></tr></tbody></table>',
          cbType: ZxHSMCheckboxWidget.TYPE_MESSAGE,
          labelLocation: _RIGHT_,
          forceUpdate: true,
          bmolsnr: true
        },
        {
          type: _ZE_HSM_CHECKBOX_,
          ref: '.',
          valign: _MIDDLE_,
          label: '<table><tbody><tr><td width="20px"><div class="ImgZXDocuments"></div></td><td>' + zxMsg("LBL_Documents") + '</td></tr></tbody></table>',
          cbType: ZxHSMCheckboxWidget.TYPE_DOCUMENT,
          labelLocation: _RIGHT_,
          forceUpdate: true,
          bmolsnr: true
        },
        {
          type: _ZE_HSM_CHECKBOX_,
          ref: '.',
          valign: _MIDDLE_,
          label: '<table><tbody><tr><td width="20px"><div class="ImgZXTask"></div></td><td>' + zxMsg("LBL_Tasks") + '</td></tr></tbody></table>',
          cbType: ZxHSMCheckboxWidget.TYPE_TASK,
          labelLocation: _RIGHT_,
          forceUpdate: true,
          bmolsnr: true
        },
        {
          type: _ZE_HSM_CHECKBOX_,
          ref: '.',
          valign: _MIDDLE_,
          label: '<table><tbody><tr><td width="20px"><div class="ImgZXCalendar"></div></td><td>' + zxMsg("LBL_Appointments") + '</td></tr></tbody></table>',
          cbType: ZxHSMCheckboxWidget.TYPE_APPOINTMENT,
          labelLocation: _RIGHT_,
          forceUpdate: true,
          bmolsnr: true
        },
        {
          type: _ZE_HSM_CHECKBOX_,
          ref: '.',
          valign: _MIDDLE_,
          label: '<table><tbody><tr><td width="20px"><div class="ImgZXContact"></div></td><td>' + zxMsg("LBL_Contacts") + '</td></tr></tbody></table>',
          cbType: ZxHSMCheckboxWidget.TYPE_CONTACT,
          labelLocation: _RIGHT_,
          forceUpdate: true,
          bmolsnr: true
        },
        {
          type: _ZE_HSM_CHECKBOX_,
          ref: '.',
          valign: _MIDDLE_,
          label: '<table><tbody><tr><td width="20px"><div class="ImgZXChatfolder"></div></td><td>' + zxMsg("LBL_Chats") + '</td></tr></tbody></table>',
          cbType: ZxHSMCheckboxWidget.TYPE_CHAT,
          labelLocation: _RIGHT_,
          forceUpdate: true,
          bmolsnr: true
        }
      ]
    }
  ];

  Composite_XFormItem.prototype.initializeItems.call(this);
};
