/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */
function ZxAlert_XFormItem(params) {
  if (!params) { return; }
  Group_XFormItem.call(this, params);
}
ZxAlert_XFormItem.prototype = new Group_XFormItem();
ZxAlert_XFormItem.prototype.constructor = ZxAlert_XFormItem;
XFormItemFactory.createItemType('_ZX_ALERT_', 'zx_alert', ZxAlert_XFormItem, ZxAlert_XFormItem);

ZxAlert_XFormItem.prototype._setAttributes = function(params) {
  var alertIcon = 'ImgCritical_32',
    alertStyle = 'DwtAlertCrit',
    baseXForm;

  if (typeof params.style === 'number') {
    switch (params.style) {
    case DwtAlert.INFORMATION:
      alertIcon = 'ImgInformation_32';
      alertStyle = 'DwtAlertInfo';
      break;
    case DwtAlert.WARNING:
      alertIcon = 'ImgWarning_32';
      alertStyle = 'DwtAlertWarn';
      break;
    case DwtAlert.CRITICAL:
      alertIcon = 'ImgCritical_32';
      alertStyle = 'DwtAlertCrit';
      break;
    default:
      alertIcon = 'ImgCritical_32';
      alertStyle = 'DwtAlertCrit';
    }
    //delete params.style;
  }

  params.colSizes = params.colSizes || ['*'];
  params.numCols = params.numCols || 1;
  if (params.items[0] && !params.items[0].isIcon) {
    params.colSizes.splice(0, 0, 37);
    params.numCols += 1;
    params.items.splice(0, 0, {
      type: _OUTPUT_,
      width: 37,
      cssClass: alertIcon,
      cssStyle: 'margin-right: 5px; display: block;',
      isIcon: true
    });
  }
  params.cssClass = 'DwtAlert ' + alertStyle;
  params.colSpan = '*';
  this.__attributes = params;
};
