/*
 * ***** BEGIN LICENSE BLOCK *****
 * Copyright (C) 2011-2016 ZeXtras
 *
 * The contents of this file are subject to the ZeXtras EULA;
 * you may not use this file except in compliance with the EULA.
 * You may obtain a copy of the EULA at
 * http://www.zextras.com/zextras-eula.html
 * ***** END LICENSE BLOCK *****
 */

function ZxDateTimeWidget() {
  this.numCols = 2;
  this.useParentTable = false;
  this.cssClass = 'xform_dwt_datetime';
}

XFormItemFactory.createItemType('_ZX_DATETIME_', 'zextras_datetime_widget',
  ZxDateTimeWidget, Composite_XFormItem);

ZxDateTimeWidget.prototype.items = [
  {
    type: _DWT_DATE_,
    ref: '.',
    errorLocation: _PARENT_,
    label: zxMsg('LBL_Date') + ': ',
    elementChanged: function(newDate, currentDate, event) {
      currentDate = currentDate || new Date();
      newDate.setHours(currentDate.getHours(), currentDate.getMinutes(), currentDate.getSeconds(), 0);
      this.updateWidget(newDate);
      var elementChangedMethod = this.getParentItem().getElementChangedMethod();
      if (elementChangedMethod) {
        elementChangedMethod.call(this.getParentItem(), newDate, currentDate, event);
      }
    },
    labelLocation: _LEFT_
  },
  { type: _SPACER_, height: 2 },
  {
    type: _ZX_TIME_,
    ref: '.',
    labelLocation: _NONE_,
    errorLocation: _PARENT_,
    elementChanged: function(newDate, currentDate, event) {
      currentDate = currentDate || new Date();
      var elementChangedMethod = this.getParentItem().getElementChangedMethod();
      if (elementChangedMethod) {
        elementChangedMethod.call(this.getParentItem(), newDate, currentDate, event);
      }
    }
  }
];
